// Auto generated bindings from the xcb headers
package xcb

import ctypes "core:c"

iterator_t :: struct($T: typeid){
	data: [^]T,
	rem: i32,
	index: i32,
}

iovec :: struct{
	iov_base: rawptr,
	iov_len: int,
}

connection_t :: struct {}
special_event_t :: struct {}
extension_t :: struct {}

generic_iterator_t :: struct{
	data:  rawptr,
	rem:   ctypes.int,
	index: ctypes.int,
}

generic_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
}

generic_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	pad:           [7]u32,
	full_sequence: u32,
}

raw_generic_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	pad:           [7]u32,
}

ge_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	pad1:          u16,
	pad:           [5]u32,
	full_sequence: u32,
}

generic_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	resource_id:   u32,
	minor_code:    u16,
	major_code:    u8,
	pad0:          u8,
	pad:           [5]u32,
	full_sequence: u32,
}

void_cookie_t :: struct{
	sequence: ctypes.uint,
}

protocol_request_t :: struct{
	count:  int,
	ext:    ^extension_t,
	opcode: u8,
	isvoid: u8,
}

big_requests_enable_cookie_t :: struct{
	sequence: ctypes.uint,
}

big_requests_enable_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

big_requests_enable_reply_t :: struct{
	response_type:          u8,
	pad0:                   u8,
	sequence:               u16,
	length:                 u32,
	maximum_request_length: u32,
}

composite_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

composite_query_version_request_t :: struct{
	major_opcode:         u8,
	minor_opcode:         u8,
	length:               u16,
	client_major_version: u32,
	client_minor_version: u32,
}

composite_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u32,
	minor_version: u32,
	pad1:          [16]u8,
}

composite_redirect_window_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	update:       u8,
	pad0:         [3]u8,
}

composite_redirect_subwindows_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	update:       u8,
	pad0:         [3]u8,
}

composite_unredirect_window_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	update:       u8,
	pad0:         [3]u8,
}

composite_unredirect_subwindows_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	update:       u8,
	pad0:         [3]u8,
}

composite_create_region_from_border_clip_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	region:       xfixes_region_t,
	window:       window_t,
}

composite_name_window_pixmap_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	pixmap:       pixmap_t,
}

composite_get_overlay_window_cookie_t :: struct{
	sequence: ctypes.uint,
}

composite_get_overlay_window_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

composite_get_overlay_window_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	overlay_win:   window_t,
	pad1:          [20]u8,
}

composite_release_overlay_window_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

damage_bad_damage_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

damage_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

damage_query_version_request_t :: struct{
	major_opcode:         u8,
	minor_opcode:         u8,
	length:               u16,
	client_major_version: u32,
	client_minor_version: u32,
}

damage_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u32,
	minor_version: u32,
	pad1:          [16]u8,
}

damage_create_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	damage:       damage_damage_t,
	drawable:     drawable_t,
	level:        u8,
	pad0:         [3]u8,
}

damage_destroy_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	damage:       damage_damage_t,
}

damage_subtract_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	damage:       damage_damage_t,
	repair:       xfixes_region_t,
	parts:        xfixes_region_t,
}

damage_add_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
	region:       xfixes_region_t,
}

damage_notify_event_t :: struct{
	response_type: u8,
	level:         u8,
	sequence:      u16,
	drawable:      drawable_t,
	damage:        damage_damage_t,
	timestamp:     timestamp_t,
	area:          rectangle_t,
	geometry:      rectangle_t,
}

dpms_get_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

dpms_get_version_request_t :: struct{
	major_opcode:         u8,
	minor_opcode:         u8,
	length:               u16,
	client_major_version: u16,
	client_minor_version: u16,
}

dpms_get_version_reply_t :: struct{
	response_type:        u8,
	pad0:                 u8,
	sequence:             u16,
	length:               u32,
	server_major_version: u16,
	server_minor_version: u16,
}

dpms_capable_cookie_t :: struct{
	sequence: ctypes.uint,
}

dpms_capable_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

dpms_capable_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	capable:       u8,
	pad1:          [23]u8,
}

dpms_get_timeouts_cookie_t :: struct{
	sequence: ctypes.uint,
}

dpms_get_timeouts_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

dpms_get_timeouts_reply_t :: struct{
	response_type:   u8,
	pad0:            u8,
	sequence:        u16,
	length:          u32,
	standby_timeout: u16,
	suspend_timeout: u16,
	off_timeout:     u16,
	pad1:            [18]u8,
}

dpms_set_timeouts_request_t :: struct{
	major_opcode:    u8,
	minor_opcode:    u8,
	length:          u16,
	standby_timeout: u16,
	suspend_timeout: u16,
	off_timeout:     u16,
}

dpms_enable_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

dpms_disable_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

dpms_force_level_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	power_level:  u16,
}

dpms_info_cookie_t :: struct{
	sequence: ctypes.uint,
}

dpms_info_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

dpms_info_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	power_level:   u16,
	state:         u8,
	pad1:          [21]u8,
}

dri2_dri2_buffer_t :: struct{
	attachment: u32,
	name:       u32,
	pitch:      u32,
	cpp:        u32,
	flags:      u32,
}

dri2_attach_format_t :: struct{
	attachment: u32,
	format:     u32,
}

dri2_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri2_query_version_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	major_version: u32,
	minor_version: u32,
}

dri2_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u32,
	minor_version: u32,
}

dri2_connect_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri2_connect_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	driver_type:  u32,
}

dri2_connect_reply_t :: struct{
	response_type:      u8,
	pad0:               u8,
	sequence:           u16,
	length:             u32,
	driver_name_length: u32,
	device_name_length: u32,
	pad1:               [16]u8,
}

dri2_authenticate_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri2_authenticate_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	magic:        u32,
}

dri2_authenticate_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	authenticated: u32,
}

dri2_create_drawable_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
}

dri2_destroy_drawable_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
}

dri2_get_buffers_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri2_get_buffers_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
	count:        u32,
}

dri2_get_buffers_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	width:         u32,
	height:        u32,
	count:         u32,
	pad1:          [12]u8,
}

dri2_copy_region_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri2_copy_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
	region:       u32,
	dest:         u32,
	src:          u32,
}

dri2_copy_region_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
}

dri2_get_buffers_with_format_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri2_get_buffers_with_format_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
	count:        u32,
}

dri2_get_buffers_with_format_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	width:         u32,
	height:        u32,
	count:         u32,
	pad1:          [12]u8,
}

dri2_swap_buffers_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri2_swap_buffers_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	drawable:      drawable_t,
	target_msc_hi: u32,
	target_msc_lo: u32,
	divisor_hi:    u32,
	divisor_lo:    u32,
	remainder_hi:  u32,
	remainder_lo:  u32,
}

dri2_swap_buffers_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	swap_hi:       u32,
	swap_lo:       u32,
}

dri2_get_msc_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri2_get_msc_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
}

dri2_get_msc_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	ust_hi:        u32,
	ust_lo:        u32,
	msc_hi:        u32,
	msc_lo:        u32,
	sbc_hi:        u32,
	sbc_lo:        u32,
}

dri2_wait_msc_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri2_wait_msc_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	drawable:      drawable_t,
	target_msc_hi: u32,
	target_msc_lo: u32,
	divisor_hi:    u32,
	divisor_lo:    u32,
	remainder_hi:  u32,
	remainder_lo:  u32,
}

dri2_wait_msc_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	ust_hi:        u32,
	ust_lo:        u32,
	msc_hi:        u32,
	msc_lo:        u32,
	sbc_hi:        u32,
	sbc_lo:        u32,
}

dri2_wait_sbc_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri2_wait_sbc_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	drawable:      drawable_t,
	target_sbc_hi: u32,
	target_sbc_lo: u32,
}

dri2_wait_sbc_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	ust_hi:        u32,
	ust_lo:        u32,
	msc_hi:        u32,
	msc_lo:        u32,
	sbc_hi:        u32,
	sbc_lo:        u32,
}

dri2_swap_interval_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
	interval:     u32,
}

dri2_get_param_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri2_get_param_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
	param:        u32,
}

dri2_get_param_reply_t :: struct{
	response_type:       u8,
	is_param_recognized: u8,
	sequence:            u16,
	length:              u32,
	value_hi:            u32,
	value_lo:            u32,
}

dri2_buffer_swap_complete_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	event_type:    u16,
	pad1:          [2]u8,
	drawable:      drawable_t,
	ust_hi:        u32,
	ust_lo:        u32,
	msc_hi:        u32,
	msc_lo:        u32,
	sbc:           u32,
}

dri2_invalidate_buffers_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	drawable:      drawable_t,
}

dri3_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri3_query_version_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	major_version: u32,
	minor_version: u32,
}

dri3_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u32,
	minor_version: u32,
}

dri3_open_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri3_open_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
	provider:     u32,
}

dri3_open_reply_t :: struct{
	response_type: u8,
	nfd:           u8,
	sequence:      u16,
	length:        u32,
	pad0:          [24]u8,
}

dri3_pixmap_from_buffer_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	pixmap:       pixmap_t,
	drawable:     drawable_t,
	size:         u32,
	width:        u16,
	height:       u16,
	stride:       u16,
	depth:        u8,
	bpp:          u8,
}

dri3_buffer_from_pixmap_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri3_buffer_from_pixmap_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	pixmap:       pixmap_t,
}

dri3_buffer_from_pixmap_reply_t :: struct{
	response_type: u8,
	nfd:           u8,
	sequence:      u16,
	length:        u32,
	size:          u32,
	width:         u16,
	height:        u16,
	stride:        u16,
	depth:         u8,
	bpp:           u8,
	pad0:          [12]u8,
}

dri3_fence_from_fd_request_t :: struct{
	major_opcode:        u8,
	minor_opcode:        u8,
	length:              u16,
	drawable:            drawable_t,
	fence:               u32,
	initially_triggered: u8,
	pad0:                [3]u8,
}

dri3_fd_from_fence_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri3_fd_from_fence_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
	fence:        u32,
}

dri3_fd_from_fence_reply_t :: struct{
	response_type: u8,
	nfd:           u8,
	sequence:      u16,
	length:        u32,
	pad0:          [24]u8,
}

dri3_get_supported_modifiers_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri3_get_supported_modifiers_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       u32,
	depth:        u8,
	bpp:          u8,
	pad0:         [2]u8,
}

dri3_get_supported_modifiers_reply_t :: struct{
	response_type:        u8,
	pad0:                 u8,
	sequence:             u16,
	length:               u32,
	num_window_modifiers: u32,
	num_screen_modifiers: u32,
	pad1:                 [16]u8,
}

dri3_pixmap_from_buffers_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	pixmap:       pixmap_t,
	window:       window_t,
	num_buffers:  u8,
	pad0:         [3]u8,
	width:        u16,
	height:       u16,
	stride0:      u32,
	offset0:      u32,
	stride1:      u32,
	offset1:      u32,
	stride2:      u32,
	offset2:      u32,
	stride3:      u32,
	offset3:      u32,
	depth:        u8,
	bpp:          u8,
	pad1:         [2]u8,
	modifier:     u64,
}

dri3_buffers_from_pixmap_cookie_t :: struct{
	sequence: ctypes.uint,
}

dri3_buffers_from_pixmap_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	pixmap:       pixmap_t,
}

dri3_buffers_from_pixmap_reply_t :: struct{
	response_type: u8,
	nfd:           u8,
	sequence:      u16,
	length:        u32,
	width:         u16,
	height:        u16,
	pad0:          [4]u8,
	modifier:      u64,
	depth:         u8,
	bpp:           u8,
	pad1:          [6]u8,
}

dri3_set_drm_device_in_use_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	drmMajor:     u32,
	drmMinor:     u32,
}

genericevent_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

genericevent_query_version_request_t :: struct{
	major_opcode:         u8,
	minor_opcode:         u8,
	length:               u16,
	client_major_version: u16,
	client_minor_version: u16,
}

genericevent_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u16,
	minor_version: u16,
	pad1:          [20]u8,
}

glx_generic_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
	pad0:          [21]u8,
}

glx_pbuffer_clobber_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	event_type:    u16,
	draw_type:     u16,
	drawable:      glx_drawable_t,
	b_mask:        u32,
	aux_buffer:    u16,
	x:             u16,
	y:             u16,
	width:         u16,
	height:        u16,
	count:         u16,
	pad1:          [4]u8,
}

glx_buffer_swap_complete_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	event_type:    u16,
	pad1:          [2]u8,
	drawable:      glx_drawable_t,
	ust_hi:        u32,
	ust_lo:        u32,
	msc_hi:        u32,
	msc_lo:        u32,
	sbc:           u32,
}

glx_render_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
}

glx_render_large_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	context_tag:   glx_context_tag_t,
	request_num:   u16,
	request_total: u16,
	data_len:      u32,
}

glx_create_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     glx_context_t,
	visual:       visualid_t,
	screen:       u32,
	share_list:   glx_context_t,
	is_direct:    u8,
	pad0:         [3]u8,
}

glx_destroy_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     glx_context_t,
}

glx_make_current_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_make_current_request_t :: struct{
	major_opcode:    u8,
	minor_opcode:    u8,
	length:          u16,
	drawable:        glx_drawable_t,
	context_:        glx_context_t,
	old_context_tag: glx_context_tag_t,
}

glx_make_current_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_tag:   glx_context_tag_t,
	pad1:          [20]u8,
}

glx_is_direct_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_is_direct_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     glx_context_t,
}

glx_is_direct_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	is_direct:     u8,
	pad1:          [23]u8,
}

glx_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_query_version_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	major_version: u32,
	minor_version: u32,
}

glx_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u32,
	minor_version: u32,
	pad1:          [16]u8,
}

glx_wait_gl_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
}

glx_wait_x_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
}

glx_copy_context_request_t :: struct{
	major_opcode:    u8,
	minor_opcode:    u8,
	length:          u16,
	src:             glx_context_t,
	dest:            glx_context_t,
	mask:            u32,
	src_context_tag: glx_context_tag_t,
}

glx_swap_buffers_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	drawable:     glx_drawable_t,
}

glx_use_x_font_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	font:         font_t,
	first:        u32,
	count:        u32,
	list_base:    u32,
}

glx_create_glx_pixmap_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
	visual:       visualid_t,
	pixmap:       pixmap_t,
	glx_pixmap:   glx_pixmap_t,
}

glx_get_visual_configs_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_visual_configs_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
}

glx_get_visual_configs_reply_t :: struct{
	response_type:  u8,
	pad0:           u8,
	sequence:       u16,
	length:         u32,
	num_visuals:    u32,
	num_properties: u32,
	pad1:           [16]u8,
}

glx_destroy_glx_pixmap_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	glx_pixmap:   glx_pixmap_t,
}

glx_vendor_private_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	vendor_code:  u32,
	context_tag:  glx_context_tag_t,
}

glx_vendor_private_with_reply_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_vendor_private_with_reply_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	vendor_code:  u32,
	context_tag:  glx_context_tag_t,
}

glx_vendor_private_with_reply_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	retval:        u32,
	data1:         [24]u8,
}

glx_query_extensions_string_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_query_extensions_string_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
}

glx_query_extensions_string_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	pad2:          [16]u8,
}

glx_query_server_string_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_query_server_string_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
	name:         u32,
}

glx_query_server_string_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	str_len:       u32,
	pad2:          [16]u8,
}

glx_client_info_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	major_version: u32,
	minor_version: u32,
	str_len:       u32,
}

glx_get_fb_configs_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_fb_configs_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
}

glx_get_fb_configs_reply_t :: struct{
	response_type:  u8,
	pad0:           u8,
	sequence:       u16,
	length:         u32,
	num_FB_configs: u32,
	num_properties: u32,
	pad1:           [16]u8,
}

glx_create_pixmap_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
	fbconfig:     glx_fbconfig_t,
	pixmap:       pixmap_t,
	glx_pixmap:   glx_pixmap_t,
	num_attribs:  u32,
}

glx_destroy_pixmap_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	glx_pixmap:   glx_pixmap_t,
}

glx_create_new_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     glx_context_t,
	fbconfig:     glx_fbconfig_t,
	screen:       u32,
	render_type:  u32,
	share_list:   glx_context_t,
	is_direct:    u8,
	pad0:         [3]u8,
}

glx_query_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_query_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     glx_context_t,
}

glx_query_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_attribs:   u32,
	pad1:          [20]u8,
}

glx_make_context_current_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_make_context_current_request_t :: struct{
	major_opcode:    u8,
	minor_opcode:    u8,
	length:          u16,
	old_context_tag: glx_context_tag_t,
	drawable:        glx_drawable_t,
	read_drawable:   glx_drawable_t,
	context_:        glx_context_t,
}

glx_make_context_current_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_tag:   glx_context_tag_t,
	pad1:          [20]u8,
}

glx_create_pbuffer_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
	fbconfig:     glx_fbconfig_t,
	pbuffer:      glx_pbuffer_t,
	num_attribs:  u32,
}

glx_destroy_pbuffer_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	pbuffer:      glx_pbuffer_t,
}

glx_get_drawable_attributes_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_drawable_attributes_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     glx_drawable_t,
}

glx_get_drawable_attributes_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_attribs:   u32,
	pad1:          [20]u8,
}

glx_change_drawable_attributes_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     glx_drawable_t,
	num_attribs:  u32,
}

glx_create_window_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
	fbconfig:     glx_fbconfig_t,
	window:       window_t,
	glx_window:   glx_window_t,
	num_attribs:  u32,
}

glx_delete_window_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	glxwindow:    glx_window_t,
}

glx_set_client_info_arb_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	major_version: u32,
	minor_version: u32,
	num_versions:  u32,
	gl_str_len:    u32,
	glx_str_len:   u32,
}

glx_create_context_attribs_arb_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     glx_context_t,
	fbconfig:     glx_fbconfig_t,
	screen:       u32,
	share_list:   glx_context_t,
	is_direct:    u8,
	pad0:         [3]u8,
	num_attribs:  u32,
}

glx_set_client_info_2arb_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	major_version: u32,
	minor_version: u32,
	num_versions:  u32,
	gl_str_len:    u32,
	glx_str_len:   u32,
}

glx_new_list_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	list:         u32,
	mode:         u32,
}

glx_end_list_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
}

glx_delete_lists_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	list:         u32,
	range:        i32,
}

glx_gen_lists_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_gen_lists_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	range:        i32,
}

glx_gen_lists_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	ret_val:       u32,
}

glx_feedback_buffer_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	size:         i32,
	type:         i32,
}

glx_select_buffer_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	size:         i32,
}

glx_render_mode_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_render_mode_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	mode:         u32,
}

glx_render_mode_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	ret_val:       u32,
	n:             u32,
	new_mode:      u32,
	pad1:          [12]u8,
}

glx_finish_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_finish_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
}

glx_finish_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
}

glx_pixel_storef_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	pname:        u32,
	datum:        glx_float32_t,
}

glx_pixel_storei_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	pname:        u32,
	datum:        i32,
}

glx_read_pixels_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_read_pixels_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	x:            i32,
	y:            i32,
	width:        i32,
	height:       i32,
	format:       u32,
	type:         u32,
	swap_bytes:   u8,
	lsb_first:    u8,
}

glx_read_pixels_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [24]u8,
}

glx_get_booleanv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_booleanv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	pname:        i32,
}

glx_get_booleanv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         u8,
	pad2:          [15]u8,
}

glx_get_clip_plane_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_clip_plane_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	plane:        i32,
}

glx_get_clip_plane_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [24]u8,
}

glx_get_doublev_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_doublev_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	pname:        u32,
}

glx_get_doublev_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float64_t,
	pad2:          [8]u8,
}

glx_get_error_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_error_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
}

glx_get_error_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	error:         i32,
}

glx_get_floatv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_floatv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	pname:        u32,
}

glx_get_floatv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float32_t,
	pad2:          [12]u8,
}

glx_get_integerv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_integerv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	pname:        u32,
}

glx_get_integerv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         i32,
	pad2:          [12]u8,
}

glx_get_lightfv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_lightfv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	light:        u32,
	pname:        u32,
}

glx_get_lightfv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float32_t,
	pad2:          [12]u8,
}

glx_get_lightiv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_lightiv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	light:        u32,
	pname:        u32,
}

glx_get_lightiv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         i32,
	pad2:          [12]u8,
}

glx_get_mapdv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_mapdv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	query:        u32,
}

glx_get_mapdv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float64_t,
	pad2:          [8]u8,
}

glx_get_mapfv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_mapfv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	query:        u32,
}

glx_get_mapfv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float32_t,
	pad2:          [12]u8,
}

glx_get_mapiv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_mapiv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	query:        u32,
}

glx_get_mapiv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         i32,
	pad2:          [12]u8,
}

glx_get_materialfv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_materialfv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	face:         u32,
	pname:        u32,
}

glx_get_materialfv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float32_t,
	pad2:          [12]u8,
}

glx_get_materialiv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_materialiv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	face:         u32,
	pname:        u32,
}

glx_get_materialiv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         i32,
	pad2:          [12]u8,
}

glx_get_pixel_mapfv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_pixel_mapfv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	map_:         u32,
}

glx_get_pixel_mapfv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float32_t,
	pad2:          [12]u8,
}

glx_get_pixel_mapuiv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_pixel_mapuiv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	map_:         u32,
}

glx_get_pixel_mapuiv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         u32,
	pad2:          [12]u8,
}

glx_get_pixel_mapusv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_pixel_mapusv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	map_:         u32,
}

glx_get_pixel_mapusv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         u16,
	pad2:          [16]u8,
}

glx_get_polygon_stipple_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_polygon_stipple_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	lsb_first:    u8,
}

glx_get_polygon_stipple_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [24]u8,
}

glx_get_string_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_string_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	name:         u32,
}

glx_get_string_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	pad2:          [16]u8,
}

glx_get_tex_envfv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_tex_envfv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	pname:        u32,
}

glx_get_tex_envfv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float32_t,
	pad2:          [12]u8,
}

glx_get_tex_enviv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_tex_enviv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	pname:        u32,
}

glx_get_tex_enviv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         i32,
	pad2:          [12]u8,
}

glx_get_tex_gendv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_tex_gendv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	coord:        u32,
	pname:        u32,
}

glx_get_tex_gendv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float64_t,
	pad2:          [8]u8,
}

glx_get_tex_genfv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_tex_genfv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	coord:        u32,
	pname:        u32,
}

glx_get_tex_genfv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float32_t,
	pad2:          [12]u8,
}

glx_get_tex_geniv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_tex_geniv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	coord:        u32,
	pname:        u32,
}

glx_get_tex_geniv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         i32,
	pad2:          [12]u8,
}

glx_get_tex_image_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_tex_image_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	level:        i32,
	format:       u32,
	type:         u32,
	swap_bytes:   u8,
}

glx_get_tex_image_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [8]u8,
	width:         i32,
	height:        i32,
	depth:         i32,
	pad2:          [4]u8,
}

glx_get_tex_parameterfv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_tex_parameterfv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	pname:        u32,
}

glx_get_tex_parameterfv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float32_t,
	pad2:          [12]u8,
}

glx_get_tex_parameteriv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_tex_parameteriv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	pname:        u32,
}

glx_get_tex_parameteriv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         i32,
	pad2:          [12]u8,
}

glx_get_tex_level_parameterfv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_tex_level_parameterfv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	level:        i32,
	pname:        u32,
}

glx_get_tex_level_parameterfv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float32_t,
	pad2:          [12]u8,
}

glx_get_tex_level_parameteriv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_tex_level_parameteriv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	level:        i32,
	pname:        u32,
}

glx_get_tex_level_parameteriv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         i32,
	pad2:          [12]u8,
}

glx_is_enabled_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_is_enabled_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	capability:   u32,
}

glx_is_enabled_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	ret_val:       glx_bool32_t,
}

glx_is_list_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_is_list_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	list:         u32,
}

glx_is_list_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	ret_val:       glx_bool32_t,
}

glx_flush_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
}

glx_are_textures_resident_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_are_textures_resident_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	n:            i32,
}

glx_are_textures_resident_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	ret_val:       glx_bool32_t,
	pad1:          [20]u8,
}

glx_delete_textures_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	n:            i32,
}

glx_gen_textures_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_gen_textures_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	n:            i32,
}

glx_gen_textures_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [24]u8,
}

glx_is_texture_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_is_texture_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	texture:      u32,
}

glx_is_texture_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	ret_val:       glx_bool32_t,
}

glx_get_color_table_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_color_table_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	format:       u32,
	type:         u32,
	swap_bytes:   u8,
}

glx_get_color_table_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [8]u8,
	width:         i32,
	pad2:          [12]u8,
}

glx_get_color_table_parameterfv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_color_table_parameterfv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	pname:        u32,
}

glx_get_color_table_parameterfv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float32_t,
	pad2:          [12]u8,
}

glx_get_color_table_parameteriv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_color_table_parameteriv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	pname:        u32,
}

glx_get_color_table_parameteriv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         i32,
	pad2:          [12]u8,
}

glx_get_convolution_filter_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_convolution_filter_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	format:       u32,
	type:         u32,
	swap_bytes:   u8,
}

glx_get_convolution_filter_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [8]u8,
	width:         i32,
	height:        i32,
	pad2:          [8]u8,
}

glx_get_convolution_parameterfv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_convolution_parameterfv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	pname:        u32,
}

glx_get_convolution_parameterfv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float32_t,
	pad2:          [12]u8,
}

glx_get_convolution_parameteriv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_convolution_parameteriv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	pname:        u32,
}

glx_get_convolution_parameteriv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         i32,
	pad2:          [12]u8,
}

glx_get_separable_filter_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_separable_filter_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	format:       u32,
	type:         u32,
	swap_bytes:   u8,
}

glx_get_separable_filter_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [8]u8,
	row_w:         i32,
	col_h:         i32,
	pad2:          [8]u8,
}

glx_get_histogram_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_histogram_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	format:       u32,
	type:         u32,
	swap_bytes:   u8,
	reset:        u8,
}

glx_get_histogram_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [8]u8,
	width:         i32,
	pad2:          [12]u8,
}

glx_get_histogram_parameterfv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_histogram_parameterfv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	pname:        u32,
}

glx_get_histogram_parameterfv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float32_t,
	pad2:          [12]u8,
}

glx_get_histogram_parameteriv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_histogram_parameteriv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	pname:        u32,
}

glx_get_histogram_parameteriv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         i32,
	pad2:          [12]u8,
}

glx_get_minmax_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_minmax_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	format:       u32,
	type:         u32,
	swap_bytes:   u8,
	reset:        u8,
}

glx_get_minmax_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [24]u8,
}

glx_get_minmax_parameterfv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_minmax_parameterfv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	pname:        u32,
}

glx_get_minmax_parameterfv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         glx_float32_t,
	pad2:          [12]u8,
}

glx_get_minmax_parameteriv_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_minmax_parameteriv_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	pname:        u32,
}

glx_get_minmax_parameteriv_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         i32,
	pad2:          [12]u8,
}

glx_get_compressed_tex_image_arb_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_compressed_tex_image_arb_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	level:        i32,
}

glx_get_compressed_tex_image_arb_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [8]u8,
	size:          i32,
	pad2:          [12]u8,
}

glx_delete_queries_arb_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	n:            i32,
}

glx_gen_queries_arb_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_gen_queries_arb_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	n:            i32,
}

glx_gen_queries_arb_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [24]u8,
}

glx_is_query_arb_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_is_query_arb_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	id:           u32,
}

glx_is_query_arb_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	ret_val:       glx_bool32_t,
}

glx_get_queryiv_arb_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_queryiv_arb_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	target:       u32,
	pname:        u32,
}

glx_get_queryiv_arb_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         i32,
	pad2:          [12]u8,
}

glx_get_query_objectiv_arb_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_query_objectiv_arb_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	id:           u32,
	pname:        u32,
}

glx_get_query_objectiv_arb_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         i32,
	pad2:          [12]u8,
}

glx_get_query_objectuiv_arb_cookie_t :: struct{
	sequence: ctypes.uint,
}

glx_get_query_objectuiv_arb_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_tag:  glx_context_tag_t,
	id:           u32,
	pname:        u32,
}

glx_get_query_objectuiv_arb_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [4]u8,
	n:             u32,
	datum:         u32,
	pad2:          [12]u8,
}

present_notify_t :: struct{
	window: window_t,
	serial: u32,
}

present_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

present_query_version_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	major_version: u32,
	minor_version: u32,
}

present_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u32,
	minor_version: u32,
}

present_pixmap_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	pixmap:       pixmap_t,
	serial:       u32,
	valid:        xfixes_region_t,
	update:       xfixes_region_t,
	x_off:        i16,
	y_off:        i16,
	target_crtc:  randr_crtc_t,
	wait_fence:   sync_fence_t,
	idle_fence:   sync_fence_t,
	options:      u32,
	pad0:         [4]u8,
	target_msc:   u64,
	divisor:      u64,
	remainder:    u64,
}

present_notify_msc_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	serial:       u32,
	pad0:         [4]u8,
	target_msc:   u64,
	divisor:      u64,
	remainder:    u64,
}

present_select_input_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	eid:          present_event_t,
	window:       window_t,
	event_mask:   u32,
}

present_query_capabilities_cookie_t :: struct{
	sequence: ctypes.uint,
}

present_query_capabilities_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	target:       u32,
}

present_query_capabilities_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	capabilities:  u32,
}

present_generic_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	evtype:        u16,
	pad0:          [2]u8,
	event:         present_event_t,
}

present_configure_notify_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	pad0:          [2]u8,
	event:         present_event_t,
	window:        window_t,
	x:             i16,
	y:             i16,
	width:         u16,
	height:        u16,
	off_x:         i16,
	off_y:         i16,
	full_sequence: u32,
	pixmap_width:  u16,
	pixmap_height: u16,
	pixmap_flags:  u32,
}

present_complete_notify_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	kind:          u8,
	mode:          u8,
	event:         present_event_t,
	window:        window_t,
	serial:        u32,
	ust:           u64,
	full_sequence: u32,
	msc:           u64,
}

present_idle_notify_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	pad0:          [2]u8,
	event:         present_event_t,
	window:        window_t,
	serial:        u32,
	pixmap:        pixmap_t,
	idle_fence:    sync_fence_t,
	full_sequence: u32,
}

present_redirect_notify_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	update_window: u8,
	pad0:          u8,
	event:         present_event_t,
	event_window:  window_t,
	window:        window_t,
	pixmap:        pixmap_t,
	serial:        u32,
	full_sequence: u32,
	valid_region:  xfixes_region_t,
	update_region: xfixes_region_t,
	valid_rect:    rectangle_t,
	update_rect:   rectangle_t,
	x_off:         i16,
	y_off:         i16,
	target_crtc:   randr_crtc_t,
	wait_fence:    sync_fence_t,
	idle_fence:    sync_fence_t,
	options:       u32,
	pad1:          [4]u8,
	target_msc:    u64,
	divisor:       u64,
	remainder:     u64,
}

randr_bad_output_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

randr_bad_crtc_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

randr_bad_mode_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

randr_bad_provider_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

randr_screen_size_t :: struct{
	width:   u16,
	height:  u16,
	mwidth:  u16,
	mheight: u16,
}

randr_refresh_rates_t :: struct{
	nRates: u16,
}

randr_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_query_version_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	major_version: u32,
	minor_version: u32,
}

randr_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u32,
	minor_version: u32,
	pad1:          [16]u8,
}

randr_set_screen_config_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_set_screen_config_request_t :: struct{
	major_opcode:     u8,
	minor_opcode:     u8,
	length:           u16,
	window:           window_t,
	timestamp:        timestamp_t,
	config_timestamp: timestamp_t,
	sizeID:           u16,
	rotation:         u16,
	rate:             u16,
	pad0:             [2]u8,
}

randr_set_screen_config_reply_t :: struct{
	response_type:    u8,
	status:           u8,
	sequence:         u16,
	length:           u32,
	new_timestamp:    timestamp_t,
	config_timestamp: timestamp_t,
	root:             window_t,
	subpixel_order:   u16,
	pad0:             [10]u8,
}

randr_select_input_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	enable:       u16,
	pad0:         [2]u8,
}

randr_get_screen_info_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_screen_info_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

randr_get_screen_info_reply_t :: struct{
	response_type:    u8,
	rotations:        u8,
	sequence:         u16,
	length:           u32,
	root:             window_t,
	timestamp:        timestamp_t,
	config_timestamp: timestamp_t,
	nSizes:           u16,
	sizeID:           u16,
	rotation:         u16,
	rate:             u16,
	nInfo:            u16,
	pad0:             [2]u8,
}

randr_get_screen_size_range_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_screen_size_range_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

randr_get_screen_size_range_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	min_width:     u16,
	min_height:    u16,
	max_width:     u16,
	max_height:    u16,
	pad1:          [16]u8,
}

randr_set_screen_size_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	width:        u16,
	height:       u16,
	mm_width:     u32,
	mm_height:    u32,
}

randr_mode_info_t :: struct{
	id:          u32,
	width:       u16,
	height:      u16,
	dot_clock:   u32,
	hsync_start: u16,
	hsync_end:   u16,
	htotal:      u16,
	hskew:       u16,
	vsync_start: u16,
	vsync_end:   u16,
	vtotal:      u16,
	name_len:    u16,
	mode_flags:  u32,
}

randr_get_screen_resources_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_screen_resources_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

randr_get_screen_resources_reply_t :: struct{
	response_type:    u8,
	pad0:             u8,
	sequence:         u16,
	length:           u32,
	timestamp:        timestamp_t,
	config_timestamp: timestamp_t,
	num_crtcs:        u16,
	num_outputs:      u16,
	num_modes:        u16,
	names_len:        u16,
	pad1:             [8]u8,
}

randr_get_output_info_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_output_info_request_t :: struct{
	major_opcode:     u8,
	minor_opcode:     u8,
	length:           u16,
	output:           randr_output_t,
	config_timestamp: timestamp_t,
}

randr_get_output_info_reply_t :: struct{
	response_type:  u8,
	status:         u8,
	sequence:       u16,
	length:         u32,
	timestamp:      timestamp_t,
	crtc:           randr_crtc_t,
	mm_width:       u32,
	mm_height:      u32,
	connection:     u8,
	subpixel_order: u8,
	num_crtcs:      u16,
	num_modes:      u16,
	num_preferred:  u16,
	num_clones:     u16,
	name_len:       u16,
}

randr_list_output_properties_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_list_output_properties_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	output:       randr_output_t,
}

randr_list_output_properties_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_atoms:     u16,
	pad1:          [22]u8,
}

randr_query_output_property_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_query_output_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	output:       randr_output_t,
	property:     atom_t,
}

randr_query_output_property_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pending:       u8,
	range:         u8,
	immutable:     u8,
	pad1:          [21]u8,
}

randr_configure_output_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	output:       randr_output_t,
	property:     atom_t,
	pending:      u8,
	range:        u8,
	pad0:         [2]u8,
}

randr_change_output_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	output:       randr_output_t,
	property:     atom_t,
	type:         atom_t,
	format:       u8,
	mode:         u8,
	pad0:         [2]u8,
	num_units:    u32,
}

randr_delete_output_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	output:       randr_output_t,
	property:     atom_t,
}

randr_get_output_property_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_output_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	output:       randr_output_t,
	property:     atom_t,
	type:         atom_t,
	long_offset:  u32,
	long_length:  u32,
	_delete:      u8,
	pending:      u8,
	pad0:         [2]u8,
}

randr_get_output_property_reply_t :: struct{
	response_type: u8,
	format:        u8,
	sequence:      u16,
	length:        u32,
	type:          atom_t,
	bytes_after:   u32,
	num_items:     u32,
	pad0:          [12]u8,
}

randr_create_mode_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_create_mode_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	mode_info:    randr_mode_info_t,
}

randr_create_mode_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	mode:          randr_mode_t,
	pad1:          [20]u8,
}

randr_destroy_mode_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	mode:         randr_mode_t,
}

randr_add_output_mode_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	output:       randr_output_t,
	mode:         randr_mode_t,
}

randr_delete_output_mode_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	output:       randr_output_t,
	mode:         randr_mode_t,
}

randr_get_crtc_info_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_crtc_info_request_t :: struct{
	major_opcode:     u8,
	minor_opcode:     u8,
	length:           u16,
	crtc:             randr_crtc_t,
	config_timestamp: timestamp_t,
}

randr_get_crtc_info_reply_t :: struct{
	response_type:        u8,
	status:               u8,
	sequence:             u16,
	length:               u32,
	timestamp:            timestamp_t,
	x:                    i16,
	y:                    i16,
	width:                u16,
	height:               u16,
	mode:                 randr_mode_t,
	rotation:             u16,
	rotations:            u16,
	num_outputs:          u16,
	num_possible_outputs: u16,
}

randr_set_crtc_config_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_set_crtc_config_request_t :: struct{
	major_opcode:     u8,
	minor_opcode:     u8,
	length:           u16,
	crtc:             randr_crtc_t,
	timestamp:        timestamp_t,
	config_timestamp: timestamp_t,
	x:                i16,
	y:                i16,
	mode:             randr_mode_t,
	rotation:         u16,
	pad0:             [2]u8,
}

randr_set_crtc_config_reply_t :: struct{
	response_type: u8,
	status:        u8,
	sequence:      u16,
	length:        u32,
	timestamp:     timestamp_t,
	pad0:          [20]u8,
}

randr_get_crtc_gamma_size_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_crtc_gamma_size_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	crtc:         randr_crtc_t,
}

randr_get_crtc_gamma_size_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	size:          u16,
	pad1:          [22]u8,
}

randr_get_crtc_gamma_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_crtc_gamma_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	crtc:         randr_crtc_t,
}

randr_get_crtc_gamma_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	size:          u16,
	pad1:          [22]u8,
}

randr_set_crtc_gamma_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	crtc:         randr_crtc_t,
	size:         u16,
	pad0:         [2]u8,
}

randr_get_screen_resources_current_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_screen_resources_current_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

randr_get_screen_resources_current_reply_t :: struct{
	response_type:    u8,
	pad0:             u8,
	sequence:         u16,
	length:           u32,
	timestamp:        timestamp_t,
	config_timestamp: timestamp_t,
	num_crtcs:        u16,
	num_outputs:      u16,
	num_modes:        u16,
	names_len:        u16,
	pad1:             [8]u8,
}

randr_set_crtc_transform_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	crtc:         randr_crtc_t,
	transform:    render_transform_t,
	filter_len:   u16,
	pad0:         [2]u8,
}

randr_get_crtc_transform_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_crtc_transform_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	crtc:         randr_crtc_t,
}

randr_get_crtc_transform_reply_t :: struct{
	response_type:     u8,
	pad0:              u8,
	sequence:          u16,
	length:            u32,
	pending_transform: render_transform_t,
	has_transforms:    u8,
	pad1:              [3]u8,
	current_transform: render_transform_t,
	pad2:              [4]u8,
	pending_len:       u16,
	pending_nparams:   u16,
	current_len:       u16,
	current_nparams:   u16,
}

randr_get_panning_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_panning_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	crtc:         randr_crtc_t,
}

randr_get_panning_reply_t :: struct{
	response_type: u8,
	status:        u8,
	sequence:      u16,
	length:        u32,
	timestamp:     timestamp_t,
	left:          u16,
	top:           u16,
	width:         u16,
	height:        u16,
	track_left:    u16,
	track_top:     u16,
	track_width:   u16,
	track_height:  u16,
	border_left:   i16,
	border_top:    i16,
	border_right:  i16,
	border_bottom: i16,
}

randr_set_panning_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_set_panning_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	crtc:          randr_crtc_t,
	timestamp:     timestamp_t,
	left:          u16,
	top:           u16,
	width:         u16,
	height:        u16,
	track_left:    u16,
	track_top:     u16,
	track_width:   u16,
	track_height:  u16,
	border_left:   i16,
	border_top:    i16,
	border_right:  i16,
	border_bottom: i16,
}

randr_set_panning_reply_t :: struct{
	response_type: u8,
	status:        u8,
	sequence:      u16,
	length:        u32,
	timestamp:     timestamp_t,
}

randr_set_output_primary_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	output:       randr_output_t,
}

randr_get_output_primary_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_output_primary_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

randr_get_output_primary_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	output:        randr_output_t,
}

randr_get_providers_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_providers_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

randr_get_providers_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	timestamp:     timestamp_t,
	num_providers: u16,
	pad1:          [18]u8,
}

randr_get_provider_info_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_provider_info_request_t :: struct{
	major_opcode:     u8,
	minor_opcode:     u8,
	length:           u16,
	provider:         randr_provider_t,
	config_timestamp: timestamp_t,
}

randr_get_provider_info_reply_t :: struct{
	response_type:            u8,
	status:                   u8,
	sequence:                 u16,
	length:                   u32,
	timestamp:                timestamp_t,
	capabilities:             u32,
	num_crtcs:                u16,
	num_outputs:              u16,
	num_associated_providers: u16,
	name_len:                 u16,
	pad0:                     [8]u8,
}

randr_set_provider_offload_sink_request_t :: struct{
	major_opcode:     u8,
	minor_opcode:     u8,
	length:           u16,
	provider:         randr_provider_t,
	sink_provider:    randr_provider_t,
	config_timestamp: timestamp_t,
}

randr_set_provider_output_source_request_t :: struct{
	major_opcode:     u8,
	minor_opcode:     u8,
	length:           u16,
	provider:         randr_provider_t,
	source_provider:  randr_provider_t,
	config_timestamp: timestamp_t,
}

randr_list_provider_properties_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_list_provider_properties_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	provider:     randr_provider_t,
}

randr_list_provider_properties_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_atoms:     u16,
	pad1:          [22]u8,
}

randr_query_provider_property_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_query_provider_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	provider:     randr_provider_t,
	property:     atom_t,
}

randr_query_provider_property_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pending:       u8,
	range:         u8,
	immutable:     u8,
	pad1:          [21]u8,
}

randr_configure_provider_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	provider:     randr_provider_t,
	property:     atom_t,
	pending:      u8,
	range:        u8,
	pad0:         [2]u8,
}

randr_change_provider_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	provider:     randr_provider_t,
	property:     atom_t,
	type:         atom_t,
	format:       u8,
	mode:         u8,
	pad0:         [2]u8,
	num_items:    u32,
}

randr_delete_provider_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	provider:     randr_provider_t,
	property:     atom_t,
}

randr_get_provider_property_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_provider_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	provider:     randr_provider_t,
	property:     atom_t,
	type:         atom_t,
	long_offset:  u32,
	long_length:  u32,
	_delete:      u8,
	pending:      u8,
	pad0:         [2]u8,
}

randr_get_provider_property_reply_t :: struct{
	response_type: u8,
	format:        u8,
	sequence:      u16,
	length:        u32,
	type:          atom_t,
	bytes_after:   u32,
	num_items:     u32,
	pad0:          [12]u8,
}

randr_screen_change_notify_event_t :: struct{
	response_type:    u8,
	rotation:         u8,
	sequence:         u16,
	timestamp:        timestamp_t,
	config_timestamp: timestamp_t,
	root:             window_t,
	request_window:   window_t,
	sizeID:           u16,
	subpixel_order:   u16,
	width:            u16,
	height:           u16,
	mwidth:           u16,
	mheight:          u16,
}

randr_crtc_change_t :: struct{
	timestamp: timestamp_t,
	window:    window_t,
	crtc:      randr_crtc_t,
	mode:      randr_mode_t,
	rotation:  u16,
	pad0:      [2]u8,
	x:         i16,
	y:         i16,
	width:     u16,
	height:    u16,
}

randr_output_change_t :: struct{
	timestamp:        timestamp_t,
	config_timestamp: timestamp_t,
	window:           window_t,
	output:           randr_output_t,
	crtc:             randr_crtc_t,
	mode:             randr_mode_t,
	rotation:         u16,
	connection:       u8,
	subpixel_order:   u8,
}

randr_output_property_t :: struct{
	window:    window_t,
	output:    randr_output_t,
	atom:      atom_t,
	timestamp: timestamp_t,
	status:    u8,
	pad0:      [11]u8,
}

randr_provider_change_t :: struct{
	timestamp: timestamp_t,
	window:    window_t,
	provider:  randr_provider_t,
	pad0:      [16]u8,
}

randr_provider_property_t :: struct{
	window:    window_t,
	provider:  randr_provider_t,
	atom:      atom_t,
	timestamp: timestamp_t,
	state:     u8,
	pad0:      [11]u8,
}

randr_resource_change_t :: struct{
	timestamp: timestamp_t,
	window:    window_t,
	pad0:      [20]u8,
}

randr_monitor_info_t :: struct{
	name:                  atom_t,
	primary:               u8,
	automatic:             u8,
	nOutput:               u16,
	x:                     i16,
	y:                     i16,
	width:                 u16,
	height:                u16,
	width_in_millimeters:  u32,
	height_in_millimeters: u32,
}

randr_get_monitors_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_get_monitors_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	get_active:   u8,
}

randr_get_monitors_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	timestamp:     timestamp_t,
	nMonitors:     u32,
	nOutputs:      u32,
	pad1:          [12]u8,
}

randr_set_monitor_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

randr_delete_monitor_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	name:         atom_t,
}

randr_create_lease_cookie_t :: struct{
	sequence: ctypes.uint,
}

randr_create_lease_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	lid:          randr_lease_t,
	num_crtcs:    u16,
	num_outputs:  u16,
}

randr_create_lease_reply_t :: struct{
	response_type: u8,
	nfd:           u8,
	sequence:      u16,
	length:        u32,
	pad0:          [24]u8,
}

randr_free_lease_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	lid:          randr_lease_t,
	terminate:    u8,
}

randr_lease_notify_t :: struct{
	timestamp: timestamp_t,
	window:    window_t,
	lease:     randr_lease_t,
	created:   u8,
	pad0:      [15]u8,
}

randr_notify_data_t :: struct#raw_union {
	cc: randr_crtc_change_t,
	oc: randr_output_change_t,
	op: randr_output_property_t,
	pc: randr_provider_change_t,
	pp: randr_provider_property_t,
	rc: randr_resource_change_t,
	lc: randr_lease_notify_t,
}

randr_notify_event_t :: struct{
	response_type: u8,
	subCode:       u8,
	sequence:      u16,
	u:             randr_notify_data_t,
}

record_range_8_t :: struct{
	first: u8,
	last:  u8,
}

record_range_16_t :: struct{
	first: u16,
	last:  u16,
}

record_ext_range_t :: struct{
	major: record_range_8_t,
	minor: record_range_16_t,
}

record_range_t :: struct{
	core_requests:    record_range_8_t,
	core_replies:     record_range_8_t,
	ext_requests:     record_ext_range_t,
	ext_replies:      record_ext_range_t,
	delivered_events: record_range_8_t,
	device_events:    record_range_8_t,
	errors:           record_range_8_t,
	client_started:   u8,
	client_died:      u8,
}

record_client_info_t :: struct{
	client_resource: record_client_spec_t,
	num_ranges:      u32,
}

record_bad_context_error_t :: struct{
	response_type:  u8,
	error_code:     u8,
	sequence:       u16,
	invalid_record: u32,
	minor_opcode:   u16,
	major_opcode:   u8,
}

record_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

record_query_version_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	major_version: u16,
	minor_version: u16,
}

record_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u16,
	minor_version: u16,
}

record_create_context_request_t :: struct{
	major_opcode:     u8,
	minor_opcode:     u8,
	length:           u16,
	context_:         record_context_t,
	element_header:   record_element_header_t,
	pad0:             [3]u8,
	num_client_specs: u32,
	num_ranges:       u32,
}

record_register_clients_request_t :: struct{
	major_opcode:     u8,
	minor_opcode:     u8,
	length:           u16,
	context_:         record_context_t,
	element_header:   record_element_header_t,
	pad0:             [3]u8,
	num_client_specs: u32,
	num_ranges:       u32,
}

record_unregister_clients_request_t :: struct{
	major_opcode:     u8,
	minor_opcode:     u8,
	length:           u16,
	context_:         record_context_t,
	num_client_specs: u32,
}

record_get_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

record_get_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     record_context_t,
}

record_get_context_reply_t :: struct{
	response_type:           u8,
	enabled:                 u8,
	sequence:                u16,
	length:                  u32,
	element_header:          record_element_header_t,
	pad0:                    [3]u8,
	num_intercepted_clients: u32,
	pad1:                    [16]u8,
}

record_enable_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

record_enable_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     record_context_t,
}

record_enable_context_reply_t :: struct{
	response_type:    u8,
	category:         u8,
	sequence:         u16,
	length:           u32,
	element_header:   record_element_header_t,
	client_swapped:   u8,
	pad0:             [2]u8,
	xid_base:         u32,
	server_time:      u32,
	rec_sequence_num: u32,
	pad1:             [8]u8,
}

record_disable_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     record_context_t,
}

record_free_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     record_context_t,
}

render_pict_format_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

render_picture_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

render_pict_op_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

render_glyph_set_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

render_glyph_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

render_directformat_t :: struct{
	red_shift:   u16,
	red_mask:    u16,
	green_shift: u16,
	green_mask:  u16,
	blue_shift:  u16,
	blue_mask:   u16,
	alpha_shift: u16,
	alpha_mask:  u16,
}

render_pictforminfo_t :: struct{
	id:       render_pictformat_t,
	type:     u8,
	depth:    u8,
	pad0:     [2]u8,
	direct:   render_directformat_t,
	colormap: colormap_t,
}

render_pictvisual_t :: struct{
	visual: visualid_t,
	format: render_pictformat_t,
}

render_pictdepth_t :: struct{
	depth:       u8,
	pad0:        u8,
	num_visuals: u16,
	pad1:        [4]u8,
}

render_pictscreen_t :: struct{
	num_depths: u32,
	fallback:   render_pictformat_t,
}

render_indexvalue_t :: struct{
	pixel: u32,
	red:   u16,
	green: u16,
	blue:  u16,
	alpha: u16,
}

render_color_t :: struct{
	red:   u16,
	green: u16,
	blue:  u16,
	alpha: u16,
}

render_pointfix_t :: struct{
	x: render_fixed_t,
	y: render_fixed_t,
}

render_linefix_t :: struct{
	p1: render_pointfix_t,
	p2: render_pointfix_t,
}

render_triangle_t :: struct{
	p1: render_pointfix_t,
	p2: render_pointfix_t,
	p3: render_pointfix_t,
}

render_trapezoid_t :: struct{
	top:    render_fixed_t,
	bottom: render_fixed_t,
	left:   render_linefix_t,
	right:  render_linefix_t,
}

render_glyphinfo_t :: struct{
	width:  u16,
	height: u16,
	x:      i16,
	y:      i16,
	x_off:  i16,
	y_off:  i16,
}

render_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

render_query_version_request_t :: struct{
	major_opcode:         u8,
	minor_opcode:         u8,
	length:               u16,
	client_major_version: u32,
	client_minor_version: u32,
}

render_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u32,
	minor_version: u32,
	pad1:          [16]u8,
}

render_query_pict_formats_cookie_t :: struct{
	sequence: ctypes.uint,
}

render_query_pict_formats_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

render_query_pict_formats_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_formats:   u32,
	num_screens:   u32,
	num_depths:    u32,
	num_visuals:   u32,
	num_subpixel:  u32,
	pad1:          [4]u8,
}

render_query_pict_index_values_cookie_t :: struct{
	sequence: ctypes.uint,
}

render_query_pict_index_values_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	format:       render_pictformat_t,
}

render_query_pict_index_values_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_values:    u32,
	pad1:          [20]u8,
}

render_create_picture_value_list_t :: struct{
	repeat:           u32,
	alphamap:         render_picture_t,
	alphaxorigin:     i32,
	alphayorigin:     i32,
	clipxorigin:      i32,
	clipyorigin:      i32,
	clipmask:         pixmap_t,
	graphicsexposure: u32,
	subwindowmode:    u32,
	polyedge:         u32,
	polymode:         u32,
	dither:           atom_t,
	componentalpha:   u32,
}

render_create_picture_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	pid:          render_picture_t,
	drawable:     drawable_t,
	format:       render_pictformat_t,
	value_mask:   u32,
}

render_change_picture_value_list_t :: struct{
	repeat:           u32,
	alphamap:         render_picture_t,
	alphaxorigin:     i32,
	alphayorigin:     i32,
	clipxorigin:      i32,
	clipyorigin:      i32,
	clipmask:         pixmap_t,
	graphicsexposure: u32,
	subwindowmode:    u32,
	polyedge:         u32,
	polymode:         u32,
	dither:           atom_t,
	componentalpha:   u32,
}

render_change_picture_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	picture:      render_picture_t,
	value_mask:   u32,
}

render_set_picture_clip_rectangles_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	picture:       render_picture_t,
	clip_x_origin: i16,
	clip_y_origin: i16,
}

render_free_picture_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	picture:      render_picture_t,
}

render_composite_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	op:           u8,
	pad0:         [3]u8,
	src:          render_picture_t,
	mask:         render_picture_t,
	dst:          render_picture_t,
	src_x:        i16,
	src_y:        i16,
	mask_x:       i16,
	mask_y:       i16,
	dst_x:        i16,
	dst_y:        i16,
	width:        u16,
	height:       u16,
}

render_trapezoids_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	op:           u8,
	pad0:         [3]u8,
	src:          render_picture_t,
	dst:          render_picture_t,
	mask_format:  render_pictformat_t,
	src_x:        i16,
	src_y:        i16,
}

render_triangles_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	op:           u8,
	pad0:         [3]u8,
	src:          render_picture_t,
	dst:          render_picture_t,
	mask_format:  render_pictformat_t,
	src_x:        i16,
	src_y:        i16,
}

render_tri_strip_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	op:           u8,
	pad0:         [3]u8,
	src:          render_picture_t,
	dst:          render_picture_t,
	mask_format:  render_pictformat_t,
	src_x:        i16,
	src_y:        i16,
}

render_tri_fan_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	op:           u8,
	pad0:         [3]u8,
	src:          render_picture_t,
	dst:          render_picture_t,
	mask_format:  render_pictformat_t,
	src_x:        i16,
	src_y:        i16,
}

render_create_glyph_set_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	gsid:         render_glyphset_t,
	format:       render_pictformat_t,
}

render_reference_glyph_set_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	gsid:         render_glyphset_t,
	existing:     render_glyphset_t,
}

render_free_glyph_set_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	glyphset:     render_glyphset_t,
}

render_add_glyphs_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	glyphset:     render_glyphset_t,
	glyphs_len:   u32,
}

render_free_glyphs_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	glyphset:     render_glyphset_t,
}

render_composite_glyphs_8_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	op:           u8,
	pad0:         [3]u8,
	src:          render_picture_t,
	dst:          render_picture_t,
	mask_format:  render_pictformat_t,
	glyphset:     render_glyphset_t,
	src_x:        i16,
	src_y:        i16,
}

render_composite_glyphs_16_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	op:           u8,
	pad0:         [3]u8,
	src:          render_picture_t,
	dst:          render_picture_t,
	mask_format:  render_pictformat_t,
	glyphset:     render_glyphset_t,
	src_x:        i16,
	src_y:        i16,
}

render_composite_glyphs_32_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	op:           u8,
	pad0:         [3]u8,
	src:          render_picture_t,
	dst:          render_picture_t,
	mask_format:  render_pictformat_t,
	glyphset:     render_glyphset_t,
	src_x:        i16,
	src_y:        i16,
}

render_fill_rectangles_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	op:           u8,
	pad0:         [3]u8,
	dst:          render_picture_t,
	color:        render_color_t,
}

render_create_cursor_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	cid:          cursor_t,
	source:       render_picture_t,
	x:            u16,
	y:            u16,
}

render_transform_t :: struct{
	matrix11: render_fixed_t,
	matrix12: render_fixed_t,
	matrix13: render_fixed_t,
	matrix21: render_fixed_t,
	matrix22: render_fixed_t,
	matrix23: render_fixed_t,
	matrix31: render_fixed_t,
	matrix32: render_fixed_t,
	matrix33: render_fixed_t,
}

render_set_picture_transform_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	picture:      render_picture_t,
	transform:    render_transform_t,
}

render_query_filters_cookie_t :: struct{
	sequence: ctypes.uint,
}

render_query_filters_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
}

render_query_filters_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_aliases:   u32,
	num_filters:   u32,
	pad1:          [16]u8,
}

render_set_picture_filter_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	picture:      render_picture_t,
	filter_len:   u16,
	pad0:         [2]u8,
}

render_animcursorelt_t :: struct{
	cursor: cursor_t,
	delay:  u32,
}

render_create_anim_cursor_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	cid:          cursor_t,
}

render_spanfix_t :: struct{
	l: render_fixed_t,
	r: render_fixed_t,
	y: render_fixed_t,
}

render_trap_t :: struct{
	top: render_spanfix_t,
	bot: render_spanfix_t,
}

render_add_traps_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	picture:      render_picture_t,
	x_off:        i16,
	y_off:        i16,
}

render_create_solid_fill_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	picture:      render_picture_t,
	color:        render_color_t,
}

render_create_linear_gradient_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	picture:      render_picture_t,
	p1:           render_pointfix_t,
	p2:           render_pointfix_t,
	num_stops:    u32,
}

render_create_radial_gradient_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	picture:      render_picture_t,
	inner:        render_pointfix_t,
	outer:        render_pointfix_t,
	inner_radius: render_fixed_t,
	outer_radius: render_fixed_t,
	num_stops:    u32,
}

render_create_conical_gradient_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	picture:      render_picture_t,
	center:       render_pointfix_t,
	angle:        render_fixed_t,
	num_stops:    u32,
}

res_client_t :: struct{
	resource_base: u32,
	resource_mask: u32,
}

res_type_t :: struct{
	resource_type: atom_t,
	count:         u32,
}

res_client_id_spec_t :: struct{
	client: u32,
	mask:   u32,
}

res_client_id_value_t :: struct{
	spec:   res_client_id_spec_t,
	length: u32,
}

res_resource_id_spec_t :: struct{
	resource: u32,
	type:     u32,
}

res_resource_size_spec_t :: struct{
	spec:      res_resource_id_spec_t,
	bytes:     u32,
	ref_count: u32,
	use_count: u32,
}

res_resource_size_value_t :: struct{
	size:                 res_resource_size_spec_t,
	num_cross_references: u32,
}

res_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

res_query_version_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	client_major: u8,
	client_minor: u8,
}

res_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	server_major:  u16,
	server_minor:  u16,
}

res_query_clients_cookie_t :: struct{
	sequence: ctypes.uint,
}

res_query_clients_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

res_query_clients_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_clients:   u32,
	pad1:          [20]u8,
}

res_query_client_resources_cookie_t :: struct{
	sequence: ctypes.uint,
}

res_query_client_resources_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	xid:          u32,
}

res_query_client_resources_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_types:     u32,
	pad1:          [20]u8,
}

res_query_client_pixmap_bytes_cookie_t :: struct{
	sequence: ctypes.uint,
}

res_query_client_pixmap_bytes_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	xid:          u32,
}

res_query_client_pixmap_bytes_reply_t :: struct{
	response_type:  u8,
	pad0:           u8,
	sequence:       u16,
	length:         u32,
	bytes:          u32,
	bytes_overflow: u32,
}

res_query_client_ids_cookie_t :: struct{
	sequence: ctypes.uint,
}

res_query_client_ids_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	num_specs:    u32,
}

res_query_client_ids_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_ids:       u32,
	pad1:          [20]u8,
}

res_query_resource_bytes_cookie_t :: struct{
	sequence: ctypes.uint,
}

res_query_resource_bytes_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	client:       u32,
	num_specs:    u32,
}

res_query_resource_bytes_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_sizes:     u32,
	pad1:          [20]u8,
}

screensaver_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

screensaver_query_version_request_t :: struct{
	major_opcode:         u8,
	minor_opcode:         u8,
	length:               u16,
	client_major_version: u8,
	client_minor_version: u8,
	pad0:                 [2]u8,
}

screensaver_query_version_reply_t :: struct{
	response_type:        u8,
	pad0:                 u8,
	sequence:             u16,
	length:               u32,
	server_major_version: u16,
	server_minor_version: u16,
	pad1:                 [20]u8,
}

screensaver_query_info_cookie_t :: struct{
	sequence: ctypes.uint,
}

screensaver_query_info_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
}

screensaver_query_info_reply_t :: struct{
	response_type:       u8,
	state:               u8,
	sequence:            u16,
	length:              u32,
	saver_window:        window_t,
	ms_until_server:     u32,
	ms_since_user_input: u32,
	event_mask:          u32,
	kind:                u8,
	pad0:                [7]u8,
}

screensaver_select_input_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
	event_mask:   u32,
}

screensaver_set_attributes_value_list_t :: struct{
	background_pixmap:     pixmap_t,
	background_pixel:      u32,
	border_pixmap:         pixmap_t,
	border_pixel:          u32,
	bit_gravity:           u32,
	win_gravity:           u32,
	backing_store:         u32,
	backing_planes:        u32,
	backing_pixel:         u32,
	override_redirect:     b32,
	save_under:            b32,
	event_mask:            u32,
	do_not_propogate_mask: u32,
	colormap:              colormap_t,
	cursor:                cursor_t,
}

screensaver_set_attributes_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
	x:            i16,
	y:            i16,
	width:        u16,
	height:       u16,
	border_width: u16,
	_class:       u8,
	depth:        u8,
	visual:       visualid_t,
	value_mask:   u32,
}

screensaver_unset_attributes_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
}

screensaver_suspend_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	suspend:      u32,
}

screensaver_notify_event_t :: struct{
	response_type: u8,
	state:         u8,
	sequence:      u16,
	time:          timestamp_t,
	root:          window_t,
	window:        window_t,
	kind:          u8,
	forced:        u8,
	pad0:          [14]u8,
}

shape_notify_event_t :: struct{
	response_type:   u8,
	shape_kind:      shape_kind_t,
	sequence:        u16,
	affected_window: window_t,
	extents_x:       i16,
	extents_y:       i16,
	extents_width:   u16,
	extents_height:  u16,
	server_time:     timestamp_t,
	shaped:          u8,
	pad0:            [11]u8,
}

shape_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

shape_query_version_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

shape_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u16,
	minor_version: u16,
}

shape_rectangles_request_t :: struct{
	major_opcode:       u8,
	minor_opcode:       u8,
	length:             u16,
	operation:          shape_op_t,
	destination_kind:   shape_kind_t,
	ordering:           u8,
	pad0:               u8,
	destination_window: window_t,
	x_offset:           i16,
	y_offset:           i16,
}

shape_mask_request_t :: struct{
	major_opcode:       u8,
	minor_opcode:       u8,
	length:             u16,
	operation:          shape_op_t,
	destination_kind:   shape_kind_t,
	pad0:               [2]u8,
	destination_window: window_t,
	x_offset:           i16,
	y_offset:           i16,
	source_bitmap:      pixmap_t,
}

shape_combine_request_t :: struct{
	major_opcode:       u8,
	minor_opcode:       u8,
	length:             u16,
	operation:          shape_op_t,
	destination_kind:   shape_kind_t,
	source_kind:        shape_kind_t,
	pad0:               u8,
	destination_window: window_t,
	x_offset:           i16,
	y_offset:           i16,
	source_window:      window_t,
}

shape_offset_request_t :: struct{
	major_opcode:       u8,
	minor_opcode:       u8,
	length:             u16,
	destination_kind:   shape_kind_t,
	pad0:               [3]u8,
	destination_window: window_t,
	x_offset:           i16,
	y_offset:           i16,
}

shape_query_extents_cookie_t :: struct{
	sequence: ctypes.uint,
}

shape_query_extents_request_t :: struct{
	major_opcode:       u8,
	minor_opcode:       u8,
	length:             u16,
	destination_window: window_t,
}

shape_query_extents_reply_t :: struct{
	response_type:                 u8,
	pad0:                          u8,
	sequence:                      u16,
	length:                        u32,
	bounding_shaped:               u8,
	clip_shaped:                   u8,
	pad1:                          [2]u8,
	bounding_shape_extents_x:      i16,
	bounding_shape_extents_y:      i16,
	bounding_shape_extents_width:  u16,
	bounding_shape_extents_height: u16,
	clip_shape_extents_x:          i16,
	clip_shape_extents_y:          i16,
	clip_shape_extents_width:      u16,
	clip_shape_extents_height:     u16,
}

shape_select_input_request_t :: struct{
	major_opcode:       u8,
	minor_opcode:       u8,
	length:             u16,
	destination_window: window_t,
	enable:             u8,
	pad0:               [3]u8,
}

shape_input_selected_cookie_t :: struct{
	sequence: ctypes.uint,
}

shape_input_selected_request_t :: struct{
	major_opcode:       u8,
	minor_opcode:       u8,
	length:             u16,
	destination_window: window_t,
}

shape_input_selected_reply_t :: struct{
	response_type: u8,
	enabled:       u8,
	sequence:      u16,
	length:        u32,
}

shape_get_rectangles_cookie_t :: struct{
	sequence: ctypes.uint,
}

shape_get_rectangles_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	source_kind:  shape_kind_t,
	pad0:         [3]u8,
}

shape_get_rectangles_reply_t :: struct{
	response_type:  u8,
	ordering:       u8,
	sequence:       u16,
	length:         u32,
	rectangles_len: u32,
	pad0:           [20]u8,
}

shm_completion_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	drawable:      drawable_t,
	minor_event:   u16,
	major_event:   u8,
	pad1:          u8,
	shmseg:        shm_seg_t,
	offset:        u32,
}

shm_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

shm_query_version_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

shm_query_version_reply_t :: struct{
	response_type:  u8,
	shared_pixmaps: u8,
	sequence:       u16,
	length:         u32,
	major_version:  u16,
	minor_version:  u16,
	uid:            u16,
	gid:            u16,
	pixmap_format:  u8,
	pad0:           [15]u8,
}

shm_attach_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	shmseg:       shm_seg_t,
	shmid:        u32,
	read_only:    u8,
	pad0:         [3]u8,
}

shm_detach_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	shmseg:       shm_seg_t,
}

shm_put_image_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
	gc:           gcontext_t,
	total_width:  u16,
	total_height: u16,
	src_x:        u16,
	src_y:        u16,
	src_width:    u16,
	src_height:   u16,
	dst_x:        i16,
	dst_y:        i16,
	depth:        u8,
	format:       u8,
	send_event:   u8,
	pad0:         u8,
	shmseg:       shm_seg_t,
	offset:       u32,
}

shm_get_image_cookie_t :: struct{
	sequence: ctypes.uint,
}

shm_get_image_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
	x:            i16,
	y:            i16,
	width:        u16,
	height:       u16,
	plane_mask:   u32,
	format:       u8,
	pad0:         [3]u8,
	shmseg:       shm_seg_t,
	offset:       u32,
}

shm_get_image_reply_t :: struct{
	response_type: u8,
	depth:         u8,
	sequence:      u16,
	length:        u32,
	visual:        visualid_t,
	size:          u32,
}

shm_create_pixmap_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	pid:          pixmap_t,
	drawable:     drawable_t,
	width:        u16,
	height:       u16,
	depth:        u8,
	pad0:         [3]u8,
	shmseg:       shm_seg_t,
	offset:       u32,
}

shm_attach_fd_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	shmseg:       shm_seg_t,
	read_only:    u8,
	pad0:         [3]u8,
}

shm_create_segment_cookie_t :: struct{
	sequence: ctypes.uint,
}

shm_create_segment_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	shmseg:       shm_seg_t,
	size:         u32,
	read_only:    u8,
	pad0:         [3]u8,
}

shm_create_segment_reply_t :: struct{
	response_type: u8,
	nfd:           u8,
	sequence:      u16,
	length:        u32,
	pad0:          [24]u8,
}

sync_int64_t :: struct{
	hi: i32,
	lo: u32,
}

sync_systemcounter_t :: struct{
	counter:    sync_counter_t,
	resolution: sync_int64_t,
	name_len:   u16,
}

sync_trigger_t :: struct{
	counter:    sync_counter_t,
	wait_type:  u32,
	wait_value: sync_int64_t,
	test_type:  u32,
}

sync_waitcondition_t :: struct{
	trigger:         sync_trigger_t,
	event_threshold: sync_int64_t,
}

sync_counter_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_counter:   u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

sync_alarm_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_alarm:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

sync_initialize_cookie_t :: struct{
	sequence: ctypes.uint,
}

sync_initialize_request_t :: struct{
	major_opcode:          u8,
	minor_opcode:          u8,
	length:                u16,
	desired_major_version: u8,
	desired_minor_version: u8,
}

sync_initialize_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u8,
	minor_version: u8,
	pad1:          [22]u8,
}

sync_list_system_counters_cookie_t :: struct{
	sequence: ctypes.uint,
}

sync_list_system_counters_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

sync_list_system_counters_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	counters_len:  u32,
	pad1:          [20]u8,
}

sync_create_counter_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	id:            sync_counter_t,
	initial_value: sync_int64_t,
}

sync_destroy_counter_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	counter:      sync_counter_t,
}

sync_query_counter_cookie_t :: struct{
	sequence: ctypes.uint,
}

sync_query_counter_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	counter:      sync_counter_t,
}

sync_query_counter_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	counter_value: sync_int64_t,
}

sync_await_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

sync_change_counter_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	counter:      sync_counter_t,
	amount:       sync_int64_t,
}

sync_set_counter_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	counter:      sync_counter_t,
	value:        sync_int64_t,
}

sync_create_alarm_value_list_t :: struct{
	counter:   sync_counter_t,
	valueType: u32,
	value:     sync_int64_t,
	testType:  u32,
	delta:     sync_int64_t,
	events:    u32,
}

sync_create_alarm_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	id:           sync_alarm_t,
	value_mask:   u32,
}

sync_change_alarm_value_list_t :: struct{
	counter:   sync_counter_t,
	valueType: u32,
	value:     sync_int64_t,
	testType:  u32,
	delta:     sync_int64_t,
	events:    u32,
}

sync_change_alarm_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	id:           sync_alarm_t,
	value_mask:   u32,
}

sync_destroy_alarm_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	alarm:        sync_alarm_t,
}

sync_query_alarm_cookie_t :: struct{
	sequence: ctypes.uint,
}

sync_query_alarm_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	alarm:        sync_alarm_t,
}

sync_query_alarm_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	trigger:       sync_trigger_t,
	delta:         sync_int64_t,
	events:        u8,
	state:         u8,
	pad1:          [2]u8,
}

sync_set_priority_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	id:           u32,
	priority:     i32,
}

sync_get_priority_cookie_t :: struct{
	sequence: ctypes.uint,
}

sync_get_priority_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	id:           u32,
}

sync_get_priority_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	priority:      i32,
}

sync_create_fence_request_t :: struct{
	major_opcode:        u8,
	minor_opcode:        u8,
	length:              u16,
	drawable:            drawable_t,
	fence:               sync_fence_t,
	initially_triggered: u8,
}

sync_trigger_fence_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	fence:        sync_fence_t,
}

sync_reset_fence_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	fence:        sync_fence_t,
}

sync_destroy_fence_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	fence:        sync_fence_t,
}

sync_query_fence_cookie_t :: struct{
	sequence: ctypes.uint,
}

sync_query_fence_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	fence:        sync_fence_t,
}

sync_query_fence_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	triggered:     u8,
	pad1:          [23]u8,
}

sync_await_fence_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

sync_counter_notify_event_t :: struct{
	response_type: u8,
	kind:          u8,
	sequence:      u16,
	counter:       sync_counter_t,
	wait_value:    sync_int64_t,
	counter_value: sync_int64_t,
	timestamp:     timestamp_t,
	count:         u16,
	destroyed:     u8,
	pad0:          u8,
}

sync_alarm_notify_event_t :: struct{
	response_type: u8,
	kind:          u8,
	sequence:      u16,
	alarm:         sync_alarm_t,
	counter_value: sync_int64_t,
	alarm_value:   sync_int64_t,
	timestamp:     timestamp_t,
	state:         u8,
	pad0:          [3]u8,
}

xc_misc_get_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

xc_misc_get_version_request_t :: struct{
	major_opcode:         u8,
	minor_opcode:         u8,
	length:               u16,
	client_major_version: u16,
	client_minor_version: u16,
}

xc_misc_get_version_reply_t :: struct{
	response_type:        u8,
	pad0:                 u8,
	sequence:             u16,
	length:               u32,
	server_major_version: u16,
	server_minor_version: u16,
}

xc_misc_get_xid_range_cookie_t :: struct{
	sequence: ctypes.uint,
}

xc_misc_get_xid_range_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

xc_misc_get_xid_range_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	start_id:      u32,
	count:         u32,
}

xc_misc_get_xid_list_cookie_t :: struct{
	sequence: ctypes.uint,
}

xc_misc_get_xid_list_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	count:        u32,
}

xc_misc_get_xid_list_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	ids_len:       u32,
	pad1:          [20]u8,
}

auth_info_t :: struct{
	namelen: ctypes.int,
	name:    cstring,
	datalen: ctypes.int,
	data:    cstring,
}

xevie_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

xevie_query_version_request_t :: struct{
	major_opcode:         u8,
	minor_opcode:         u8,
	length:               u16,
	client_major_version: u16,
	client_minor_version: u16,
}

xevie_query_version_reply_t :: struct{
	response_type:        u8,
	pad0:                 u8,
	sequence:             u16,
	length:               u32,
	server_major_version: u16,
	server_minor_version: u16,
	pad1:                 [20]u8,
}

xevie_start_cookie_t :: struct{
	sequence: ctypes.uint,
}

xevie_start_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
}

xevie_start_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [24]u8,
}

xevie_end_cookie_t :: struct{
	sequence: ctypes.uint,
}

xevie_end_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	cmap:         u32,
}

xevie_end_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [24]u8,
}

xevie_event_t :: struct{
	pad0: [32]u8,
}

xevie_send_cookie_t :: struct{
	sequence: ctypes.uint,
}

xevie_send_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	event:        xevie_event_t,
	data_type:    u32,
	pad0:         [64]u8,
}

xevie_send_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [24]u8,
}

xevie_select_input_cookie_t :: struct{
	sequence: ctypes.uint,
}

xevie_select_input_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	event_mask:   u32,
}

xevie_select_input_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [24]u8,
}

xf86dri_drm_clip_rect_t :: struct{
	x1: i16,
	y1: i16,
	x2: i16,
	x3: i16,
}

xf86dri_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

xf86dri_query_version_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

xf86dri_query_version_reply_t :: struct{
	response_type:     u8,
	pad0:              u8,
	sequence:          u16,
	length:            u32,
	dri_major_version: u16,
	dri_minor_version: u16,
	dri_minor_patch:   u32,
}

xf86dri_query_direct_rendering_capable_cookie_t :: struct{
	sequence: ctypes.uint,
}

xf86dri_query_direct_rendering_capable_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
}

xf86dri_query_direct_rendering_capable_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	is_capable:    u8,
}

xf86dri_open_connection_cookie_t :: struct{
	sequence: ctypes.uint,
}

xf86dri_open_connection_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
}

xf86dri_open_connection_reply_t :: struct{
	response_type:     u8,
	pad0:              u8,
	sequence:          u16,
	length:            u32,
	sarea_handle_low:  u32,
	sarea_handle_high: u32,
	bus_id_len:        u32,
	pad1:              [12]u8,
}

xf86dri_close_connection_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
}

xf86dri_get_client_driver_name_cookie_t :: struct{
	sequence: ctypes.uint,
}

xf86dri_get_client_driver_name_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
}

xf86dri_get_client_driver_name_reply_t :: struct{
	response_type:               u8,
	pad0:                        u8,
	sequence:                    u16,
	length:                      u32,
	client_driver_major_version: u32,
	client_driver_minor_version: u32,
	client_driver_patch_version: u32,
	client_driver_name_len:      u32,
	pad1:                        [8]u8,
}

xf86dri_create_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

xf86dri_create_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
	visual:       u32,
	context_:     u32,
}

xf86dri_create_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	hw_context:    u32,
}

xf86dri_destroy_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
	context_:     u32,
}

xf86dri_create_drawable_cookie_t :: struct{
	sequence: ctypes.uint,
}

xf86dri_create_drawable_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
	drawable:     u32,
}

xf86dri_create_drawable_reply_t :: struct{
	response_type:      u8,
	pad0:               u8,
	sequence:           u16,
	length:             u32,
	hw_drawable_handle: u32,
}

xf86dri_destroy_drawable_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
	drawable:     u32,
}

xf86dri_get_drawable_info_cookie_t :: struct{
	sequence: ctypes.uint,
}

xf86dri_get_drawable_info_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
	drawable:     u32,
}

xf86dri_get_drawable_info_reply_t :: struct{
	response_type:        u8,
	pad0:                 u8,
	sequence:             u16,
	length:               u32,
	drawable_table_index: u32,
	drawable_table_stamp: u32,
	drawable_origin_X:    i16,
	drawable_origin_Y:    i16,
	drawable_size_W:      i16,
	drawable_size_H:      i16,
	num_clip_rects:       u32,
	back_x:               i16,
	back_y:               i16,
	num_back_clip_rects:  u32,
}

xf86dri_get_device_info_cookie_t :: struct{
	sequence: ctypes.uint,
}

xf86dri_get_device_info_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
}

xf86dri_get_device_info_reply_t :: struct{
	response_type:             u8,
	pad0:                      u8,
	sequence:                  u16,
	length:                    u32,
	framebuffer_handle_low:    u32,
	framebuffer_handle_high:   u32,
	framebuffer_origin_offset: u32,
	framebuffer_size:          u32,
	framebuffer_stride:        u32,
	device_private_size:       u32,
}

xf86dri_auth_connection_cookie_t :: struct{
	sequence: ctypes.uint,
}

xf86dri_auth_connection_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	screen:       u32,
	magic:        u32,
}

xf86dri_auth_connection_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	authenticated: u32,
}

xfixes_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

xfixes_query_version_request_t :: struct{
	major_opcode:         u8,
	minor_opcode:         u8,
	length:               u16,
	client_major_version: u32,
	client_minor_version: u32,
}

xfixes_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u32,
	minor_version: u32,
	pad1:          [16]u8,
}

xfixes_change_save_set_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	mode:         u8,
	target:       u8,
	map_:         u8,
	pad0:         u8,
	window:       window_t,
}

xfixes_selection_notify_event_t :: struct{
	response_type:       u8,
	subtype:             u8,
	sequence:            u16,
	window:              window_t,
	owner:               window_t,
	selection:           atom_t,
	timestamp:           timestamp_t,
	selection_timestamp: timestamp_t,
	pad0:                [8]u8,
}

xfixes_select_selection_input_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	selection:    atom_t,
	event_mask:   u32,
}

xfixes_cursor_notify_event_t :: struct{
	response_type: u8,
	subtype:       u8,
	sequence:      u16,
	window:        window_t,
	cursor_serial: u32,
	timestamp:     timestamp_t,
	name:          atom_t,
	pad0:          [12]u8,
}

xfixes_select_cursor_input_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	event_mask:   u32,
}

xfixes_get_cursor_image_cookie_t :: struct{
	sequence: ctypes.uint,
}

xfixes_get_cursor_image_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

xfixes_get_cursor_image_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	x:             i16,
	y:             i16,
	width:         u16,
	height:        u16,
	xhot:          u16,
	yhot:          u16,
	cursor_serial: u32,
	pad1:          [8]u8,
}

xfixes_bad_region_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

xfixes_create_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	region:       xfixes_region_t,
}

xfixes_create_region_from_bitmap_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	region:       xfixes_region_t,
	bitmap:       pixmap_t,
}

xfixes_create_region_from_window_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	region:       xfixes_region_t,
	window:       window_t,
	kind:         shape_kind_t,
	pad0:         [3]u8,
}

xfixes_create_region_from_gc_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	region:       xfixes_region_t,
	gc:           gcontext_t,
}

xfixes_create_region_from_picture_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	region:       xfixes_region_t,
	picture:      render_picture_t,
}

xfixes_destroy_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	region:       xfixes_region_t,
}

xfixes_set_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	region:       xfixes_region_t,
}

xfixes_copy_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	source:       xfixes_region_t,
	destination:  xfixes_region_t,
}

xfixes_union_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	source1:      xfixes_region_t,
	source2:      xfixes_region_t,
	destination:  xfixes_region_t,
}

xfixes_intersect_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	source1:      xfixes_region_t,
	source2:      xfixes_region_t,
	destination:  xfixes_region_t,
}

xfixes_subtract_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	source1:      xfixes_region_t,
	source2:      xfixes_region_t,
	destination:  xfixes_region_t,
}

xfixes_invert_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	source:       xfixes_region_t,
	bounds:       rectangle_t,
	destination:  xfixes_region_t,
}

xfixes_translate_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	region:       xfixes_region_t,
	dx:           i16,
	dy:           i16,
}

xfixes_region_extents_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	source:       xfixes_region_t,
	destination:  xfixes_region_t,
}

xfixes_fetch_region_cookie_t :: struct{
	sequence: ctypes.uint,
}

xfixes_fetch_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	region:       xfixes_region_t,
}

xfixes_fetch_region_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	extents:       rectangle_t,
	pad1:          [16]u8,
}

xfixes_set_gc_clip_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	gc:           gcontext_t,
	region:       xfixes_region_t,
	x_origin:     i16,
	y_origin:     i16,
}

xfixes_set_window_shape_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	dest:         window_t,
	dest_kind:    shape_kind_t,
	pad0:         [3]u8,
	x_offset:     i16,
	y_offset:     i16,
	region:       xfixes_region_t,
}

xfixes_set_picture_clip_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	picture:      render_picture_t,
	region:       xfixes_region_t,
	x_origin:     i16,
	y_origin:     i16,
}

xfixes_set_cursor_name_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	cursor:       cursor_t,
	nbytes:       u16,
	pad0:         [2]u8,
}

xfixes_get_cursor_name_cookie_t :: struct{
	sequence: ctypes.uint,
}

xfixes_get_cursor_name_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	cursor:       cursor_t,
}

xfixes_get_cursor_name_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	atom:          atom_t,
	nbytes:        u16,
	pad1:          [18]u8,
}

xfixes_get_cursor_image_and_name_cookie_t :: struct{
	sequence: ctypes.uint,
}

xfixes_get_cursor_image_and_name_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

xfixes_get_cursor_image_and_name_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	x:             i16,
	y:             i16,
	width:         u16,
	height:        u16,
	xhot:          u16,
	yhot:          u16,
	cursor_serial: u32,
	cursor_atom:   atom_t,
	nbytes:        u16,
	pad1:          [2]u8,
}

xfixes_change_cursor_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	source:       cursor_t,
	destination:  cursor_t,
}

xfixes_change_cursor_by_name_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	src:          cursor_t,
	nbytes:       u16,
	pad0:         [2]u8,
}

xfixes_expand_region_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	source:       xfixes_region_t,
	destination:  xfixes_region_t,
	left:         u16,
	right:        u16,
	top:          u16,
	bottom:       u16,
}

xfixes_hide_cursor_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

xfixes_show_cursor_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

xfixes_create_pointer_barrier_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	barrier:      xfixes_barrier_t,
	window:       window_t,
	x1:           u16,
	y1:           u16,
	x2:           u16,
	y2:           u16,
	directions:   u32,
	pad0:         [2]u8,
	num_devices:  u16,
}

xfixes_delete_pointer_barrier_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	barrier:      xfixes_barrier_t,
}

xfixes_set_client_disconnect_mode_request_t :: struct{
	major_opcode:    u8,
	minor_opcode:    u8,
	length:          u16,
	disconnect_mode: u32,
}

xfixes_get_client_disconnect_mode_cookie_t :: struct{
	sequence: ctypes.uint,
}

xfixes_get_client_disconnect_mode_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

xfixes_get_client_disconnect_mode_reply_t :: struct{
	response_type:   u8,
	pad0:            u8,
	sequence:        u16,
	length:          u32,
	disconnect_mode: u32,
	pad1:            [20]u8,
}

xinerama_screen_info_t :: struct{
	x_org:  i16,
	y_org:  i16,
	width:  u16,
	height: u16,
}

xinerama_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

xinerama_query_version_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	major:        u8,
	minor:        u8,
}

xinerama_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major:         u16,
	minor:         u16,
}

xinerama_get_state_cookie_t :: struct{
	sequence: ctypes.uint,
}

xinerama_get_state_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

xinerama_get_state_reply_t :: struct{
	response_type: u8,
	state:         u8,
	sequence:      u16,
	length:        u32,
	window:        window_t,
}

xinerama_get_screen_count_cookie_t :: struct{
	sequence: ctypes.uint,
}

xinerama_get_screen_count_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

xinerama_get_screen_count_reply_t :: struct{
	response_type: u8,
	screen_count:  u8,
	sequence:      u16,
	length:        u32,
	window:        window_t,
}

xinerama_get_screen_size_cookie_t :: struct{
	sequence: ctypes.uint,
}

xinerama_get_screen_size_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	screen:       u32,
}

xinerama_get_screen_size_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	width:         u32,
	height:        u32,
	window:        window_t,
	screen:        u32,
}

xinerama_is_active_cookie_t :: struct{
	sequence: ctypes.uint,
}

xinerama_is_active_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

xinerama_is_active_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	state:         u32,
}

xinerama_query_screens_cookie_t :: struct{
	sequence: ctypes.uint,
}

xinerama_query_screens_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

xinerama_query_screens_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	number:        u32,
	pad1:          [20]u8,
}

input_fp3232_t :: struct{
	integral: i32,
	frac:     u32,
}

input_get_extension_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_get_extension_version_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	name_len:     u16,
	pad0:         [2]u8,
}

input_get_extension_version_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	server_major:  u16,
	server_minor:  u16,
	present:       u8,
	pad0:          [19]u8,
}

input_device_info_t :: struct{
	device_type:    atom_t,
	device_id:      u8,
	num_class_info: u8,
	device_use:     u8,
	pad0:           u8,
}

input_key_info_t :: struct{
	class_id:    u8,
	len:         u8,
	min_keycode: input_key_code_t,
	max_keycode: input_key_code_t,
	num_keys:    u16,
	pad0:        [2]u8,
}

input_button_info_t :: struct{
	class_id:    u8,
	len:         u8,
	num_buttons: u16,
}

input_axis_info_t :: struct{
	resolution: u32,
	minimum:    i32,
	maximum:    i32,
}

input_valuator_info_t :: struct{
	class_id:    u8,
	len:         u8,
	axes_len:    u8,
	mode:        u8,
	motion_size: u32,
}

input_input_info_info_t :: struct{
	min_keycode: input_key_code_t,
	max_keycode: input_key_code_t,
	num_keys:    u16,
	pad0:        [2]u8,
}

input_input_info_t :: struct{
	class_id: u8,
	len:      u8,
}

input_device_name_t :: struct{
	len: u8,
}

input_list_input_devices_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_list_input_devices_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

input_list_input_devices_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	devices_len:   u8,
	pad0:          [23]u8,
}

input_input_class_info_t :: struct{
	class_id:        u8,
	event_type_base: input_event_type_base_t,
}

input_open_device_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_open_device_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	device_id:    u8,
	pad0:         [3]u8,
}

input_open_device_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	num_classes:   u8,
	pad0:          [23]u8,
}

input_close_device_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	device_id:    u8,
	pad0:         [3]u8,
}

input_set_device_mode_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_set_device_mode_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	device_id:    u8,
	mode:         u8,
	pad0:         [2]u8,
}

input_set_device_mode_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	status:        u8,
	pad0:          [23]u8,
}

input_select_extension_event_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	num_classes:  u16,
	pad0:         [2]u8,
}

input_get_selected_extension_events_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_get_selected_extension_events_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

input_get_selected_extension_events_reply_t :: struct{
	response_type:    u8,
	xi_reply_type:    u8,
	sequence:         u16,
	length:           u32,
	num_this_classes: u16,
	num_all_classes:  u16,
	pad0:             [20]u8,
}

input_change_device_dont_propagate_list_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	num_classes:  u16,
	mode:         u8,
	pad0:         u8,
}

input_get_device_dont_propagate_list_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_get_device_dont_propagate_list_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

input_get_device_dont_propagate_list_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	num_classes:   u16,
	pad0:          [22]u8,
}

input_device_time_coord_t :: struct{
	time: timestamp_t,
}

input_get_device_motion_events_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_get_device_motion_events_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	start:        timestamp_t,
	stop:         timestamp_t,
	device_id:    u8,
	pad0:         [3]u8,
}

input_get_device_motion_events_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	num_events:    u32,
	num_axes:      u8,
	device_mode:   u8,
	pad0:          [18]u8,
}

input_change_keyboard_device_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_change_keyboard_device_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	device_id:    u8,
	pad0:         [3]u8,
}

input_change_keyboard_device_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	status:        u8,
	pad0:          [23]u8,
}

input_change_pointer_device_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_change_pointer_device_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	x_axis:       u8,
	y_axis:       u8,
	device_id:    u8,
	pad0:         u8,
}

input_change_pointer_device_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	status:        u8,
	pad0:          [23]u8,
}

input_grab_device_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_grab_device_request_t :: struct{
	major_opcode:      u8,
	minor_opcode:      u8,
	length:            u16,
	grab_window:       window_t,
	time:              timestamp_t,
	num_classes:       u16,
	this_device_mode:  u8,
	other_device_mode: u8,
	owner_events:      u8,
	device_id:         u8,
	pad0:              [2]u8,
}

input_grab_device_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	status:        u8,
	pad0:          [23]u8,
}

input_ungrab_device_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	time:         timestamp_t,
	device_id:    u8,
	pad0:         [3]u8,
}

input_grab_device_key_request_t :: struct{
	major_opcode:      u8,
	minor_opcode:      u8,
	length:            u16,
	grab_window:       window_t,
	num_classes:       u16,
	modifiers:         u16,
	modifier_device:   u8,
	grabbed_device:    u8,
	key:               u8,
	this_device_mode:  u8,
	other_device_mode: u8,
	owner_events:      u8,
	pad0:              [2]u8,
}

input_ungrab_device_key_request_t :: struct{
	major_opcode:    u8,
	minor_opcode:    u8,
	length:          u16,
	grabWindow:      window_t,
	modifiers:       u16,
	modifier_device: u8,
	key:             u8,
	grabbed_device:  u8,
}

input_grab_device_button_request_t :: struct{
	major_opcode:      u8,
	minor_opcode:      u8,
	length:            u16,
	grab_window:       window_t,
	grabbed_device:    u8,
	modifier_device:   u8,
	num_classes:       u16,
	modifiers:         u16,
	this_device_mode:  u8,
	other_device_mode: u8,
	button:            u8,
	owner_events:      u8,
	pad0:              [2]u8,
}

input_ungrab_device_button_request_t :: struct{
	major_opcode:    u8,
	minor_opcode:    u8,
	length:          u16,
	grab_window:     window_t,
	modifiers:       u16,
	modifier_device: u8,
	button:          u8,
	grabbed_device:  u8,
	pad0:            [3]u8,
}

input_allow_device_events_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	time:         timestamp_t,
	mode:         u8,
	device_id:    u8,
	pad0:         [2]u8,
}

input_get_device_focus_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_get_device_focus_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	device_id:    u8,
	pad0:         [3]u8,
}

input_get_device_focus_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	focus:         window_t,
	time:          timestamp_t,
	revert_to:     u8,
	pad0:          [15]u8,
}

input_set_device_focus_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	focus:        window_t,
	time:         timestamp_t,
	revert_to:    u8,
	device_id:    u8,
	pad0:         [2]u8,
}

input_kbd_feedback_state_t :: struct{
	class_id:           u8,
	feedback_id:        u8,
	len:                u16,
	pitch:              u16,
	duration:           u16,
	led_mask:           u32,
	led_values:         u32,
	global_auto_repeat: u8,
	click:              u8,
	percent:            u8,
	pad0:               u8,
	auto_repeats:       [32]u8,
}

input_ptr_feedback_state_t :: struct{
	class_id:    u8,
	feedback_id: u8,
	len:         u16,
	pad0:        [2]u8,
	accel_num:   u16,
	accel_denom: u16,
	threshold:   u16,
}

input_integer_feedback_state_t :: struct{
	class_id:    u8,
	feedback_id: u8,
	len:         u16,
	resolution:  u32,
	min_value:   i32,
	max_value:   i32,
}

input_string_feedback_state_t :: struct{
	class_id:    u8,
	feedback_id: u8,
	len:         u16,
	max_symbols: u16,
	num_keysyms: u16,
}

input_bell_feedback_state_t :: struct{
	class_id:    u8,
	feedback_id: u8,
	len:         u16,
	percent:     u8,
	pad0:        [3]u8,
	pitch:       u16,
	duration:    u16,
}

input_led_feedback_state_t :: struct{
	class_id:    u8,
	feedback_id: u8,
	len:         u16,
	led_mask:    u32,
	led_values:  u32,
}

input_feedback_state_data_t :: struct{
	pitch:              u16,
	duration:           u16,
	led_mask:           u32,
	led_values:         u32,
	global_auto_repeat: u8,
	click:              u8,
	percent:            u8,
	pad0:               u8,
	auto_repeats:       [32]u8,
}

input_feedback_state_t :: struct{
	class_id:    u8,
	feedback_id: u8,
	len:         u16,
}

input_get_feedback_control_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_get_feedback_control_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	device_id:    u8,
	pad0:         [3]u8,
}

input_get_feedback_control_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	num_feedbacks: u16,
	pad0:          [22]u8,
}

input_kbd_feedback_ctl_t :: struct{
	class_id:          u8,
	feedback_id:       u8,
	len:               u16,
	key:               input_key_code_t,
	auto_repeat_mode:  u8,
	key_click_percent: i8,
	bell_percent:      i8,
	bell_pitch:        i16,
	bell_duration:     i16,
	led_mask:          u32,
	led_values:        u32,
}

input_ptr_feedback_ctl_t :: struct{
	class_id:    u8,
	feedback_id: u8,
	len:         u16,
	pad0:        [2]u8,
	num:         i16,
	denom:       i16,
	threshold:   i16,
}

input_integer_feedback_ctl_t :: struct{
	class_id:       u8,
	feedback_id:    u8,
	len:            u16,
	int_to_display: i32,
}

input_string_feedback_ctl_t :: struct{
	class_id:    u8,
	feedback_id: u8,
	len:         u16,
	pad0:        [2]u8,
	num_keysyms: u16,
}

input_bell_feedback_ctl_t :: struct{
	class_id:    u8,
	feedback_id: u8,
	len:         u16,
	percent:     i8,
	pad0:        [3]u8,
	pitch:       i16,
	duration:    i16,
}

input_led_feedback_ctl_t :: struct{
	class_id:    u8,
	feedback_id: u8,
	len:         u16,
	led_mask:    u32,
	led_values:  u32,
}

input_feedback_ctl_data_t :: struct{
	key:               input_key_code_t,
	auto_repeat_mode:  u8,
	key_click_percent: i8,
	bell_percent:      i8,
	bell_pitch:        i16,
	bell_duration:     i16,
	led_mask:          u32,
	led_values:        u32,
}

input_feedback_ctl_t :: struct{
	class_id:    u8,
	feedback_id: u8,
	len:         u16,
}

input_change_feedback_control_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	mask:         u32,
	device_id:    u8,
	feedback_id:  u8,
	pad0:         [2]u8,
}

input_get_device_key_mapping_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_get_device_key_mapping_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	device_id:     u8,
	first_keycode: input_key_code_t,
	count:         u8,
	pad0:          u8,
}

input_get_device_key_mapping_reply_t :: struct{
	response_type:       u8,
	xi_reply_type:       u8,
	sequence:            u16,
	length:              u32,
	keysyms_per_keycode: u8,
	pad0:                [23]u8,
}

input_change_device_key_mapping_request_t :: struct{
	major_opcode:        u8,
	minor_opcode:        u8,
	length:              u16,
	device_id:           u8,
	first_keycode:       input_key_code_t,
	keysyms_per_keycode: u8,
	keycode_count:       u8,
}

input_get_device_modifier_mapping_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_get_device_modifier_mapping_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	device_id:    u8,
	pad0:         [3]u8,
}

input_get_device_modifier_mapping_reply_t :: struct{
	response_type:         u8,
	xi_reply_type:         u8,
	sequence:              u16,
	length:                u32,
	keycodes_per_modifier: u8,
	pad0:                  [23]u8,
}

input_set_device_modifier_mapping_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_set_device_modifier_mapping_request_t :: struct{
	major_opcode:          u8,
	minor_opcode:          u8,
	length:                u16,
	device_id:             u8,
	keycodes_per_modifier: u8,
	pad0:                  [2]u8,
}

input_set_device_modifier_mapping_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	status:        u8,
	pad0:          [23]u8,
}

input_get_device_button_mapping_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_get_device_button_mapping_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	device_id:    u8,
	pad0:         [3]u8,
}

input_get_device_button_mapping_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	map_size:      u8,
	pad0:          [23]u8,
}

input_set_device_button_mapping_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_set_device_button_mapping_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	device_id:    u8,
	map_size:     u8,
	pad0:         [2]u8,
}

input_set_device_button_mapping_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	status:        u8,
	pad0:          [23]u8,
}

input_key_state_t :: struct{
	class_id: u8,
	len:      u8,
	num_keys: u8,
	pad0:     u8,
	keys:     [32]u8,
}

input_button_state_t :: struct{
	class_id:    u8,
	len:         u8,
	num_buttons: u8,
	pad0:        u8,
	buttons:     [32]u8,
}

input_valuator_state_t :: struct{
	class_id:      u8,
	len:           u8,
	num_valuators: u8,
	mode:          u8,
}

input_input_state_data_t :: struct{
	num_keys: u8,
	pad0:     u8,
	keys:     [32]u8,
}

input_input_state_t :: struct{
	class_id: u8,
	len:      u8,
}

input_query_device_state_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_query_device_state_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	device_id:    u8,
	pad0:         [3]u8,
}

input_query_device_state_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	num_classes:   u8,
	pad0:          [23]u8,
}

input_device_bell_request_t :: struct{
	major_opcode:   u8,
	minor_opcode:   u8,
	length:         u16,
	device_id:      u8,
	feedback_id:    u8,
	feedback_class: u8,
	percent:        i8,
}

input_set_device_valuators_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_set_device_valuators_request_t :: struct{
	major_opcode:   u8,
	minor_opcode:   u8,
	length:         u16,
	device_id:      u8,
	first_valuator: u8,
	num_valuators:  u8,
	pad0:           u8,
}

input_set_device_valuators_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	status:        u8,
	pad0:          [23]u8,
}

input_device_resolution_state_t :: struct{
	control_id:    u16,
	len:           u16,
	num_valuators: u32,
}

input_device_abs_calib_state_t :: struct{
	control_id:       u16,
	len:              u16,
	min_x:            i32,
	max_x:            i32,
	min_y:            i32,
	max_y:            i32,
	flip_x:           u32,
	flip_y:           u32,
	rotation:         u32,
	button_threshold: u32,
}

input_device_abs_area_state_t :: struct{
	control_id: u16,
	len:        u16,
	offset_x:   u32,
	offset_y:   u32,
	width:      u32,
	height:     u32,
	screen:     u32,
	following:  u32,
}

input_device_core_state_t :: struct{
	control_id: u16,
	len:        u16,
	status:     u8,
	iscore:     u8,
	pad0:       [2]u8,
}

input_device_enable_state_t :: struct{
	control_id: u16,
	len:        u16,
	enable:     u8,
	pad0:       [3]u8,
}

input_device_state_data_t :: struct{
	num_valuators:     u32,
	resolution_values: ^u32,
	resolution_min:    ^u32,
	resolution_max:    ^u32,
}

input_device_state_t :: struct{
	control_id: u16,
	len:        u16,
}

input_get_device_control_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_get_device_control_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	control_id:   u16,
	device_id:    u8,
	pad0:         u8,
}

input_get_device_control_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	status:        u8,
	pad0:          [23]u8,
}

input_device_resolution_ctl_t :: struct{
	control_id:     u16,
	len:            u16,
	first_valuator: u8,
	num_valuators:  u8,
	pad0:           [2]u8,
}

input_device_abs_calib_ctl_t :: struct{
	control_id:       u16,
	len:              u16,
	min_x:            i32,
	max_x:            i32,
	min_y:            i32,
	max_y:            i32,
	flip_x:           u32,
	flip_y:           u32,
	rotation:         u32,
	button_threshold: u32,
}

input_device_abs_area_ctrl_t :: struct{
	control_id: u16,
	len:        u16,
	offset_x:   u32,
	offset_y:   u32,
	width:      i32,
	height:     i32,
	screen:     i32,
	following:  u32,
}

input_device_core_ctrl_t :: struct{
	control_id: u16,
	len:        u16,
	status:     u8,
	pad0:       [3]u8,
}

input_device_enable_ctrl_t :: struct{
	control_id: u16,
	len:        u16,
	enable:     u8,
	pad0:       [3]u8,
}

input_device_ctl_data_t :: struct{
	first_valuator:    u8,
	num_valuators:     u8,
	pad0:              [2]u8,
	resolution_values: ^u32,
}

input_device_ctl_t :: struct{
	control_id: u16,
	len:        u16,
}

input_change_device_control_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_change_device_control_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	control_id:   u16,
	device_id:    u8,
	pad0:         u8,
}

input_change_device_control_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	status:        u8,
	pad0:          [23]u8,
}

input_list_device_properties_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_list_device_properties_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	device_id:    u8,
	pad0:         [3]u8,
}

input_list_device_properties_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	num_atoms:     u16,
	pad0:          [22]u8,
}

input_change_device_property_items_t :: struct{
	data8:  ^u8,
	data16: ^u16,
	data32: ^u32,
}

input_change_device_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	property:     atom_t,
	type:         atom_t,
	device_id:    u8,
	format:       u8,
	mode:         u8,
	pad0:         u8,
	num_items:    u32,
}

input_delete_device_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	property:     atom_t,
	device_id:    u8,
	pad0:         [3]u8,
}

input_get_device_property_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_get_device_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	property:     atom_t,
	type:         atom_t,
	offset:       u32,
	len:          u32,
	device_id:    u8,
	_delete:      u8,
	pad0:         [2]u8,
}

input_get_device_property_items_t :: struct{
	data8:  ^u8,
	data16: ^u16,
	data32: ^u32,
}

input_get_device_property_reply_t :: struct{
	response_type: u8,
	xi_reply_type: u8,
	sequence:      u16,
	length:        u32,
	type:          atom_t,
	bytes_after:   u32,
	num_items:     u32,
	format:        u8,
	device_id:     u8,
	pad0:          [10]u8,
}

input_group_info_t :: struct{
	base:      u8,
	latched:   u8,
	locked:    u8,
	effective: u8,
}

input_modifier_info_t :: struct{
	base:      u32,
	latched:   u32,
	locked:    u32,
	effective: u32,
}

input_xi_query_pointer_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_xi_query_pointer_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	deviceid:     input_device_id_t,
	pad0:         [2]u8,
}

input_xi_query_pointer_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	root:          window_t,
	child:         window_t,
	root_x:        input_fp1616_t,
	root_y:        input_fp1616_t,
	win_x:         input_fp1616_t,
	win_y:         input_fp1616_t,
	same_screen:   u8,
	pad1:          u8,
	buttons_len:   u16,
	mods:          input_modifier_info_t,
	group:         input_group_info_t,
}

input_xi_warp_pointer_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	src_win:      window_t,
	dst_win:      window_t,
	src_x:        input_fp1616_t,
	src_y:        input_fp1616_t,
	src_width:    u16,
	src_height:   u16,
	dst_x:        input_fp1616_t,
	dst_y:        input_fp1616_t,
	deviceid:     input_device_id_t,
	pad0:         [2]u8,
}

input_xi_change_cursor_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	cursor:       cursor_t,
	deviceid:     input_device_id_t,
	pad0:         [2]u8,
}

input_add_master_t :: struct{
	type:      u16,
	len:       u16,
	name_len:  u16,
	send_core: u8,
	enable:    u8,
}

input_remove_master_t :: struct{
	type:            u16,
	len:             u16,
	deviceid:        input_device_id_t,
	return_mode:     u8,
	pad0:            u8,
	return_pointer:  input_device_id_t,
	return_keyboard: input_device_id_t,
}

input_attach_slave_t :: struct{
	type:     u16,
	len:      u16,
	deviceid: input_device_id_t,
	master:   input_device_id_t,
}

input_detach_slave_t :: struct{
	type:     u16,
	len:      u16,
	deviceid: input_device_id_t,
	pad0:     [2]u8,
}

input_hierarchy_change_data_t :: struct{
	name_len:  u16,
	send_core: u8,
	enable:    u8,
	name:      cstring,
}

input_hierarchy_change_t :: struct{
	type: u16,
	len:  u16,
}

input_xi_change_hierarchy_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	num_changes:  u8,
	pad0:         [3]u8,
}

input_xi_set_client_pointer_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	deviceid:     input_device_id_t,
	pad0:         [2]u8,
}

input_xi_get_client_pointer_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_xi_get_client_pointer_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

input_xi_get_client_pointer_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	set:           u8,
	pad1:          u8,
	deviceid:      input_device_id_t,
	pad2:          [20]u8,
}

input_event_mask_t :: struct{
	deviceid: input_device_id_t,
	mask_len: u16,
}

input_xi_select_events_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	num_mask:     u16,
	pad0:         [2]u8,
}

input_xi_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_xi_query_version_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	major_version: u16,
	minor_version: u16,
}

input_xi_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u16,
	minor_version: u16,
	pad1:          [20]u8,
}

input_button_class_t :: struct{
	type:        u16,
	len:         u16,
	sourceid:    input_device_id_t,
	num_buttons: u16,
}

input_key_class_t :: struct{
	type:     u16,
	len:      u16,
	sourceid: input_device_id_t,
	num_keys: u16,
}

input_scroll_class_t :: struct{
	type:        u16,
	len:         u16,
	sourceid:    input_device_id_t,
	number:      u16,
	scroll_type: u16,
	pad0:        [2]u8,
	flags:       u32,
	increment:   input_fp3232_t,
}

input_touch_class_t :: struct{
	type:        u16,
	len:         u16,
	sourceid:    input_device_id_t,
	mode:        u8,
	num_touches: u8,
}

input_gesture_class_t :: struct{
	type:        u16,
	len:         u16,
	sourceid:    input_device_id_t,
	num_touches: u8,
	pad0:        u8,
}

input_valuator_class_t :: struct{
	type:       u16,
	len:        u16,
	sourceid:   input_device_id_t,
	number:     u16,
	label:      atom_t,
	min:        input_fp3232_t,
	max:        input_fp3232_t,
	value:      input_fp3232_t,
	resolution: u32,
	mode:       u8,
	pad0:       [3]u8,
}

input_device_class_data_t :: struct{
	num_keys: u16,
	keys:     ^u32,
}

input_device_class_t :: struct{
	type:     u16,
	len:      u16,
	sourceid: input_device_id_t,
}

input_xi_device_info_t :: struct{
	deviceid:    input_device_id_t,
	type:        u16,
	attachment:  input_device_id_t,
	num_classes: u16,
	name_len:    u16,
	enabled:     u8,
	pad0:        u8,
}

input_xi_query_device_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_xi_query_device_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceid:     input_device_id_t,
	pad0:         [2]u8,
}

input_xi_query_device_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_infos:     u16,
	pad1:          [22]u8,
}

input_xi_set_focus_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	time:         timestamp_t,
	deviceid:     input_device_id_t,
	pad0:         [2]u8,
}

input_xi_get_focus_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_xi_get_focus_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceid:     input_device_id_t,
	pad0:         [2]u8,
}

input_xi_get_focus_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	focus:         window_t,
	pad1:          [20]u8,
}

input_xi_grab_device_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_xi_grab_device_request_t :: struct{
	major_opcode:       u8,
	minor_opcode:       u8,
	length:             u16,
	window:             window_t,
	time:               timestamp_t,
	cursor:             cursor_t,
	deviceid:           input_device_id_t,
	mode:               u8,
	paired_device_mode: u8,
	owner_events:       u8,
	pad0:               u8,
	mask_len:           u16,
}

input_xi_grab_device_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	status:        u8,
	pad1:          [23]u8,
}

input_xi_ungrab_device_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	time:         timestamp_t,
	deviceid:     input_device_id_t,
	pad0:         [2]u8,
}

input_xi_allow_events_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	time:         timestamp_t,
	deviceid:     input_device_id_t,
	event_mode:   u8,
	pad0:         u8,
	touchid:      u32,
	grab_window:  window_t,
}

input_grab_modifier_info_t :: struct{
	modifiers: u32,
	status:    u8,
	pad0:      [3]u8,
}

input_xi_passive_grab_device_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_xi_passive_grab_device_request_t :: struct{
	major_opcode:       u8,
	minor_opcode:       u8,
	length:             u16,
	time:               timestamp_t,
	grab_window:        window_t,
	cursor:             cursor_t,
	detail:             u32,
	deviceid:           input_device_id_t,
	num_modifiers:      u16,
	mask_len:           u16,
	grab_type:          u8,
	grab_mode:          u8,
	paired_device_mode: u8,
	owner_events:       u8,
	pad0:               [2]u8,
}

input_xi_passive_grab_device_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_modifiers: u16,
	pad1:          [22]u8,
}

input_xi_passive_ungrab_device_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	grab_window:   window_t,
	detail:        u32,
	deviceid:      input_device_id_t,
	num_modifiers: u16,
	grab_type:     u8,
	pad0:          [3]u8,
}

input_xi_list_properties_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_xi_list_properties_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceid:     input_device_id_t,
	pad0:         [2]u8,
}

input_xi_list_properties_reply_t :: struct{
	response_type:  u8,
	pad0:           u8,
	sequence:       u16,
	length:         u32,
	num_properties: u16,
	pad1:           [22]u8,
}

input_xi_change_property_items_t :: struct{
	data8:  ^u8,
	data16: ^u16,
	data32: ^u32,
}

input_xi_change_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceid:     input_device_id_t,
	mode:         u8,
	format:       u8,
	property:     atom_t,
	type:         atom_t,
	num_items:    u32,
}

input_xi_delete_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceid:     input_device_id_t,
	pad0:         [2]u8,
	property:     atom_t,
}

input_xi_get_property_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_xi_get_property_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceid:     input_device_id_t,
	_delete:      u8,
	pad0:         u8,
	property:     atom_t,
	type:         atom_t,
	offset:       u32,
	len:          u32,
}

input_xi_get_property_items_t :: struct{
	data8:  ^u8,
	data16: ^u16,
	data32: ^u32,
}

input_xi_get_property_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	type:          atom_t,
	bytes_after:   u32,
	num_items:     u32,
	format:        u8,
	pad1:          [11]u8,
}

input_xi_get_selected_events_cookie_t :: struct{
	sequence: ctypes.uint,
}

input_xi_get_selected_events_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

input_xi_get_selected_events_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_masks:     u16,
	pad1:          [22]u8,
}

input_barrier_release_pointer_info_t :: struct{
	deviceid: input_device_id_t,
	pad0:     [2]u8,
	barrier:  xfixes_barrier_t,
	eventid:  u32,
}

input_xi_barrier_release_pointer_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	num_barriers: u32,
}

input_device_valuator_event_t :: struct{
	response_type:  u8,
	device_id:      u8,
	sequence:       u16,
	device_state:   u16,
	num_valuators:  u8,
	first_valuator: u8,
	valuators:      [6]i32,
}

input_device_key_press_event_t :: struct{
	response_type: u8,
	detail:        u8,
	sequence:      u16,
	time:          timestamp_t,
	root:          window_t,
	event:         window_t,
	child:         window_t,
	root_x:        i16,
	root_y:        i16,
	event_x:       i16,
	event_y:       i16,
	state:         u16,
	same_screen:   u8,
	device_id:     u8,
}

input_device_focus_in_event_t :: struct{
	response_type: u8,
	detail:        u8,
	sequence:      u16,
	time:          timestamp_t,
	window:        window_t,
	mode:          u8,
	device_id:     u8,
	pad0:          [18]u8,
}

input_device_state_notify_event_t :: struct{
	response_type:    u8,
	device_id:        u8,
	sequence:         u16,
	time:             timestamp_t,
	num_keys:         u8,
	num_buttons:      u8,
	num_valuators:    u8,
	classes_reported: u8,
	buttons:          [4]u8,
	keys:             [4]u8,
	valuators:        [3]u32,
}

input_device_mapping_notify_event_t :: struct{
	response_type: u8,
	device_id:     u8,
	sequence:      u16,
	request:       u8,
	first_keycode: input_key_code_t,
	count:         u8,
	pad0:          u8,
	time:          timestamp_t,
	pad1:          [20]u8,
}

input_change_device_notify_event_t :: struct{
	response_type: u8,
	device_id:     u8,
	sequence:      u16,
	time:          timestamp_t,
	request:       u8,
	pad0:          [23]u8,
}

input_device_key_state_notify_event_t :: struct{
	response_type: u8,
	device_id:     u8,
	sequence:      u16,
	keys:          [28]u8,
}

input_device_button_state_notify_event_t :: struct{
	response_type: u8,
	device_id:     u8,
	sequence:      u16,
	buttons:       [28]u8,
}

input_device_presence_notify_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	time:          timestamp_t,
	devchange:     u8,
	device_id:     u8,
	control:       u16,
	pad1:          [20]u8,
}

input_device_property_notify_event_t :: struct{
	response_type: u8,
	state:         u8,
	sequence:      u16,
	time:          timestamp_t,
	property:      atom_t,
	pad0:          [19]u8,
	device_id:     u8,
}

input_device_changed_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	deviceid:      input_device_id_t,
	time:          timestamp_t,
	num_classes:   u16,
	sourceid:      input_device_id_t,
	reason:        u8,
	pad0:          [11]u8,
	full_sequence: u32,
}

input_key_press_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	deviceid:      input_device_id_t,
	time:          timestamp_t,
	detail:        u32,
	root:          window_t,
	event:         window_t,
	child:         window_t,
	full_sequence: u32,
	root_x:        input_fp1616_t,
	root_y:        input_fp1616_t,
	event_x:       input_fp1616_t,
	event_y:       input_fp1616_t,
	buttons_len:   u16,
	valuators_len: u16,
	sourceid:      input_device_id_t,
	pad0:          [2]u8,
	flags:         u32,
	mods:          input_modifier_info_t,
	group:         input_group_info_t,
}

input_button_press_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	deviceid:      input_device_id_t,
	time:          timestamp_t,
	detail:        u32,
	root:          window_t,
	event:         window_t,
	child:         window_t,
	full_sequence: u32,
	root_x:        input_fp1616_t,
	root_y:        input_fp1616_t,
	event_x:       input_fp1616_t,
	event_y:       input_fp1616_t,
	buttons_len:   u16,
	valuators_len: u16,
	sourceid:      input_device_id_t,
	pad0:          [2]u8,
	flags:         u32,
	mods:          input_modifier_info_t,
	group:         input_group_info_t,
}

input_enter_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	deviceid:      input_device_id_t,
	time:          timestamp_t,
	sourceid:      input_device_id_t,
	mode:          u8,
	detail:        u8,
	root:          window_t,
	event:         window_t,
	child:         window_t,
	full_sequence: u32,
	root_x:        input_fp1616_t,
	root_y:        input_fp1616_t,
	event_x:       input_fp1616_t,
	event_y:       input_fp1616_t,
	same_screen:   u8,
	focus:         u8,
	buttons_len:   u16,
	mods:          input_modifier_info_t,
	group:         input_group_info_t,
}

input_hierarchy_info_t :: struct{
	deviceid:   input_device_id_t,
	attachment: input_device_id_t,
	type:       u8,
	enabled:    u8,
	pad0:       [2]u8,
	flags:      u32,
}

input_hierarchy_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	deviceid:      input_device_id_t,
	time:          timestamp_t,
	flags:         u32,
	num_infos:     u16,
	pad0:          [10]u8,
	full_sequence: u32,
}

input_property_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	deviceid:      input_device_id_t,
	time:          timestamp_t,
	property:      atom_t,
	what:          u8,
	pad0:          [11]u8,
	full_sequence: u32,
}

input_raw_key_press_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	deviceid:      input_device_id_t,
	time:          timestamp_t,
	detail:        u32,
	sourceid:      input_device_id_t,
	valuators_len: u16,
	flags:         u32,
	pad0:          [4]u8,
	full_sequence: u32,
}

input_raw_button_press_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	deviceid:      input_device_id_t,
	time:          timestamp_t,
	detail:        u32,
	sourceid:      input_device_id_t,
	valuators_len: u16,
	flags:         u32,
	pad0:          [4]u8,
	full_sequence: u32,
}

input_touch_begin_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	deviceid:      input_device_id_t,
	time:          timestamp_t,
	detail:        u32,
	root:          window_t,
	event:         window_t,
	child:         window_t,
	full_sequence: u32,
	root_x:        input_fp1616_t,
	root_y:        input_fp1616_t,
	event_x:       input_fp1616_t,
	event_y:       input_fp1616_t,
	buttons_len:   u16,
	valuators_len: u16,
	sourceid:      input_device_id_t,
	pad0:          [2]u8,
	flags:         u32,
	mods:          input_modifier_info_t,
	group:         input_group_info_t,
}

input_touch_ownership_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	deviceid:      input_device_id_t,
	time:          timestamp_t,
	touchid:       u32,
	root:          window_t,
	event:         window_t,
	child:         window_t,
	full_sequence: u32,
	sourceid:      input_device_id_t,
	pad0:          [2]u8,
	flags:         u32,
	pad1:          [8]u8,
}

input_raw_touch_begin_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	deviceid:      input_device_id_t,
	time:          timestamp_t,
	detail:        u32,
	sourceid:      input_device_id_t,
	valuators_len: u16,
	flags:         u32,
	pad0:          [4]u8,
	full_sequence: u32,
}

input_barrier_hit_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	deviceid:      input_device_id_t,
	time:          timestamp_t,
	eventid:       u32,
	root:          window_t,
	event:         window_t,
	barrier:       xfixes_barrier_t,
	full_sequence: u32,
	dtime:         u32,
	flags:         u32,
	sourceid:      input_device_id_t,
	pad0:          [2]u8,
	root_x:        input_fp1616_t,
	root_y:        input_fp1616_t,
	dx:            input_fp3232_t,
	dy:            input_fp3232_t,
}

input_gesture_pinch_begin_event_t :: struct{
	response_type:   u8,
	extension:       u8,
	sequence:        u16,
	length:          u32,
	event_type:      u16,
	deviceid:        input_device_id_t,
	time:            timestamp_t,
	detail:          u32,
	root:            window_t,
	event:           window_t,
	child:           window_t,
	full_sequence:   u32,
	root_x:          input_fp1616_t,
	root_y:          input_fp1616_t,
	event_x:         input_fp1616_t,
	event_y:         input_fp1616_t,
	delta_x:         input_fp1616_t,
	delta_y:         input_fp1616_t,
	delta_unaccel_x: input_fp1616_t,
	delta_unaccel_y: input_fp1616_t,
	scale:           input_fp1616_t,
	delta_angle:     input_fp1616_t,
	sourceid:        input_device_id_t,
	pad0:            [2]u8,
	mods:            input_modifier_info_t,
	group:           input_group_info_t,
	flags:           u32,
}

input_gesture_swipe_begin_event_t :: struct{
	response_type:   u8,
	extension:       u8,
	sequence:        u16,
	length:          u32,
	event_type:      u16,
	deviceid:        input_device_id_t,
	time:            timestamp_t,
	detail:          u32,
	root:            window_t,
	event:           window_t,
	child:           window_t,
	full_sequence:   u32,
	root_x:          input_fp1616_t,
	root_y:          input_fp1616_t,
	event_x:         input_fp1616_t,
	event_y:         input_fp1616_t,
	delta_x:         input_fp1616_t,
	delta_y:         input_fp1616_t,
	delta_unaccel_x: input_fp1616_t,
	delta_unaccel_y: input_fp1616_t,
	sourceid:        input_device_id_t,
	pad0:            [2]u8,
	mods:            input_modifier_info_t,
	group:           input_group_info_t,
	flags:           u32,
}

input_event_for_send_t :: struct#raw_union {
	device_valuator:            input_device_valuator_event_t,
	device_key_press:           input_device_key_press_event_t,
	device_key_release:         input_device_key_release_event_t,
	device_button_press:        input_device_button_press_event_t,
	device_button_release:      input_device_button_release_event_t,
	device_motion_notify:       input_device_motion_notify_event_t,
	device_focus_in:            input_device_focus_in_event_t,
	device_focus_out:           input_device_focus_out_event_t,
	proximity_in:               input_proximity_in_event_t,
	proximity_out:              input_proximity_out_event_t,
	device_state_notify:        input_device_state_notify_event_t,
	device_mapping_notify:      input_device_mapping_notify_event_t,
	change_device_notify:       input_change_device_notify_event_t,
	device_key_state_notify:    input_device_key_state_notify_event_t,
	device_button_state_notify: input_device_button_state_notify_event_t,
	device_presence_notify:     input_device_presence_notify_event_t,
	event_header:               raw_generic_event_t,
}

input_send_extension_event_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	destination:  window_t,
	device_id:    u8,
	propagate:    u8,
	num_classes:  u16,
	num_events:   u8,
	pad0:         [3]u8,
}

input_device_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

input_event_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

input_mode_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

input_device_busy_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

input_class_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

xkb_indicator_map_t :: struct{
	flags:       u8,
	whichGroups: u8,
	groups:      u8,
	whichMods:   u8,
	mods:        u8,
	realMods:    u8,
	vmods:       u16,
	ctrls:       u32,
}

xkb_mod_def_t :: struct{
	mask:     u8,
	realMods: u8,
	vmods:    u16,
}

xkb_key_name_t :: struct{
	name: [4]byte,
}

xkb_key_alias_t :: struct{
	real:  [4]byte,
	alias: [4]byte,
}

xkb_counted_string_16_t :: struct{
	length: u16,
}

xkb_kt_map_entry_t :: struct{
	active:     u8,
	mods_mask:  u8,
	level:      u8,
	mods_mods:  u8,
	mods_vmods: u16,
	pad0:       [2]u8,
}

xkb_key_type_t :: struct{
	mods_mask:   u8,
	mods_mods:   u8,
	mods_vmods:  u16,
	numLevels:   u8,
	nMapEntries: u8,
	hasPreserve: u8,
	pad0:        u8,
}

xkb_key_sym_map_t :: struct{
	kt_index:  [4]u8,
	groupInfo: u8,
	width:     u8,
	nSyms:     u16,
}

xkb_common_behavior_t :: struct{
	type: u8,
	data: u8,
}

xkb_default_behavior_t :: struct{
	type: u8,
	pad0: u8,
}

xkb_lock_behavior_t :: struct{
	type: u8,
	pad0: u8,
}

xkb_radio_group_behavior_t :: struct{
	type:  u8,
	group: u8,
}

xkb_overlay_behavior_t :: struct{
	type: u8,
	key:  keycode_t,
}

xkb_permament_lock_behavior_t :: struct{
	type: u8,
	pad0: u8,
}

xkb_permament_radio_group_behavior_t :: struct{
	type:  u8,
	group: u8,
}

xkb_permament_overlay_behavior_t :: struct{
	type: u8,
	key:  keycode_t,
}

xkb_behavior_t :: struct#raw_union {
	common:              xkb_common_behavior_t,
	_default:            xkb_default_behavior_t,
	lock:                xkb_lock_behavior_t,
	radioGroup:          xkb_radio_group_behavior_t,
	overlay1:            xkb_overlay_behavior_t,
	overlay2:            xkb_overlay_behavior_t,
	permamentLock:       xkb_permament_lock_behavior_t,
	permamentRadioGroup: xkb_permament_radio_group_behavior_t,
	permamentOverlay1:   xkb_permament_overlay_behavior_t,
	permamentOverlay2:   xkb_permament_overlay_behavior_t,
	type:                u8,
}

xkb_set_behavior_t :: struct{
	keycode:  keycode_t,
	behavior: xkb_behavior_t,
	pad0:     u8,
}

xkb_set_explicit_t :: struct{
	keycode:  keycode_t,
	explicit: u8,
}

xkb_key_mod_map_t :: struct{
	keycode: keycode_t,
	mods:    u8,
}

xkb_key_v_mod_map_t :: struct{
	keycode: keycode_t,
	pad0:    u8,
	vmods:   u16,
}

xkb_kt_set_map_entry_t :: struct{
	level:       u8,
	realMods:    u8,
	virtualMods: u16,
}

xkb_set_key_type_t :: struct{
	mask:        u8,
	realMods:    u8,
	virtualMods: u16,
	numLevels:   u8,
	nMapEntries: u8,
	preserve:    u8,
	pad0:        u8,
}

xkb_outline_t :: struct{
	nPoints:      u8,
	cornerRadius: u8,
	pad0:         [2]u8,
}

xkb_shape_t :: struct{
	name:       atom_t,
	nOutlines:  u8,
	primaryNdx: u8,
	approxNdx:  u8,
	pad0:       u8,
}

xkb_key_t :: struct{
	name:     [4]xkb_string8_t,
	gap:      i16,
	shapeNdx: u8,
	colorNdx: u8,
}

xkb_overlay_key_t :: struct{
	over:  [4]xkb_string8_t,
	under: [4]xkb_string8_t,
}

xkb_overlay_row_t :: struct{
	rowUnder: u8,
	nKeys:    u8,
	pad0:     [2]u8,
}

xkb_overlay_t :: struct{
	name:  atom_t,
	nRows: u8,
	pad0:  [3]u8,
}

xkb_row_t :: struct{
	top:      i16,
	left:     i16,
	nKeys:    u8,
	vertical: u8,
	pad0:     [2]u8,
}

xkb_listing_t :: struct{
	flags:  u16,
	length: u16,
}

xkb_device_led_info_t :: struct{
	ledClass:       xkb_led_class_spec_t,
	ledID:          xkb_id_spec_t,
	namesPresent:   u32,
	mapsPresent:    u32,
	physIndicators: u32,
	state:          u32,
}

xkb_keyboard_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	value:         u32,
	minorOpcode:   u16,
	majorOpcode:   u8,
	pad0:          [21]u8,
}

xkb_sa_no_action_t :: struct{
	type: u8,
	pad0: [7]u8,
}

xkb_sa_set_mods_t :: struct{
	type:      u8,
	flags:     u8,
	mask:      u8,
	realMods:  u8,
	vmodsHigh: u8,
	vmodsLow:  u8,
	pad0:      [2]u8,
}

xkb_sa_latch_mods_t :: struct{
	type:      u8,
	flags:     u8,
	mask:      u8,
	realMods:  u8,
	vmodsHigh: u8,
	vmodsLow:  u8,
	pad0:      [2]u8,
}

xkb_sa_lock_mods_t :: struct{
	type:      u8,
	flags:     u8,
	mask:      u8,
	realMods:  u8,
	vmodsHigh: u8,
	vmodsLow:  u8,
	pad0:      [2]u8,
}

xkb_sa_set_group_t :: struct{
	type:  u8,
	flags: u8,
	group: i8,
	pad0:  [5]u8,
}

xkb_sa_latch_group_t :: struct{
	type:  u8,
	flags: u8,
	group: i8,
	pad0:  [5]u8,
}

xkb_sa_lock_group_t :: struct{
	type:  u8,
	flags: u8,
	group: i8,
	pad0:  [5]u8,
}

xkb_sa_move_ptr_t :: struct{
	type:  u8,
	flags: u8,
	xHigh: i8,
	xLow:  u8,
	yHigh: i8,
	yLow:  u8,
	pad0:  [2]u8,
}

xkb_sa_ptr_btn_t :: struct{
	type:   u8,
	flags:  u8,
	count:  u8,
	button: u8,
	pad0:   [4]u8,
}

xkb_sa_lock_ptr_btn_t :: struct{
	type:   u8,
	flags:  u8,
	pad0:   u8,
	button: u8,
	pad1:   [4]u8,
}

xkb_sa_set_ptr_dflt_t :: struct{
	type:   u8,
	flags:  u8,
	affect: u8,
	value:  i8,
	pad0:   [4]u8,
}

xkb_sa_iso_lock_t :: struct{
	type:      u8,
	flags:     u8,
	mask:      u8,
	realMods:  u8,
	group:     i8,
	affect:    u8,
	vmodsHigh: u8,
	vmodsLow:  u8,
}

xkb_sa_terminate_t :: struct{
	type: u8,
	pad0: [7]u8,
}

xkb_sa_switch_screen_t :: struct{
	type:      u8,
	flags:     u8,
	newScreen: i8,
	pad0:      [5]u8,
}

xkb_sa_set_controls_t :: struct{
	type:          u8,
	pad0:          [3]u8,
	boolCtrlsHigh: u8,
	boolCtrlsLow:  u8,
	pad1:          [2]u8,
}

xkb_sa_lock_controls_t :: struct{
	type:          u8,
	pad0:          [3]u8,
	boolCtrlsHigh: u8,
	boolCtrlsLow:  u8,
	pad1:          [2]u8,
}

xkb_sa_action_message_t :: struct{
	type:    u8,
	flags:   u8,
	message: [6]u8,
}

xkb_sa_redirect_key_t :: struct{
	type:          u8,
	newkey:        keycode_t,
	mask:          u8,
	realModifiers: u8,
	vmodsMaskHigh: u8,
	vmodsMaskLow:  u8,
	vmodsHigh:     u8,
	vmodsLow:      u8,
}

xkb_sa_device_btn_t :: struct{
	type:   u8,
	flags:  u8,
	count:  u8,
	button: u8,
	device: u8,
	pad0:   [3]u8,
}

xkb_sa_lock_device_btn_t :: struct{
	type:   u8,
	flags:  u8,
	pad0:   u8,
	button: u8,
	device: u8,
	pad1:   [3]u8,
}

xkb_sa_device_valuator_t :: struct{
	type:      u8,
	device:    u8,
	val1what:  u8,
	val1index: u8,
	val1value: u8,
	val2what:  u8,
	val2index: u8,
	val2value: u8,
}

xkb_si_action_t :: struct{
	type: u8,
	data: [7]u8,
}

xkb_sym_interpret_t :: struct{
	sym:        keysym_t,
	mods:       u8,
	match:      u8,
	virtualMod: u8,
	flags:      u8,
	action:     xkb_si_action_t,
}

xkb_action_t :: struct#raw_union {
	noaction:     xkb_sa_no_action_t,
	setmods:      xkb_sa_set_mods_t,
	latchmods:    xkb_sa_latch_mods_t,
	lockmods:     xkb_sa_lock_mods_t,
	setgroup:     xkb_sa_set_group_t,
	latchgroup:   xkb_sa_latch_group_t,
	lockgroup:    xkb_sa_lock_group_t,
	moveptr:      xkb_sa_move_ptr_t,
	ptrbtn:       xkb_sa_ptr_btn_t,
	lockptrbtn:   xkb_sa_lock_ptr_btn_t,
	setptrdflt:   xkb_sa_set_ptr_dflt_t,
	isolock:      xkb_sa_iso_lock_t,
	terminate:    xkb_sa_terminate_t,
	switchscreen: xkb_sa_switch_screen_t,
	setcontrols:  xkb_sa_set_controls_t,
	lockcontrols: xkb_sa_lock_controls_t,
	message:      xkb_sa_action_message_t,
	redirect:     xkb_sa_redirect_key_t,
	devbtn:       xkb_sa_device_btn_t,
	lockdevbtn:   xkb_sa_lock_device_btn_t,
	devval:       xkb_sa_device_valuator_t,
	type:         u8,
}

xkb_use_extension_cookie_t :: struct{
	sequence: ctypes.uint,
}

xkb_use_extension_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	wantedMajor:  u16,
	wantedMinor:  u16,
}

xkb_use_extension_reply_t :: struct{
	response_type: u8,
	supported:     u8,
	sequence:      u16,
	length:        u32,
	serverMajor:   u16,
	serverMinor:   u16,
	pad0:          [20]u8,
}

xkb_select_events_details_t :: struct{
	affectNewKeyboard:     u16,
	newKeyboardDetails:    u16,
	affectState:           u16,
	stateDetails:          u16,
	affectCtrls:           u32,
	ctrlDetails:           u32,
	affectIndicatorState:  u32,
	indicatorStateDetails: u32,
	affectIndicatorMap:    u32,
	indicatorMapDetails:   u32,
	affectNames:           u16,
	namesDetails:          u16,
	affectCompat:          u8,
	compatDetails:         u8,
	affectBell:            u8,
	bellDetails:           u8,
	affectMsgDetails:      u8,
	msgDetails:            u8,
	affectAccessX:         u16,
	accessXDetails:        u16,
	affectExtDev:          u16,
	extdevDetails:         u16,
}

xkb_select_events_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceSpec:   xkb_device_spec_t,
	affectWhich:  u16,
	clear:        u16,
	selectAll:    u16,
	affectMap:    u16,
	map_:         u16,
}

xkb_bell_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceSpec:   xkb_device_spec_t,
	bellClass:    xkb_bell_class_spec_t,
	bellID:       xkb_id_spec_t,
	percent:      i8,
	forceSound:   u8,
	eventOnly:    u8,
	pad0:         u8,
	pitch:        i16,
	duration:     i16,
	pad1:         [2]u8,
	name:         atom_t,
	window:       window_t,
}

xkb_get_state_cookie_t :: struct{
	sequence: ctypes.uint,
}

xkb_get_state_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceSpec:   xkb_device_spec_t,
	pad0:         [2]u8,
}

xkb_get_state_reply_t :: struct{
	response_type:    u8,
	deviceID:         u8,
	sequence:         u16,
	length:           u32,
	mods:             u8,
	baseMods:         u8,
	latchedMods:      u8,
	lockedMods:       u8,
	group:            u8,
	lockedGroup:      u8,
	baseGroup:        i16,
	latchedGroup:     i16,
	compatState:      u8,
	grabMods:         u8,
	compatGrabMods:   u8,
	lookupMods:       u8,
	compatLookupMods: u8,
	pad0:             u8,
	ptrBtnState:      u16,
	pad1:             [6]u8,
}

xkb_latch_lock_state_request_t :: struct{
	major_opcode:     u8,
	minor_opcode:     u8,
	length:           u16,
	deviceSpec:       xkb_device_spec_t,
	affectModLocks:   u8,
	modLocks:         u8,
	lockGroup:        u8,
	groupLock:        u8,
	affectModLatches: u8,
	pad0:             u8,
	pad1:             u8,
	latchGroup:       u8,
	groupLatch:       u16,
}

xkb_get_controls_cookie_t :: struct{
	sequence: ctypes.uint,
}

xkb_get_controls_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceSpec:   xkb_device_spec_t,
	pad0:         [2]u8,
}

xkb_get_controls_reply_t :: struct{
	response_type:               u8,
	deviceID:                    u8,
	sequence:                    u16,
	length:                      u32,
	mouseKeysDfltBtn:            u8,
	numGroups:                   u8,
	groupsWrap:                  u8,
	internalModsMask:            u8,
	ignoreLockModsMask:          u8,
	internalModsRealMods:        u8,
	ignoreLockModsRealMods:      u8,
	pad0:                        u8,
	internalModsVmods:           u16,
	ignoreLockModsVmods:         u16,
	repeatDelay:                 u16,
	repeatInterval:              u16,
	slowKeysDelay:               u16,
	debounceDelay:               u16,
	mouseKeysDelay:              u16,
	mouseKeysInterval:           u16,
	mouseKeysTimeToMax:          u16,
	mouseKeysMaxSpeed:           u16,
	mouseKeysCurve:              i16,
	accessXOption:               u16,
	accessXTimeout:              u16,
	accessXTimeoutOptionsMask:   u16,
	accessXTimeoutOptionsValues: u16,
	pad1:                        [2]u8,
	accessXTimeoutMask:          u32,
	accessXTimeoutValues:        u32,
	enabledControls:             u32,
	perKeyRepeat:                [32]u8,
}

xkb_set_controls_request_t :: struct{
	major_opcode:                u8,
	minor_opcode:                u8,
	length:                      u16,
	deviceSpec:                  xkb_device_spec_t,
	affectInternalRealMods:      u8,
	internalRealMods:            u8,
	affectIgnoreLockRealMods:    u8,
	ignoreLockRealMods:          u8,
	affectInternalVirtualMods:   u16,
	internalVirtualMods:         u16,
	affectIgnoreLockVirtualMods: u16,
	ignoreLockVirtualMods:       u16,
	mouseKeysDfltBtn:            u8,
	groupsWrap:                  u8,
	accessXOptions:              u16,
	pad0:                        [2]u8,
	affectEnabledControls:       u32,
	enabledControls:             u32,
	changeControls:              u32,
	repeatDelay:                 u16,
	repeatInterval:              u16,
	slowKeysDelay:               u16,
	debounceDelay:               u16,
	mouseKeysDelay:              u16,
	mouseKeysInterval:           u16,
	mouseKeysTimeToMax:          u16,
	mouseKeysMaxSpeed:           u16,
	mouseKeysCurve:              i16,
	accessXTimeout:              u16,
	accessXTimeoutMask:          u32,
	accessXTimeoutValues:        u32,
	accessXTimeoutOptionsMask:   u16,
	accessXTimeoutOptionsValues: u16,
	perKeyRepeat:                [32]u8,
}

xkb_get_map_cookie_t :: struct{
	sequence: ctypes.uint,
}

xkb_get_map_request_t :: struct{
	major_opcode:     u8,
	minor_opcode:     u8,
	length:           u16,
	deviceSpec:       xkb_device_spec_t,
	full:             u16,
	partial:          u16,
	firstType:        u8,
	nTypes:           u8,
	firstKeySym:      keycode_t,
	nKeySyms:         u8,
	firstKeyAction:   keycode_t,
	nKeyActions:      u8,
	firstKeyBehavior: keycode_t,
	nKeyBehaviors:    u8,
	virtualMods:      u16,
	firstKeyExplicit: keycode_t,
	nKeyExplicit:     u8,
	firstModMapKey:   keycode_t,
	nModMapKeys:      u8,
	firstVModMapKey:  keycode_t,
	nVModMapKeys:     u8,
	pad0:             [2]u8,
}

xkb_get_map_map_t :: struct{
	types_rtrn:      ^xkb_key_type_t,
	syms_rtrn:       ^xkb_key_sym_map_t,
	acts_rtrn_count: ^u8,
	pad2:            ^u8,
	acts_rtrn_acts:  ^xkb_action_t,
	behaviors_rtrn:  ^xkb_set_behavior_t,
	vmods_rtrn:      ^u8,
	pad3:            ^u8,
	explicit_rtrn:   ^xkb_set_explicit_t,
	pad4:            ^u8,
	modmap_rtrn:     ^xkb_key_mod_map_t,
	pad5:            ^u8,
	vmodmap_rtrn:    ^xkb_key_v_mod_map_t,
}

xkb_get_map_reply_t :: struct{
	response_type:     u8,
	deviceID:          u8,
	sequence:          u16,
	length:            u32,
	pad0:              [2]u8,
	minKeyCode:        keycode_t,
	maxKeyCode:        keycode_t,
	present:           u16,
	firstType:         u8,
	nTypes:            u8,
	totalTypes:        u8,
	firstKeySym:       keycode_t,
	totalSyms:         u16,
	nKeySyms:          u8,
	firstKeyAction:    keycode_t,
	totalActions:      u16,
	nKeyActions:       u8,
	firstKeyBehavior:  keycode_t,
	nKeyBehaviors:     u8,
	totalKeyBehaviors: u8,
	firstKeyExplicit:  keycode_t,
	nKeyExplicit:      u8,
	totalKeyExplicit:  u8,
	firstModMapKey:    keycode_t,
	nModMapKeys:       u8,
	totalModMapKeys:   u8,
	firstVModMapKey:   keycode_t,
	nVModMapKeys:      u8,
	totalVModMapKeys:  u8,
	pad1:              u8,
	virtualMods:       u16,
}

xkb_set_map_values_t :: struct{
	types:        ^xkb_set_key_type_t,
	syms:         ^xkb_key_sym_map_t,
	actionsCount: ^u8,
	actions:      ^xkb_action_t,
	behaviors:    ^xkb_set_behavior_t,
	vmods:        ^u8,
	explicit:     ^xkb_set_explicit_t,
	modmap:       ^xkb_key_mod_map_t,
	vmodmap:      ^xkb_key_v_mod_map_t,
}

xkb_set_map_request_t :: struct{
	major_opcode:      u8,
	minor_opcode:      u8,
	length:            u16,
	deviceSpec:        xkb_device_spec_t,
	present:           u16,
	flags:             u16,
	minKeyCode:        keycode_t,
	maxKeyCode:        keycode_t,
	firstType:         u8,
	nTypes:            u8,
	firstKeySym:       keycode_t,
	nKeySyms:          u8,
	totalSyms:         u16,
	firstKeyAction:    keycode_t,
	nKeyActions:       u8,
	totalActions:      u16,
	firstKeyBehavior:  keycode_t,
	nKeyBehaviors:     u8,
	totalKeyBehaviors: u8,
	firstKeyExplicit:  keycode_t,
	nKeyExplicit:      u8,
	totalKeyExplicit:  u8,
	firstModMapKey:    keycode_t,
	nModMapKeys:       u8,
	totalModMapKeys:   u8,
	firstVModMapKey:   keycode_t,
	nVModMapKeys:      u8,
	totalVModMapKeys:  u8,
	virtualMods:       u16,
}

xkb_get_compat_map_cookie_t :: struct{
	sequence: ctypes.uint,
}

xkb_get_compat_map_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceSpec:   xkb_device_spec_t,
	groups:       u8,
	getAllSI:     u8,
	firstSI:      u16,
	nSI:          u16,
}

xkb_get_compat_map_reply_t :: struct{
	response_type: u8,
	deviceID:      u8,
	sequence:      u16,
	length:        u32,
	groupsRtrn:    u8,
	pad0:          u8,
	firstSIRtrn:   u16,
	nSIRtrn:       u16,
	nTotalSI:      u16,
	pad1:          [16]u8,
}

xkb_set_compat_map_request_t :: struct{
	major_opcode:     u8,
	minor_opcode:     u8,
	length:           u16,
	deviceSpec:       xkb_device_spec_t,
	pad0:             u8,
	recomputeActions: u8,
	truncateSI:       u8,
	groups:           u8,
	firstSI:          u16,
	nSI:              u16,
	pad1:             [2]u8,
}

xkb_get_indicator_state_cookie_t :: struct{
	sequence: ctypes.uint,
}

xkb_get_indicator_state_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceSpec:   xkb_device_spec_t,
	pad0:         [2]u8,
}

xkb_get_indicator_state_reply_t :: struct{
	response_type: u8,
	deviceID:      u8,
	sequence:      u16,
	length:        u32,
	state:         u32,
	pad0:          [20]u8,
}

xkb_get_indicator_map_cookie_t :: struct{
	sequence: ctypes.uint,
}

xkb_get_indicator_map_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceSpec:   xkb_device_spec_t,
	pad0:         [2]u8,
	which:        u32,
}

xkb_get_indicator_map_reply_t :: struct{
	response_type:  u8,
	deviceID:       u8,
	sequence:       u16,
	length:         u32,
	which:          u32,
	realIndicators: u32,
	nIndicators:    u8,
	pad0:           [15]u8,
}

xkb_set_indicator_map_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceSpec:   xkb_device_spec_t,
	pad0:         [2]u8,
	which:        u32,
}

xkb_get_named_indicator_cookie_t :: struct{
	sequence: ctypes.uint,
}

xkb_get_named_indicator_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceSpec:   xkb_device_spec_t,
	ledClass:     xkb_led_class_spec_t,
	ledID:        xkb_id_spec_t,
	pad0:         [2]u8,
	indicator:    atom_t,
}

xkb_get_named_indicator_reply_t :: struct{
	response_type:   u8,
	deviceID:        u8,
	sequence:        u16,
	length:          u32,
	indicator:       atom_t,
	found:           u8,
	on:              u8,
	realIndicator:   u8,
	ndx:             u8,
	map_flags:       u8,
	map_whichGroups: u8,
	map_groups:      u8,
	map_whichMods:   u8,
	map_mods:        u8,
	map_realMods:    u8,
	map_vmod:        u16,
	map_ctrls:       u32,
	supported:       u8,
	pad0:            [3]u8,
}

xkb_set_named_indicator_request_t :: struct{
	major_opcode:    u8,
	minor_opcode:    u8,
	length:          u16,
	deviceSpec:      xkb_device_spec_t,
	ledClass:        xkb_led_class_spec_t,
	ledID:           xkb_id_spec_t,
	pad0:            [2]u8,
	indicator:       atom_t,
	setState:        u8,
	on:              u8,
	setMap:          u8,
	createMap:       u8,
	pad1:            u8,
	map_flags:       u8,
	map_whichGroups: u8,
	map_groups:      u8,
	map_whichMods:   u8,
	map_realMods:    u8,
	map_vmods:       u16,
	map_ctrls:       u32,
}

xkb_get_names_cookie_t :: struct{
	sequence: ctypes.uint,
}

xkb_get_names_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceSpec:   xkb_device_spec_t,
	pad0:         [2]u8,
	which:        u32,
}

xkb_get_names_value_list_t :: struct{
	keycodesName:    atom_t,
	geometryName:    atom_t,
	symbolsName:     atom_t,
	physSymbolsName: atom_t,
	typesName:       atom_t,
	compatName:      atom_t,
	typeNames:       ^atom_t,
	nLevelsPerType:  ^u8,
	pad1:            ^u8,
	ktLevelNames:    ^atom_t,
	indicatorNames:  ^atom_t,
	virtualModNames: ^atom_t,
	groups:          ^atom_t,
	keyNames:        ^xkb_key_name_t,
	keyAliases:      ^xkb_key_alias_t,
	radioGroupNames: ^atom_t,
}

xkb_get_names_reply_t :: struct{
	response_type: u8,
	deviceID:      u8,
	sequence:      u16,
	length:        u32,
	which:         u32,
	minKeyCode:    keycode_t,
	maxKeyCode:    keycode_t,
	nTypes:        u8,
	groupNames:    u8,
	virtualMods:   u16,
	firstKey:      keycode_t,
	nKeys:         u8,
	indicators:    u32,
	nRadioGroups:  u8,
	nKeyAliases:   u8,
	nKTLevels:     u16,
	pad0:          [4]u8,
}

xkb_set_names_values_t :: struct{
	keycodesName:    atom_t,
	geometryName:    atom_t,
	symbolsName:     atom_t,
	physSymbolsName: atom_t,
	typesName:       atom_t,
	compatName:      atom_t,
	typeNames:       ^atom_t,
	nLevelsPerType:  ^u8,
	ktLevelNames:    ^atom_t,
	indicatorNames:  ^atom_t,
	virtualModNames: ^atom_t,
	groups:          ^atom_t,
	keyNames:        ^xkb_key_name_t,
	keyAliases:      ^xkb_key_alias_t,
	radioGroupNames: ^atom_t,
}

xkb_set_names_request_t :: struct{
	major_opcode:      u8,
	minor_opcode:      u8,
	length:            u16,
	deviceSpec:        xkb_device_spec_t,
	virtualMods:       u16,
	which:             u32,
	firstType:         u8,
	nTypes:            u8,
	firstKTLevelt:     u8,
	nKTLevels:         u8,
	indicators:        u32,
	groupNames:        u8,
	nRadioGroups:      u8,
	firstKey:          keycode_t,
	nKeys:             u8,
	nKeyAliases:       u8,
	pad0:              u8,
	totalKTLevelNames: u16,
}

xkb_per_client_flags_cookie_t :: struct{
	sequence: ctypes.uint,
}

xkb_per_client_flags_request_t :: struct{
	major_opcode:    u8,
	minor_opcode:    u8,
	length:          u16,
	deviceSpec:      xkb_device_spec_t,
	pad0:            [2]u8,
	change:          u32,
	value:           u32,
	ctrlsToChange:   u32,
	autoCtrls:       u32,
	autoCtrlsValues: u32,
}

xkb_per_client_flags_reply_t :: struct{
	response_type:   u8,
	deviceID:        u8,
	sequence:        u16,
	length:          u32,
	supported:       u32,
	value:           u32,
	autoCtrls:       u32,
	autoCtrlsValues: u32,
	pad0:            [8]u8,
}

xkb_list_components_cookie_t :: struct{
	sequence: ctypes.uint,
}

xkb_list_components_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceSpec:   xkb_device_spec_t,
	maxNames:     u16,
}

xkb_list_components_reply_t :: struct{
	response_type: u8,
	deviceID:      u8,
	sequence:      u16,
	length:        u32,
	nKeymaps:      u16,
	nKeycodes:     u16,
	nTypes:        u16,
	nCompatMaps:   u16,
	nSymbols:      u16,
	nGeometries:   u16,
	extra:         u16,
	pad0:          [10]u8,
}

xkb_get_kbd_by_name_cookie_t :: struct{
	sequence: ctypes.uint,
}

xkb_get_kbd_by_name_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceSpec:   xkb_device_spec_t,
	need:         u16,
	want:         u16,
	load:         u8,
	pad0:         u8,
}

xkb_get_kbd_by_name_replies_types_map_t :: struct{
	types_rtrn:      ^xkb_key_type_t,
	syms_rtrn:       ^xkb_key_sym_map_t,
	acts_rtrn_count: ^u8,
	acts_rtrn_acts:  ^xkb_action_t,
	behaviors_rtrn:  ^xkb_set_behavior_t,
	vmods_rtrn:      ^u8,
	explicit_rtrn:   ^xkb_set_explicit_t,
	modmap_rtrn:     ^xkb_key_mod_map_t,
	vmodmap_rtrn:    ^xkb_key_v_mod_map_t,
}

xkb_get_kbd_by_name_replies_key_names_value_list_t :: struct{
	keycodesName:    atom_t,
	geometryName:    atom_t,
	symbolsName:     atom_t,
	physSymbolsName: atom_t,
	typesName:       atom_t,
	compatName:      atom_t,
	typeNames:       ^atom_t,
	nLevelsPerType:  ^u8,
	ktLevelNames:    ^atom_t,
	indicatorNames:  ^atom_t,
	virtualModNames: ^atom_t,
	groups:          ^atom_t,
	keyNames:        ^xkb_key_name_t,
	keyAliases:      ^xkb_key_alias_t,
	radioGroupNames: ^atom_t,
}

xkb_get_kbd_by_name_replies_t :: struct{
	getmap_type:       u8,
	typeDeviceID:      u8,
	getmap_sequence:   u16,
	getmap_length:     u32,
	pad1:              [2]u8,
	typeMinKeyCode:    keycode_t,
	typeMaxKeyCode:    keycode_t,
	present:           u16,
	firstType:         u8,
	nTypes:            u8,
	totalTypes:        u8,
	firstKeySym:       keycode_t,
	totalSyms:         u16,
	nKeySyms:          u8,
	firstKeyAction:    keycode_t,
	totalActions:      u16,
	nKeyActions:       u8,
	firstKeyBehavior:  keycode_t,
	nKeyBehaviors:     u8,
	totalKeyBehaviors: u8,
	firstKeyExplicit:  keycode_t,
	nKeyExplicit:      u8,
	totalKeyExplicit:  u8,
	firstModMapKey:    keycode_t,
	nModMapKeys:       u8,
	totalModMapKeys:   u8,
	firstVModMapKey:   keycode_t,
	nVModMapKeys:      u8,
	totalVModMapKeys:  u8,
	pad2:              u8,
	virtualMods:       u16,
	map_:              xkb_get_kbd_by_name_replies_types_map_t,
}

xkb_get_kbd_by_name_reply_t :: struct{
	response_type: u8,
	deviceID:      u8,
	sequence:      u16,
	length:        u32,
	minKeyCode:    keycode_t,
	maxKeyCode:    keycode_t,
	loaded:        u8,
	newKeyboard:   u8,
	found:         u16,
	reported:      u16,
	pad0:          [16]u8,
}

xkb_get_device_info_cookie_t :: struct{
	sequence: ctypes.uint,
}

xkb_get_device_info_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	deviceSpec:   xkb_device_spec_t,
	wanted:       u16,
	allButtons:   u8,
	firstButton:  u8,
	nButtons:     u8,
	pad0:         u8,
	ledClass:     xkb_led_class_spec_t,
	ledID:        xkb_id_spec_t,
}

xkb_get_device_info_reply_t :: struct{
	response_type:  u8,
	deviceID:       u8,
	sequence:       u16,
	length:         u32,
	present:        u16,
	supported:      u16,
	unsupported:    u16,
	nDeviceLedFBs:  u16,
	firstBtnWanted: u8,
	nBtnsWanted:    u8,
	firstBtnRtrn:   u8,
	nBtnsRtrn:      u8,
	totalBtns:      u8,
	hasOwnState:    u8,
	dfltKbdFB:      u16,
	dfltLedFB:      u16,
	pad0:           [2]u8,
	devType:        atom_t,
	nameLen:        u16,
}

xkb_set_device_info_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	deviceSpec:    xkb_device_spec_t,
	firstBtn:      u8,
	nBtns:         u8,
	change:        u16,
	nDeviceLedFBs: u16,
}

xkb_set_debugging_flags_cookie_t :: struct{
	sequence: ctypes.uint,
}

xkb_set_debugging_flags_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	msgLength:    u16,
	pad0:         [2]u8,
	affectFlags:  u32,
	flags:        u32,
	affectCtrls:  u32,
	ctrls:        u32,
}

xkb_set_debugging_flags_reply_t :: struct{
	response_type:  u8,
	pad0:           u8,
	sequence:       u16,
	length:         u32,
	currentFlags:   u32,
	currentCtrls:   u32,
	supportedFlags: u32,
	supportedCtrls: u32,
	pad1:           [8]u8,
}

xkb_new_keyboard_notify_event_t :: struct{
	response_type: u8,
	xkbType:       u8,
	sequence:      u16,
	time:          timestamp_t,
	deviceID:      u8,
	oldDeviceID:   u8,
	minKeyCode:    keycode_t,
	maxKeyCode:    keycode_t,
	oldMinKeyCode: keycode_t,
	oldMaxKeyCode: keycode_t,
	requestMajor:  u8,
	requestMinor:  u8,
	changed:       u16,
	pad0:          [14]u8,
}

xkb_map_notify_event_t :: struct{
	response_type:    u8,
	xkbType:          u8,
	sequence:         u16,
	time:             timestamp_t,
	deviceID:         u8,
	ptrBtnActions:    u8,
	changed:          u16,
	minKeyCode:       keycode_t,
	maxKeyCode:       keycode_t,
	firstType:        u8,
	nTypes:           u8,
	firstKeySym:      keycode_t,
	nKeySyms:         u8,
	firstKeyAct:      keycode_t,
	nKeyActs:         u8,
	firstKeyBehavior: keycode_t,
	nKeyBehavior:     u8,
	firstKeyExplicit: keycode_t,
	nKeyExplicit:     u8,
	firstModMapKey:   keycode_t,
	nModMapKeys:      u8,
	firstVModMapKey:  keycode_t,
	nVModMapKeys:     u8,
	virtualMods:      u16,
	pad0:             [2]u8,
}

xkb_state_notify_event_t :: struct{
	response_type:     u8,
	xkbType:           u8,
	sequence:          u16,
	time:              timestamp_t,
	deviceID:          u8,
	mods:              u8,
	baseMods:          u8,
	latchedMods:       u8,
	lockedMods:        u8,
	group:             u8,
	baseGroup:         i16,
	latchedGroup:      i16,
	lockedGroup:       u8,
	compatState:       u8,
	grabMods:          u8,
	compatGrabMods:    u8,
	lookupMods:        u8,
	compatLoockupMods: u8,
	ptrBtnState:       u16,
	changed:           u16,
	keycode:           keycode_t,
	eventType:         u8,
	requestMajor:      u8,
	requestMinor:      u8,
}

xkb_controls_notify_event_t :: struct{
	response_type:         u8,
	xkbType:               u8,
	sequence:              u16,
	time:                  timestamp_t,
	deviceID:              u8,
	numGroups:             u8,
	pad0:                  [2]u8,
	changedControls:       u32,
	enabledControls:       u32,
	enabledControlChanges: u32,
	keycode:               keycode_t,
	eventType:             u8,
	requestMajor:          u8,
	requestMinor:          u8,
	pad1:                  [4]u8,
}

xkb_indicator_state_notify_event_t :: struct{
	response_type: u8,
	xkbType:       u8,
	sequence:      u16,
	time:          timestamp_t,
	deviceID:      u8,
	pad0:          [3]u8,
	state:         u32,
	stateChanged:  u32,
	pad1:          [12]u8,
}

xkb_indicator_map_notify_event_t :: struct{
	response_type: u8,
	xkbType:       u8,
	sequence:      u16,
	time:          timestamp_t,
	deviceID:      u8,
	pad0:          [3]u8,
	state:         u32,
	mapChanged:    u32,
	pad1:          [12]u8,
}

xkb_names_notify_event_t :: struct{
	response_type:      u8,
	xkbType:            u8,
	sequence:           u16,
	time:               timestamp_t,
	deviceID:           u8,
	pad0:               u8,
	changed:            u16,
	firstType:          u8,
	nTypes:             u8,
	firstLevelName:     u8,
	nLevelNames:        u8,
	pad1:               u8,
	nRadioGroups:       u8,
	nKeyAliases:        u8,
	changedGroupNames:  u8,
	changedVirtualMods: u16,
	firstKey:           keycode_t,
	nKeys:              u8,
	changedIndicators:  u32,
	pad2:               [4]u8,
}

xkb_compat_map_notify_event_t :: struct{
	response_type: u8,
	xkbType:       u8,
	sequence:      u16,
	time:          timestamp_t,
	deviceID:      u8,
	changedGroups: u8,
	firstSI:       u16,
	nSI:           u16,
	nTotalSI:      u16,
	pad0:          [16]u8,
}

xkb_bell_notify_event_t :: struct{
	response_type: u8,
	xkbType:       u8,
	sequence:      u16,
	time:          timestamp_t,
	deviceID:      u8,
	bellClass:     u8,
	bellID:        u8,
	percent:       u8,
	pitch:         u16,
	duration:      u16,
	name:          atom_t,
	window:        window_t,
	eventOnly:     u8,
	pad0:          [7]u8,
}

xkb_action_message_event_t :: struct{
	response_type:   u8,
	xkbType:         u8,
	sequence:        u16,
	time:            timestamp_t,
	deviceID:        u8,
	keycode:         keycode_t,
	press:           u8,
	keyEventFollows: u8,
	mods:            u8,
	group:           u8,
	message:         [8]xkb_string8_t,
	pad0:            [10]u8,
}

xkb_access_x_notify_event_t :: struct{
	response_type: u8,
	xkbType:       u8,
	sequence:      u16,
	time:          timestamp_t,
	deviceID:      u8,
	keycode:       keycode_t,
	detailt:       u16,
	slowKeysDelay: u16,
	debounceDelay: u16,
	pad0:          [16]u8,
}

xkb_extension_device_notify_event_t :: struct{
	response_type: u8,
	xkbType:       u8,
	sequence:      u16,
	time:          timestamp_t,
	deviceID:      u8,
	pad0:          u8,
	reason:        u16,
	ledClass:      u16,
	ledID:         u16,
	ledsDefined:   u32,
	ledState:      u32,
	firstButton:   u8,
	nButtons:      u8,
	supported:     u16,
	unsupported:   u16,
	pad1:          [2]u8,
}

x_print_printer_t :: struct{
	nameLen: u32,
	descLen: u32,
}

x_print_print_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

x_print_print_query_version_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

x_print_print_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major_version: u16,
	minor_version: u16,
}

x_print_print_get_printer_list_cookie_t :: struct{
	sequence: ctypes.uint,
}

x_print_print_get_printer_list_request_t :: struct{
	major_opcode:   u8,
	minor_opcode:   u8,
	length:         u16,
	printerNameLen: u32,
	localeLen:      u32,
}

x_print_print_get_printer_list_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	listCount:     u32,
	pad1:          [20]u8,
}

x_print_print_rehash_printer_list_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

x_print_create_context_request_t :: struct{
	major_opcode:   u8,
	minor_opcode:   u8,
	length:         u16,
	context_id:     u32,
	printerNameLen: u32,
	localeLen:      u32,
}

x_print_print_set_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     u32,
}

x_print_print_get_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

x_print_print_get_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

x_print_print_get_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_:      u32,
}

x_print_print_destroy_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     u32,
}

x_print_print_get_screen_of_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

x_print_print_get_screen_of_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

x_print_print_get_screen_of_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	root:          window_t,
}

x_print_print_start_job_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	output_mode:  u8,
}

x_print_print_end_job_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	cancel:       u8,
}

x_print_print_start_doc_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	driver_mode:  u8,
}

x_print_print_end_doc_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	cancel:       u8,
}

x_print_print_put_document_data_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
	len_data:     u32,
	len_fmt:      u16,
	len_options:  u16,
}

x_print_print_get_document_data_cookie_t :: struct{
	sequence: ctypes.uint,
}

x_print_print_get_document_data_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     x_print_pcontext_t,
	max_bytes:    u32,
}

x_print_print_get_document_data_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	status_code:   u32,
	finished_flag: u32,
	dataLen:       u32,
	pad1:          [12]u8,
}

x_print_print_start_page_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

x_print_print_end_page_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	cancel:       u8,
	pad0:         [3]u8,
}

x_print_print_select_input_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     x_print_pcontext_t,
	event_mask:   u32,
}

x_print_print_input_selected_cookie_t :: struct{
	sequence: ctypes.uint,
}

x_print_print_input_selected_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     x_print_pcontext_t,
}

x_print_print_input_selected_reply_t :: struct{
	response_type:   u8,
	pad0:            u8,
	sequence:        u16,
	length:          u32,
	event_mask:      u32,
	all_events_mask: u32,
}

x_print_print_get_attributes_cookie_t :: struct{
	sequence: ctypes.uint,
}

x_print_print_get_attributes_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     x_print_pcontext_t,
	pool:         u8,
	pad0:         [3]u8,
}

x_print_print_get_attributes_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	stringLen:     u32,
	pad1:          [20]u8,
}

x_print_print_get_one_attributes_cookie_t :: struct{
	sequence: ctypes.uint,
}

x_print_print_get_one_attributes_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     x_print_pcontext_t,
	nameLen:      u32,
	pool:         u8,
	pad0:         [3]u8,
}

x_print_print_get_one_attributes_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	valueLen:      u32,
	pad1:          [20]u8,
}

x_print_print_set_attributes_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     x_print_pcontext_t,
	stringLen:    u32,
	pool:         u8,
	rule:         u8,
	pad0:         [2]u8,
}

x_print_print_get_page_dimensions_cookie_t :: struct{
	sequence: ctypes.uint,
}

x_print_print_get_page_dimensions_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     x_print_pcontext_t,
}

x_print_print_get_page_dimensions_reply_t :: struct{
	response_type:       u8,
	pad0:                u8,
	sequence:            u16,
	length:              u32,
	width:               u16,
	height:              u16,
	offset_x:            u16,
	offset_y:            u16,
	reproducible_width:  u16,
	reproducible_height: u16,
}

x_print_print_query_screens_cookie_t :: struct{
	sequence: ctypes.uint,
}

x_print_print_query_screens_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

x_print_print_query_screens_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	listCount:     u32,
	pad1:          [20]u8,
}

x_print_print_set_image_resolution_cookie_t :: struct{
	sequence: ctypes.uint,
}

x_print_print_set_image_resolution_request_t :: struct{
	major_opcode:     u8,
	minor_opcode:     u8,
	length:           u16,
	context_:         x_print_pcontext_t,
	image_resolution: u16,
}

x_print_print_set_image_resolution_reply_t :: struct{
	response_type:        u8,
	status:               u8,
	sequence:             u16,
	length:               u32,
	previous_resolutions: u16,
}

x_print_print_get_image_resolution_cookie_t :: struct{
	sequence: ctypes.uint,
}

x_print_print_get_image_resolution_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_:     x_print_pcontext_t,
}

x_print_print_get_image_resolution_reply_t :: struct{
	response_type:    u8,
	pad0:             u8,
	sequence:         u16,
	length:           u32,
	image_resolution: u16,
}

x_print_notify_event_t :: struct{
	response_type: u8,
	detail:        u8,
	sequence:      u16,
	context_:      x_print_pcontext_t,
	cancel:        u8,
}

x_print_attribut_notify_event_t :: struct{
	response_type: u8,
	detail:        u8,
	sequence:      u16,
	context_:      x_print_pcontext_t,
}

x_print_bad_context_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

x_print_bad_sequence_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

char2b_t :: struct{
	byte1: u8,
	byte2: u8,
}

point_t :: struct{
	x: i16,
	y: i16,
}

rectangle_t :: struct{
	x:      i16,
	y:      i16,
	width:  u16,
	height: u16,
}

arc_t :: struct{
	x:      i16,
	y:      i16,
	width:  u16,
	height: u16,
	angle1: i16,
	angle2: i16,
}

format_t :: struct{
	depth:          u8,
	bits_per_pixel: u8,
	scanline_pad:   u8,
	pad0:           [5]u8,
}

visualtype_t :: struct{
	visual_id:          visualid_t,
	_class:             u8,
	bits_per_rgb_value: u8,
	colormap_entries:   u16,
	red_mask:           u32,
	green_mask:         u32,
	blue_mask:          u32,
	pad0:               [4]u8,
}

depth_t :: struct{
	depth:       u8,
	pad0:        u8,
	visuals_len: u16,
	pad1:        [4]u8,
}

screen_t :: struct{
	root:                  window_t,
	default_colormap:      colormap_t,
	white_pixel:           u32,
	black_pixel:           u32,
	current_input_masks:   u32,
	width_in_pixels:       u16,
	height_in_pixels:      u16,
	width_in_millimeters:  u16,
	height_in_millimeters: u16,
	min_installed_maps:    u16,
	max_installed_maps:    u16,
	root_visual:           visualid_t,
	backing_stores:        u8,
	save_unders:           u8,
	root_depth:            u8,
	allowed_depths_len:    u8,
}

setup_request_t :: struct{
	byte_order:                      u8,
	pad0:                            u8,
	protocol_major_version:          u16,
	protocol_minor_version:          u16,
	authorization_protocol_name_len: u16,
	authorization_protocol_data_len: u16,
	pad1:                            [2]u8,
}

setup_failed_t :: struct{
	status:                 u8,
	reason_len:             u8,
	protocol_major_version: u16,
	protocol_minor_version: u16,
	length:                 u16,
}

setup_authenticate_t :: struct{
	status: u8,
	pad0:   [5]u8,
	length: u16,
}

setup_t :: struct{
	status:                      u8,
	pad0:                        u8,
	protocol_major_version:      u16,
	protocol_minor_version:      u16,
	length:                      u16,
	release_number:              u32,
	resource_id_base:            u32,
	resource_id_mask:            u32,
	motion_buffer_size:          u32,
	vendor_len:                  u16,
	maximum_request_length:      u16,
	roots_len:                   u8,
	pixmap_formats_len:          u8,
	image_byte_order:            u8,
	bitmap_format_bit_order:     u8,
	bitmap_format_scanline_unit: u8,
	bitmap_format_scanline_pad:  u8,
	min_keycode:                 keycode_t,
	max_keycode:                 keycode_t,
	pad1:                        [4]u8,
}

key_press_event_t :: struct{
	response_type: u8,
	detail:        keycode_t,
	sequence:      u16,
	time:          timestamp_t,
	root:          window_t,
	event:         window_t,
	child:         window_t,
	root_x:        i16,
	root_y:        i16,
	event_x:       i16,
	event_y:       i16,
	state:         u16,
	same_screen:   u8,
	pad0:          u8,
}

button_press_event_t :: struct{
	response_type: u8,
	detail:        button_t,
	sequence:      u16,
	time:          timestamp_t,
	root:          window_t,
	event:         window_t,
	child:         window_t,
	root_x:        i16,
	root_y:        i16,
	event_x:       i16,
	event_y:       i16,
	state:         u16,
	same_screen:   u8,
	pad0:          u8,
}

motion_notify_event_t :: struct{
	response_type: u8,
	detail:        u8,
	sequence:      u16,
	time:          timestamp_t,
	root:          window_t,
	event:         window_t,
	child:         window_t,
	root_x:        i16,
	root_y:        i16,
	event_x:       i16,
	event_y:       i16,
	state:         u16,
	same_screen:   u8,
	pad0:          u8,
}

enter_notify_event_t :: struct{
	response_type:     u8,
	detail:            u8,
	sequence:          u16,
	time:              timestamp_t,
	root:              window_t,
	event:             window_t,
	child:             window_t,
	root_x:            i16,
	root_y:            i16,
	event_x:           i16,
	event_y:           i16,
	state:             u16,
	mode:              u8,
	same_screen_focus: u8,
}

focus_in_event_t :: struct{
	response_type: u8,
	detail:        u8,
	sequence:      u16,
	event:         window_t,
	mode:          u8,
	pad0:          [3]u8,
}

keymap_notify_event_t :: struct{
	response_type: u8,
	keys:          [31]u8,
}

expose_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	window:        window_t,
	x:             u16,
	y:             u16,
	width:         u16,
	height:        u16,
	count:         u16,
	pad1:          [2]u8,
}

graphics_exposure_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	drawable:      drawable_t,
	x:             u16,
	y:             u16,
	width:         u16,
	height:        u16,
	minor_opcode:  u16,
	count:         u16,
	major_opcode:  u8,
	pad1:          [3]u8,
}

no_exposure_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	drawable:      drawable_t,
	minor_opcode:  u16,
	major_opcode:  u8,
	pad1:          u8,
}

visibility_notify_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	window:        window_t,
	state:         u8,
	pad1:          [3]u8,
}

create_notify_event_t :: struct{
	response_type:     u8,
	pad0:              u8,
	sequence:          u16,
	parent:            window_t,
	window:            window_t,
	x:                 i16,
	y:                 i16,
	width:             u16,
	height:            u16,
	border_width:      u16,
	override_redirect: u8,
	pad1:              u8,
}

destroy_notify_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	event:         window_t,
	window:        window_t,
}

unmap_notify_event_t :: struct{
	response_type:  u8,
	pad0:           u8,
	sequence:       u16,
	event:          window_t,
	window:         window_t,
	from_configure: u8,
	pad1:           [3]u8,
}

map_notify_event_t :: struct{
	response_type:     u8,
	pad0:              u8,
	sequence:          u16,
	event:             window_t,
	window:            window_t,
	override_redirect: u8,
	pad1:              [3]u8,
}

map_request_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	parent:        window_t,
	window:        window_t,
}

reparent_notify_event_t :: struct{
	response_type:     u8,
	pad0:              u8,
	sequence:          u16,
	event:             window_t,
	window:            window_t,
	parent:            window_t,
	x:                 i16,
	y:                 i16,
	override_redirect: u8,
	pad1:              [3]u8,
}

configure_notify_event_t :: struct{
	response_type:     u8,
	pad0:              u8,
	sequence:          u16,
	event:             window_t,
	window:            window_t,
	above_sibling:     window_t,
	x:                 i16,
	y:                 i16,
	width:             u16,
	height:            u16,
	border_width:      u16,
	override_redirect: u8,
	pad1:              u8,
}

configure_request_event_t :: struct{
	response_type: u8,
	stack_mode:    u8,
	sequence:      u16,
	parent:        window_t,
	window:        window_t,
	sibling:       window_t,
	x:             i16,
	y:             i16,
	width:         u16,
	height:        u16,
	border_width:  u16,
	value_mask:    u16,
}

gravity_notify_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	event:         window_t,
	window:        window_t,
	x:             i16,
	y:             i16,
}

resize_request_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	window:        window_t,
	width:         u16,
	height:        u16,
}

circulate_notify_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	event:         window_t,
	window:        window_t,
	pad1:          [4]u8,
	place:         u8,
	pad2:          [3]u8,
}

property_notify_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	window:        window_t,
	atom:          atom_t,
	time:          timestamp_t,
	state:         u8,
	pad1:          [3]u8,
}

selection_clear_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	time:          timestamp_t,
	owner:         window_t,
	selection:     atom_t,
}

selection_request_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	time:          timestamp_t,
	owner:         window_t,
	requestor:     window_t,
	selection:     atom_t,
	target:        atom_t,
	property:      atom_t,
}

selection_notify_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	time:          timestamp_t,
	requestor:     window_t,
	selection:     atom_t,
	target:        atom_t,
	property:      atom_t,
}

colormap_notify_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	window:        window_t,
	colormap:      colormap_t,
	_new:          u8,
	state:         u8,
	pad1:          [2]u8,
}

client_message_data_t :: struct#raw_union {
	data8:  [20]u8,
	data16: [10]u16,
	data32: [5]u32,
}

client_message_event_t :: struct{
	response_type: u8,
	format:        u8,
	sequence:      u16,
	window:        window_t,
	type:          atom_t,
	data:          client_message_data_t,
}

mapping_notify_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	request:       u8,
	first_keycode: keycode_t,
	count:         u8,
	pad1:          u8,
}

ge_generic_event_t :: struct{
	response_type: u8,
	extension:     u8,
	sequence:      u16,
	length:        u32,
	event_type:    u16,
	pad0:          [22]u8,
	full_sequence: u32,
}

request_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
	pad0:          u8,
}

value_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
	pad0:          u8,
}

create_window_value_list_t :: struct{
	background_pixmap:     pixmap_t,
	background_pixel:      u32,
	border_pixmap:         pixmap_t,
	border_pixel:          u32,
	bit_gravity:           u32,
	win_gravity:           u32,
	backing_store:         u32,
	backing_planes:        u32,
	backing_pixel:         u32,
	override_redirect:     b32,
	save_under:            b32,
	event_mask:            u32,
	do_not_propogate_mask: u32,
	colormap:              colormap_t,
	cursor:                cursor_t,
}

create_window_request_t :: struct{
	major_opcode: u8,
	depth:        u8,
	length:       u16,
	wid:          window_t,
	parent:       window_t,
	x:            i16,
	y:            i16,
	width:        u16,
	height:       u16,
	border_width: u16,
	_class:       u16,
	visual:       visualid_t,
	value_mask:   u32,
}

change_window_attributes_value_list_t :: struct{
	background_pixmap:     pixmap_t,
	background_pixel:      u32,
	border_pixmap:         pixmap_t,
	border_pixel:          u32,
	bit_gravity:           u32,
	win_gravity:           u32,
	backing_store:         u32,
	backing_planes:        u32,
	backing_pixel:         u32,
	override_redirect:     b32,
	save_under:            b32,
	event_mask:            u32,
	do_not_propogate_mask: u32,
	colormap:              colormap_t,
	cursor:                cursor_t,
}

change_window_attributes_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
	value_mask:   u32,
}

get_window_attributes_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_window_attributes_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
}

get_window_attributes_reply_t :: struct{
	response_type:         u8,
	backing_store:         u8,
	sequence:              u16,
	length:                u32,
	visual:                visualid_t,
	_class:                u16,
	bit_gravity:           u8,
	win_gravity:           u8,
	backing_planes:        u32,
	backing_pixel:         u32,
	save_under:            u8,
	map_is_installed:      u8,
	map_state:             u8,
	override_redirect:     u8,
	colormap:              colormap_t,
	all_event_masks:       u32,
	your_event_mask:       u32,
	do_not_propagate_mask: u16,
	pad0:                  [2]u8,
}

destroy_window_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
}

destroy_subwindows_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
}

change_save_set_request_t :: struct{
	major_opcode: u8,
	mode:         u8,
	length:       u16,
	window:       window_t,
}

reparent_window_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
	parent:       window_t,
	x:            i16,
	y:            i16,
}

map_window_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
}

map_subwindows_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
}

unmap_window_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
}

unmap_subwindows_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
}

configure_window_value_list_t :: struct{
	x:            i32,
	y:            i32,
	width:        u32,
	height:       u32,
	border_width: u32,
	sibling:      window_t,
	stack_mode:   u32,
}

configure_window_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
	value_mask:   u16,
	pad1:         [2]u8,
}

circulate_window_request_t :: struct{
	major_opcode: u8,
	direction:    u8,
	length:       u16,
	window:       window_t,
}

get_geometry_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_geometry_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	drawable:     drawable_t,
}

get_geometry_reply_t :: struct{
	response_type: u8,
	depth:         u8,
	sequence:      u16,
	length:        u32,
	root:          window_t,
	x:             i16,
	y:             i16,
	width:         u16,
	height:        u16,
	border_width:  u16,
	pad0:          [2]u8,
}

query_tree_cookie_t :: struct{
	sequence: ctypes.uint,
}

query_tree_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
}

query_tree_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	root:          window_t,
	parent:        window_t,
	children_len:  u16,
	pad1:          [14]u8,
}

intern_atom_cookie_t :: struct{
	sequence: ctypes.uint,
}

intern_atom_request_t :: struct{
	major_opcode:   u8,
	only_if_exists: u8,
	length:         u16,
	name_len:       u16,
	pad0:           [2]u8,
}

intern_atom_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	atom:          atom_t,
}

get_atom_name_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_atom_name_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	atom:         atom_t,
}

get_atom_name_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	name_len:      u16,
	pad1:          [22]u8,
}

change_property_request_t :: struct{
	major_opcode: u8,
	mode:         u8,
	length:       u16,
	window:       window_t,
	property:     atom_t,
	type:         atom_t,
	format:       u8,
	pad0:         [3]u8,
	data_len:     u32,
}

delete_property_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
	property:     atom_t,
}

get_property_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_property_request_t :: struct{
	major_opcode: u8,
	_delete:      u8,
	length:       u16,
	window:       window_t,
	property:     atom_t,
	type:         atom_t,
	long_offset:  u32,
	long_length:  u32,
}

get_property_reply_t :: struct{
	response_type: u8,
	format:        u8,
	sequence:      u16,
	length:        u32,
	type:          atom_t,
	bytes_after:   u32,
	value_len:     u32,
	pad0:          [12]u8,
}

list_properties_cookie_t :: struct{
	sequence: ctypes.uint,
}

list_properties_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
}

list_properties_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	atoms_len:     u16,
	pad1:          [22]u8,
}

set_selection_owner_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	owner:        window_t,
	selection:    atom_t,
	time:         timestamp_t,
}

get_selection_owner_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_selection_owner_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	selection:    atom_t,
}

get_selection_owner_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	owner:         window_t,
}

convert_selection_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	requestor:    window_t,
	selection:    atom_t,
	target:       atom_t,
	property:     atom_t,
	time:         timestamp_t,
}

send_event_request_t :: struct{
	major_opcode: u8,
	propagate:    u8,
	length:       u16,
	destination:  window_t,
	event_mask:   u32,
	event:        [32]byte,
}

grab_pointer_cookie_t :: struct{
	sequence: ctypes.uint,
}

grab_pointer_request_t :: struct{
	major_opcode:  u8,
	owner_events:  u8,
	length:        u16,
	grab_window:   window_t,
	event_mask:    u16,
	pointer_mode:  u8,
	keyboard_mode: u8,
	confine_to:    window_t,
	cursor:        cursor_t,
	time:          timestamp_t,
}

grab_pointer_reply_t :: struct{
	response_type: u8,
	status:        u8,
	sequence:      u16,
	length:        u32,
}

ungrab_pointer_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	time:         timestamp_t,
}

grab_button_request_t :: struct{
	major_opcode:  u8,
	owner_events:  u8,
	length:        u16,
	grab_window:   window_t,
	event_mask:    u16,
	pointer_mode:  u8,
	keyboard_mode: u8,
	confine_to:    window_t,
	cursor:        cursor_t,
	button:        u8,
	pad0:          u8,
	modifiers:     u16,
}

ungrab_button_request_t :: struct{
	major_opcode: u8,
	button:       u8,
	length:       u16,
	grab_window:  window_t,
	modifiers:    u16,
	pad0:         [2]u8,
}

change_active_pointer_grab_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cursor:       cursor_t,
	time:         timestamp_t,
	event_mask:   u16,
	pad1:         [2]u8,
}

grab_keyboard_cookie_t :: struct{
	sequence: ctypes.uint,
}

grab_keyboard_request_t :: struct{
	major_opcode:  u8,
	owner_events:  u8,
	length:        u16,
	grab_window:   window_t,
	time:          timestamp_t,
	pointer_mode:  u8,
	keyboard_mode: u8,
	pad0:          [2]u8,
}

grab_keyboard_reply_t :: struct{
	response_type: u8,
	status:        u8,
	sequence:      u16,
	length:        u32,
}

ungrab_keyboard_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	time:         timestamp_t,
}

grab_key_request_t :: struct{
	major_opcode:  u8,
	owner_events:  u8,
	length:        u16,
	grab_window:   window_t,
	modifiers:     u16,
	key:           keycode_t,
	pointer_mode:  u8,
	keyboard_mode: u8,
	pad0:          [3]u8,
}

ungrab_key_request_t :: struct{
	major_opcode: u8,
	key:          keycode_t,
	length:       u16,
	grab_window:  window_t,
	modifiers:    u16,
	pad0:         [2]u8,
}

allow_events_request_t :: struct{
	major_opcode: u8,
	mode:         u8,
	length:       u16,
	time:         timestamp_t,
}

grab_server_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
}

ungrab_server_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
}

query_pointer_cookie_t :: struct{
	sequence: ctypes.uint,
}

query_pointer_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
}

query_pointer_reply_t :: struct{
	response_type: u8,
	same_screen:   u8,
	sequence:      u16,
	length:        u32,
	root:          window_t,
	child:         window_t,
	root_x:        i16,
	root_y:        i16,
	win_x:         i16,
	win_y:         i16,
	mask:          u16,
	pad0:          [2]u8,
}

timecoord_t :: struct{
	time: timestamp_t,
	x:    i16,
	y:    i16,
}

get_motion_events_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_motion_events_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
	start:        timestamp_t,
	stop:         timestamp_t,
}

get_motion_events_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	events_len:    u32,
	pad1:          [20]u8,
}

translate_coordinates_cookie_t :: struct{
	sequence: ctypes.uint,
}

translate_coordinates_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	src_window:   window_t,
	dst_window:   window_t,
	src_x:        i16,
	src_y:        i16,
}

translate_coordinates_reply_t :: struct{
	response_type: u8,
	same_screen:   u8,
	sequence:      u16,
	length:        u32,
	child:         window_t,
	dst_x:         i16,
	dst_y:         i16,
}

warp_pointer_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	src_window:   window_t,
	dst_window:   window_t,
	src_x:        i16,
	src_y:        i16,
	src_width:    u16,
	src_height:   u16,
	dst_x:        i16,
	dst_y:        i16,
}

set_input_focus_request_t :: struct{
	major_opcode: u8,
	revert_to:    u8,
	length:       u16,
	focus:        window_t,
	time:         timestamp_t,
}

get_input_focus_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_input_focus_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
}

get_input_focus_reply_t :: struct{
	response_type: u8,
	revert_to:     u8,
	sequence:      u16,
	length:        u32,
	focus:         window_t,
}

query_keymap_cookie_t :: struct{
	sequence: ctypes.uint,
}

query_keymap_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
}

query_keymap_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	keys:          [32]u8,
}

open_font_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	fid:          font_t,
	name_len:     u16,
	pad1:         [2]u8,
}

close_font_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	font:         font_t,
}

fontprop_t :: struct{
	name:  atom_t,
	value: u32,
}

charinfo_t :: struct{
	left_side_bearing:  i16,
	right_side_bearing: i16,
	character_width:    i16,
	ascent:             i16,
	descent:            i16,
	attributes:         u16,
}

query_font_cookie_t :: struct{
	sequence: ctypes.uint,
}

query_font_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	font:         fontable_t,
}

query_font_reply_t :: struct{
	response_type:     u8,
	pad0:              u8,
	sequence:          u16,
	length:            u32,
	min_bounds:        charinfo_t,
	pad1:              [4]u8,
	max_bounds:        charinfo_t,
	pad2:              [4]u8,
	min_char_or_byte2: u16,
	max_char_or_byte2: u16,
	default_char:      u16,
	properties_len:    u16,
	draw_direction:    u8,
	min_byte1:         u8,
	max_byte1:         u8,
	all_chars_exist:   u8,
	font_ascent:       i16,
	font_descent:      i16,
	char_infos_len:    u32,
}

query_text_extents_cookie_t :: struct{
	sequence: ctypes.uint,
}

query_text_extents_request_t :: struct{
	major_opcode: u8,
	odd_length:   u8,
	length:       u16,
	font:         fontable_t,
}

query_text_extents_reply_t :: struct{
	response_type:   u8,
	draw_direction:  u8,
	sequence:        u16,
	length:          u32,
	font_ascent:     i16,
	font_descent:    i16,
	overall_ascent:  i16,
	overall_descent: i16,
	overall_width:   i32,
	overall_left:    i32,
	overall_right:   i32,
}

str_t :: struct{
	name_len: u8,
}

list_fonts_cookie_t :: struct{
	sequence: ctypes.uint,
}

list_fonts_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	max_names:    u16,
	pattern_len:  u16,
}

list_fonts_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	names_len:     u16,
	pad1:          [22]u8,
}

list_fonts_with_info_cookie_t :: struct{
	sequence: ctypes.uint,
}

list_fonts_with_info_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	max_names:    u16,
	pattern_len:  u16,
}

list_fonts_with_info_reply_t :: struct{
	response_type:     u8,
	name_len:          u8,
	sequence:          u16,
	length:            u32,
	min_bounds:        charinfo_t,
	pad0:              [4]u8,
	max_bounds:        charinfo_t,
	pad1:              [4]u8,
	min_char_or_byte2: u16,
	max_char_or_byte2: u16,
	default_char:      u16,
	properties_len:    u16,
	draw_direction:    u8,
	min_byte1:         u8,
	max_byte1:         u8,
	all_chars_exist:   u8,
	font_ascent:       i16,
	font_descent:      i16,
	replies_hint:      u32,
}

set_font_path_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	font_qty:     u16,
	pad1:         [2]u8,
}

get_font_path_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_font_path_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
}

get_font_path_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	path_len:      u16,
	pad1:          [22]u8,
}

create_pixmap_request_t :: struct{
	major_opcode: u8,
	depth:        u8,
	length:       u16,
	pid:          pixmap_t,
	drawable:     drawable_t,
	width:        u16,
	height:       u16,
}

free_pixmap_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	pixmap:       pixmap_t,
}

create_gc_value_list_t :: struct{
	function:              u32,
	plane_mask:            u32,
	foreground:            u32,
	background:            u32,
	line_width:            u32,
	line_style:            u32,
	cap_style:             u32,
	join_style:            u32,
	fill_style:            u32,
	fill_rule:             u32,
	tile:                  pixmap_t,
	stipple:               pixmap_t,
	tile_stipple_x_origin: i32,
	tile_stipple_y_origin: i32,
	font:                  font_t,
	subwindow_mode:        u32,
	graphics_exposures:    b32,
	clip_x_origin:         i32,
	clip_y_origin:         i32,
	clip_mask:             pixmap_t,
	dash_offset:           u32,
	dashes:                u32,
	arc_mode:              u32,
}

create_gc_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cid:          gcontext_t,
	drawable:     drawable_t,
	value_mask:   u32,
}

change_gc_value_list_t :: struct{
	function:              u32,
	plane_mask:            u32,
	foreground:            u32,
	background:            u32,
	line_width:            u32,
	line_style:            u32,
	cap_style:             u32,
	join_style:            u32,
	fill_style:            u32,
	fill_rule:             u32,
	tile:                  pixmap_t,
	stipple:               pixmap_t,
	tile_stipple_x_origin: i32,
	tile_stipple_y_origin: i32,
	font:                  font_t,
	subwindow_mode:        u32,
	graphics_exposures:    b32,
	clip_x_origin:         i32,
	clip_y_origin:         i32,
	clip_mask:             pixmap_t,
	dash_offset:           u32,
	dashes:                u32,
	arc_mode:              u32,
}

change_gc_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	gc:           gcontext_t,
	value_mask:   u32,
}

copy_gc_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	src_gc:       gcontext_t,
	dst_gc:       gcontext_t,
	value_mask:   u32,
}

set_dashes_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	gc:           gcontext_t,
	dash_offset:  u16,
	dashes_len:   u16,
}

set_clip_rectangles_request_t :: struct{
	major_opcode:  u8,
	ordering:      u8,
	length:        u16,
	gc:            gcontext_t,
	clip_x_origin: i16,
	clip_y_origin: i16,
}

free_gc_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	gc:           gcontext_t,
}

clear_area_request_t :: struct{
	major_opcode: u8,
	exposures:    u8,
	length:       u16,
	window:       window_t,
	x:            i16,
	y:            i16,
	width:        u16,
	height:       u16,
}

copy_area_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	src_drawable: drawable_t,
	dst_drawable: drawable_t,
	gc:           gcontext_t,
	src_x:        i16,
	src_y:        i16,
	dst_x:        i16,
	dst_y:        i16,
	width:        u16,
	height:       u16,
}

copy_plane_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	src_drawable: drawable_t,
	dst_drawable: drawable_t,
	gc:           gcontext_t,
	src_x:        i16,
	src_y:        i16,
	dst_x:        i16,
	dst_y:        i16,
	width:        u16,
	height:       u16,
	bit_plane:    u32,
}

poly_point_request_t :: struct{
	major_opcode:    u8,
	coordinate_mode: u8,
	length:          u16,
	drawable:        drawable_t,
	gc:              gcontext_t,
}

poly_line_request_t :: struct{
	major_opcode:    u8,
	coordinate_mode: u8,
	length:          u16,
	drawable:        drawable_t,
	gc:              gcontext_t,
}

segment_t :: struct{
	x1: i16,
	y1: i16,
	x2: i16,
	y2: i16,
}

poly_segment_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	drawable:     drawable_t,
	gc:           gcontext_t,
}

poly_rectangle_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	drawable:     drawable_t,
	gc:           gcontext_t,
}

poly_arc_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	drawable:     drawable_t,
	gc:           gcontext_t,
}

fill_poly_request_t :: struct{
	major_opcode:    u8,
	pad0:            u8,
	length:          u16,
	drawable:        drawable_t,
	gc:              gcontext_t,
	shape:           u8,
	coordinate_mode: u8,
	pad1:            [2]u8,
}

poly_fill_rectangle_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	drawable:     drawable_t,
	gc:           gcontext_t,
}

poly_fill_arc_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	drawable:     drawable_t,
	gc:           gcontext_t,
}

put_image_request_t :: struct{
	major_opcode: u8,
	format:       u8,
	length:       u16,
	drawable:     drawable_t,
	gc:           gcontext_t,
	width:        u16,
	height:       u16,
	dst_x:        i16,
	dst_y:        i16,
	left_pad:     u8,
	depth:        u8,
	pad0:         [2]u8,
}

get_image_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_image_request_t :: struct{
	major_opcode: u8,
	format:       u8,
	length:       u16,
	drawable:     drawable_t,
	x:            i16,
	y:            i16,
	width:        u16,
	height:       u16,
	plane_mask:   u32,
}

get_image_reply_t :: struct{
	response_type: u8,
	depth:         u8,
	sequence:      u16,
	length:        u32,
	visual:        visualid_t,
	pad0:          [20]u8,
}

poly_text_8_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	drawable:     drawable_t,
	gc:           gcontext_t,
	x:            i16,
	y:            i16,
}

poly_text_16_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	drawable:     drawable_t,
	gc:           gcontext_t,
	x:            i16,
	y:            i16,
}

image_text_8_request_t :: struct{
	major_opcode: u8,
	string_len:   u8,
	length:       u16,
	drawable:     drawable_t,
	gc:           gcontext_t,
	x:            i16,
	y:            i16,
}

image_text_16_request_t :: struct{
	major_opcode: u8,
	string_len:   u8,
	length:       u16,
	drawable:     drawable_t,
	gc:           gcontext_t,
	x:            i16,
	y:            i16,
}

create_colormap_request_t :: struct{
	major_opcode: u8,
	alloc:        u8,
	length:       u16,
	mid:          colormap_t,
	window:       window_t,
	visual:       visualid_t,
}

free_colormap_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cmap:         colormap_t,
}

copy_colormap_and_free_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	mid:          colormap_t,
	src_cmap:     colormap_t,
}

install_colormap_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cmap:         colormap_t,
}

uninstall_colormap_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cmap:         colormap_t,
}

list_installed_colormaps_cookie_t :: struct{
	sequence: ctypes.uint,
}

list_installed_colormaps_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
}

list_installed_colormaps_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	cmaps_len:     u16,
	pad1:          [22]u8,
}

alloc_color_cookie_t :: struct{
	sequence: ctypes.uint,
}

alloc_color_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cmap:         colormap_t,
	red:          u16,
	green:        u16,
	blue:         u16,
	pad1:         [2]u8,
}

alloc_color_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	red:           u16,
	green:         u16,
	blue:          u16,
	pad1:          [2]u8,
	pixel:         u32,
}

alloc_named_color_cookie_t :: struct{
	sequence: ctypes.uint,
}

alloc_named_color_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cmap:         colormap_t,
	name_len:     u16,
	pad1:         [2]u8,
}

alloc_named_color_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pixel:         u32,
	exact_red:     u16,
	exact_green:   u16,
	exact_blue:    u16,
	visual_red:    u16,
	visual_green:  u16,
	visual_blue:   u16,
}

alloc_color_cells_cookie_t :: struct{
	sequence: ctypes.uint,
}

alloc_color_cells_request_t :: struct{
	major_opcode: u8,
	contiguous:   u8,
	length:       u16,
	cmap:         colormap_t,
	colors:       u16,
	planes:       u16,
}

alloc_color_cells_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pixels_len:    u16,
	masks_len:     u16,
	pad1:          [20]u8,
}

alloc_color_planes_cookie_t :: struct{
	sequence: ctypes.uint,
}

alloc_color_planes_request_t :: struct{
	major_opcode: u8,
	contiguous:   u8,
	length:       u16,
	cmap:         colormap_t,
	colors:       u16,
	reds:         u16,
	greens:       u16,
	blues:        u16,
}

alloc_color_planes_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pixels_len:    u16,
	pad1:          [2]u8,
	red_mask:      u32,
	green_mask:    u32,
	blue_mask:     u32,
	pad2:          [8]u8,
}

free_colors_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cmap:         colormap_t,
	plane_mask:   u32,
}

coloritem_t :: struct{
	pixel: u32,
	red:   u16,
	green: u16,
	blue:  u16,
	flags: u8,
	pad0:  u8,
}

store_colors_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cmap:         colormap_t,
}

store_named_color_request_t :: struct{
	major_opcode: u8,
	flags:        u8,
	length:       u16,
	cmap:         colormap_t,
	pixel:        u32,
	name_len:     u16,
	pad0:         [2]u8,
}

rgb_t :: struct{
	red:   u16,
	green: u16,
	blue:  u16,
	pad0:  [2]u8,
}

query_colors_cookie_t :: struct{
	sequence: ctypes.uint,
}

query_colors_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cmap:         colormap_t,
}

query_colors_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	colors_len:    u16,
	pad1:          [22]u8,
}

lookup_color_cookie_t :: struct{
	sequence: ctypes.uint,
}

lookup_color_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cmap:         colormap_t,
	name_len:     u16,
	pad1:         [2]u8,
}

lookup_color_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	exact_red:     u16,
	exact_green:   u16,
	exact_blue:    u16,
	visual_red:    u16,
	visual_green:  u16,
	visual_blue:   u16,
}

create_cursor_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cid:          cursor_t,
	source:       pixmap_t,
	mask:         pixmap_t,
	fore_red:     u16,
	fore_green:   u16,
	fore_blue:    u16,
	back_red:     u16,
	back_green:   u16,
	back_blue:    u16,
	x:            u16,
	y:            u16,
}

create_glyph_cursor_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cid:          cursor_t,
	source_font:  font_t,
	mask_font:    font_t,
	source_char:  u16,
	mask_char:    u16,
	fore_red:     u16,
	fore_green:   u16,
	fore_blue:    u16,
	back_red:     u16,
	back_green:   u16,
	back_blue:    u16,
}

free_cursor_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cursor:       cursor_t,
}

recolor_cursor_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	cursor:       cursor_t,
	fore_red:     u16,
	fore_green:   u16,
	fore_blue:    u16,
	back_red:     u16,
	back_green:   u16,
	back_blue:    u16,
}

query_best_size_cookie_t :: struct{
	sequence: ctypes.uint,
}

query_best_size_request_t :: struct{
	major_opcode: u8,
	_class:       u8,
	length:       u16,
	drawable:     drawable_t,
	width:        u16,
	height:       u16,
}

query_best_size_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	width:         u16,
	height:        u16,
}

query_extension_cookie_t :: struct{
	sequence: ctypes.uint,
}

query_extension_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	name_len:     u16,
	pad1:         [2]u8,
}

query_extension_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	present:       u8,
	major_opcode:  u8,
	first_event:   u8,
	first_error:   u8,
}

list_extensions_cookie_t :: struct{
	sequence: ctypes.uint,
}

list_extensions_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
}

list_extensions_reply_t :: struct{
	response_type: u8,
	names_len:     u8,
	sequence:      u16,
	length:        u32,
	pad0:          [24]u8,
}

change_keyboard_mapping_request_t :: struct{
	major_opcode:        u8,
	keycode_count:       u8,
	length:              u16,
	first_keycode:       keycode_t,
	keysyms_per_keycode: u8,
	pad0:                [2]u8,
}

get_keyboard_mapping_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_keyboard_mapping_request_t :: struct{
	major_opcode:  u8,
	pad0:          u8,
	length:        u16,
	first_keycode: keycode_t,
	count:         u8,
}

get_keyboard_mapping_reply_t :: struct{
	response_type:       u8,
	keysyms_per_keycode: u8,
	sequence:            u16,
	length:              u32,
	pad0:                [24]u8,
}

change_keyboard_control_value_list_t :: struct{
	key_click_percent: i32,
	bell_percent:      i32,
	bell_pitch:        i32,
	bell_duration:     i32,
	led:               u32,
	led_mode:          u32,
	key:               keycode32_t,
	auto_repeat_mode:  u32,
}

change_keyboard_control_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	value_mask:   u32,
}

get_keyboard_control_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_keyboard_control_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
}

get_keyboard_control_reply_t :: struct{
	response_type:      u8,
	global_auto_repeat: u8,
	sequence:           u16,
	length:             u32,
	led_mask:           u32,
	key_click_percent:  u8,
	bell_percent:       u8,
	bell_pitch:         u16,
	bell_duration:      u16,
	pad0:               [2]u8,
	auto_repeats:       [32]u8,
}

bell_request_t :: struct{
	major_opcode: u8,
	percent:      i8,
	length:       u16,
}

change_pointer_control_request_t :: struct{
	major_opcode:             u8,
	pad0:                     u8,
	length:                   u16,
	acceleration_numerator:   i16,
	acceleration_denominator: i16,
	threshold:                i16,
	do_acceleration:          u8,
	do_threshold:             u8,
}

get_pointer_control_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_pointer_control_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
}

get_pointer_control_reply_t :: struct{
	response_type:            u8,
	pad0:                     u8,
	sequence:                 u16,
	length:                   u32,
	acceleration_numerator:   u16,
	acceleration_denominator: u16,
	threshold:                u16,
	pad1:                     [18]u8,
}

set_screen_saver_request_t :: struct{
	major_opcode:    u8,
	pad0:            u8,
	length:          u16,
	timeout:         i16,
	interval:        i16,
	prefer_blanking: u8,
	allow_exposures: u8,
}

get_screen_saver_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_screen_saver_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
}

get_screen_saver_reply_t :: struct{
	response_type:   u8,
	pad0:            u8,
	sequence:        u16,
	length:          u32,
	timeout:         u16,
	interval:        u16,
	prefer_blanking: u8,
	allow_exposures: u8,
	pad1:            [18]u8,
}

change_hosts_request_t :: struct{
	major_opcode: u8,
	mode:         u8,
	length:       u16,
	family:       u8,
	pad0:         u8,
	address_len:  u16,
}

host_t :: struct{
	family:      u8,
	pad0:        u8,
	address_len: u16,
}

list_hosts_cookie_t :: struct{
	sequence: ctypes.uint,
}

list_hosts_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
}

list_hosts_reply_t :: struct{
	response_type: u8,
	mode:          u8,
	sequence:      u16,
	length:        u32,
	hosts_len:     u16,
	pad0:          [22]u8,
}

set_access_control_request_t :: struct{
	major_opcode: u8,
	mode:         u8,
	length:       u16,
}

set_close_down_mode_request_t :: struct{
	major_opcode: u8,
	mode:         u8,
	length:       u16,
}

kill_client_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	resource:     u32,
}

rotate_properties_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
	window:       window_t,
	atoms_len:    u16,
	delta:        i16,
}

force_screen_saver_request_t :: struct{
	major_opcode: u8,
	mode:         u8,
	length:       u16,
}

set_pointer_mapping_cookie_t :: struct{
	sequence: ctypes.uint,
}

set_pointer_mapping_request_t :: struct{
	major_opcode: u8,
	map_len:      u8,
	length:       u16,
}

set_pointer_mapping_reply_t :: struct{
	response_type: u8,
	status:        u8,
	sequence:      u16,
	length:        u32,
}

get_pointer_mapping_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_pointer_mapping_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
}

get_pointer_mapping_reply_t :: struct{
	response_type: u8,
	map_len:       u8,
	sequence:      u16,
	length:        u32,
	pad0:          [24]u8,
}

set_modifier_mapping_cookie_t :: struct{
	sequence: ctypes.uint,
}

set_modifier_mapping_request_t :: struct{
	major_opcode:          u8,
	keycodes_per_modifier: u8,
	length:                u16,
}

set_modifier_mapping_reply_t :: struct{
	response_type: u8,
	status:        u8,
	sequence:      u16,
	length:        u32,
}

get_modifier_mapping_cookie_t :: struct{
	sequence: ctypes.uint,
}

get_modifier_mapping_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
}

get_modifier_mapping_reply_t :: struct{
	response_type:         u8,
	keycodes_per_modifier: u8,
	sequence:              u16,
	length:                u32,
	pad0:                  [24]u8,
}

no_operation_request_t :: struct{
	major_opcode: u8,
	pad0:         u8,
	length:       u16,
}

selinux_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_query_version_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	client_major: u8,
	client_minor: u8,
}

selinux_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	server_major:  u16,
	server_minor:  u16,
}

selinux_set_device_create_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_len:  u32,
}

selinux_get_device_create_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_get_device_create_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

selinux_get_device_create_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_len:   u32,
	pad1:          [20]u8,
}

selinux_set_device_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	device:       u32,
	context_len:  u32,
}

selinux_get_device_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_get_device_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	device:       u32,
}

selinux_get_device_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_len:   u32,
	pad1:          [20]u8,
}

selinux_set_window_create_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_len:  u32,
}

selinux_get_window_create_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_get_window_create_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

selinux_get_window_create_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_len:   u32,
	pad1:          [20]u8,
}

selinux_get_window_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_get_window_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

selinux_get_window_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_len:   u32,
	pad1:          [20]u8,
}

selinux_list_item_t :: struct{
	name:               atom_t,
	object_context_len: u32,
	data_context_len:   u32,
}

selinux_set_property_create_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_len:  u32,
}

selinux_get_property_create_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_get_property_create_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

selinux_get_property_create_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_len:   u32,
	pad1:          [20]u8,
}

selinux_set_property_use_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_len:  u32,
}

selinux_get_property_use_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_get_property_use_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

selinux_get_property_use_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_len:   u32,
	pad1:          [20]u8,
}

selinux_get_property_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_get_property_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	property:     atom_t,
}

selinux_get_property_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_len:   u32,
	pad1:          [20]u8,
}

selinux_get_property_data_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_get_property_data_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	property:     atom_t,
}

selinux_get_property_data_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_len:   u32,
	pad1:          [20]u8,
}

selinux_list_properties_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_list_properties_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

selinux_list_properties_reply_t :: struct{
	response_type:  u8,
	pad0:           u8,
	sequence:       u16,
	length:         u32,
	properties_len: u32,
	pad1:           [20]u8,
}

selinux_set_selection_create_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_len:  u32,
}

selinux_get_selection_create_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_get_selection_create_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

selinux_get_selection_create_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_len:   u32,
	pad1:          [20]u8,
}

selinux_set_selection_use_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_len:  u32,
}

selinux_get_selection_use_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_get_selection_use_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

selinux_get_selection_use_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_len:   u32,
	pad1:          [20]u8,
}

selinux_get_selection_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_get_selection_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	selection:    atom_t,
}

selinux_get_selection_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_len:   u32,
	pad1:          [20]u8,
}

selinux_get_selection_data_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_get_selection_data_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	selection:    atom_t,
}

selinux_get_selection_data_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_len:   u32,
	pad1:          [20]u8,
}

selinux_list_selections_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_list_selections_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

selinux_list_selections_reply_t :: struct{
	response_type:  u8,
	pad0:           u8,
	sequence:       u16,
	length:         u32,
	selections_len: u32,
	pad1:           [20]u8,
}

selinux_get_client_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

selinux_get_client_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	resource:     u32,
}

selinux_get_client_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	context_len:   u32,
	pad1:          [20]u8,
}

test_get_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

test_get_version_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	major_version: u8,
	pad0:          u8,
	minor_version: u16,
}

test_get_version_reply_t :: struct{
	response_type: u8,
	major_version: u8,
	sequence:      u16,
	length:        u32,
	minor_version: u16,
}

test_compare_cursor_cookie_t :: struct{
	sequence: ctypes.uint,
}

test_compare_cursor_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
	cursor:       cursor_t,
}

test_compare_cursor_reply_t :: struct{
	response_type: u8,
	same:          u8,
	sequence:      u16,
	length:        u32,
}

test_fake_input_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	type:         u8,
	detail:       u8,
	pad0:         [2]u8,
	time:         u32,
	root:         window_t,
	pad1:         [8]u8,
	rootX:        i16,
	rootY:        i16,
	pad2:         [7]u8,
	deviceid:     u8,
}

test_grab_control_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	impervious:   u8,
	pad0:         [3]u8,
}

xv_rational_t :: struct{
	numerator:   i32,
	denominator: i32,
}

xv_format_t :: struct{
	visual: visualid_t,
	depth:  u8,
	pad0:   [3]u8,
}

xv_adaptor_info_t :: struct{
	base_id:     xv_port_t,
	name_size:   u16,
	num_ports:   u16,
	num_formats: u16,
	type:        u8,
	pad0:        u8,
}

xv_encoding_info_t :: struct{
	encoding:  xv_encoding_t,
	name_size: u16,
	width:     u16,
	height:    u16,
	pad0:      [2]u8,
	rate:      xv_rational_t,
}

xv_image_t :: struct{
	id:         u32,
	width:      u16,
	height:     u16,
	data_size:  u32,
	num_planes: u32,
}

xv_attribute_info_t :: struct{
	flags: u32,
	min:   i32,
	max:   i32,
	size:  u32,
}

xv_image_format_info_t :: struct{
	id:              u32,
	type:            u8,
	byte_order:      u8,
	pad0:            [2]u8,
	guid:            [16]u8,
	bpp:             u8,
	num_planes:      u8,
	pad1:            [2]u8,
	depth:           u8,
	pad2:            [3]u8,
	red_mask:        u32,
	green_mask:      u32,
	blue_mask:       u32,
	format:          u8,
	pad3:            [3]u8,
	y_sample_bits:   u32,
	u_sample_bits:   u32,
	v_sample_bits:   u32,
	vhorz_y_period:  u32,
	vhorz_u_period:  u32,
	vhorz_v_period:  u32,
	vvert_y_period:  u32,
	vvert_u_period:  u32,
	vvert_v_period:  u32,
	vcomp_order:     [32]u8,
	vscanline_order: u8,
	pad4:            [11]u8,
}

xv_bad_port_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

xv_bad_encoding_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

xv_bad_control_error_t :: struct{
	response_type: u8,
	error_code:    u8,
	sequence:      u16,
	bad_value:     u32,
	minor_opcode:  u16,
	major_opcode:  u8,
}

xv_video_notify_event_t :: struct{
	response_type: u8,
	reason:        u8,
	sequence:      u16,
	time:          timestamp_t,
	drawable:      drawable_t,
	port:          xv_port_t,
}

xv_port_notify_event_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	time:          timestamp_t,
	port:          xv_port_t,
	attribute:     atom_t,
	value:         i32,
}

xv_query_extension_cookie_t :: struct{
	sequence: ctypes.uint,
}

xv_query_extension_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

xv_query_extension_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major:         u16,
	minor:         u16,
}

xv_query_adaptors_cookie_t :: struct{
	sequence: ctypes.uint,
}

xv_query_adaptors_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	window:       window_t,
}

xv_query_adaptors_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_adaptors:  u16,
	pad1:          [22]u8,
}

xv_query_encodings_cookie_t :: struct{
	sequence: ctypes.uint,
}

xv_query_encodings_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
}

xv_query_encodings_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_encodings: u16,
	pad1:          [22]u8,
}

xv_grab_port_cookie_t :: struct{
	sequence: ctypes.uint,
}

xv_grab_port_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
	time:         timestamp_t,
}

xv_grab_port_reply_t :: struct{
	response_type: u8,
	result:        u8,
	sequence:      u16,
	length:        u32,
}

xv_ungrab_port_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
	time:         timestamp_t,
}

xv_put_video_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
	drawable:     drawable_t,
	gc:           gcontext_t,
	vid_x:        i16,
	vid_y:        i16,
	vid_w:        u16,
	vid_h:        u16,
	drw_x:        i16,
	drw_y:        i16,
	drw_w:        u16,
	drw_h:        u16,
}

xv_put_still_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
	drawable:     drawable_t,
	gc:           gcontext_t,
	vid_x:        i16,
	vid_y:        i16,
	vid_w:        u16,
	vid_h:        u16,
	drw_x:        i16,
	drw_y:        i16,
	drw_w:        u16,
	drw_h:        u16,
}

xv_get_video_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
	drawable:     drawable_t,
	gc:           gcontext_t,
	vid_x:        i16,
	vid_y:        i16,
	vid_w:        u16,
	vid_h:        u16,
	drw_x:        i16,
	drw_y:        i16,
	drw_w:        u16,
	drw_h:        u16,
}

xv_get_still_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
	drawable:     drawable_t,
	gc:           gcontext_t,
	vid_x:        i16,
	vid_y:        i16,
	vid_w:        u16,
	vid_h:        u16,
	drw_x:        i16,
	drw_y:        i16,
	drw_w:        u16,
	drw_h:        u16,
}

xv_stop_video_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
	drawable:     drawable_t,
}

xv_select_video_notify_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	drawable:     drawable_t,
	onoff:        u8,
	pad0:         [3]u8,
}

xv_select_port_notify_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
	onoff:        u8,
	pad0:         [3]u8,
}

xv_query_best_size_cookie_t :: struct{
	sequence: ctypes.uint,
}

xv_query_best_size_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
	vid_w:        u16,
	vid_h:        u16,
	drw_w:        u16,
	drw_h:        u16,
	motion:       u8,
	pad0:         [3]u8,
}

xv_query_best_size_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	actual_width:  u16,
	actual_height: u16,
}

xv_set_port_attribute_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
	attribute:    atom_t,
	value:        i32,
}

xv_get_port_attribute_cookie_t :: struct{
	sequence: ctypes.uint,
}

xv_get_port_attribute_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
	attribute:    atom_t,
}

xv_get_port_attribute_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	value:         i32,
}

xv_query_port_attributes_cookie_t :: struct{
	sequence: ctypes.uint,
}

xv_query_port_attributes_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
}

xv_query_port_attributes_reply_t :: struct{
	response_type:  u8,
	pad0:           u8,
	sequence:       u16,
	length:         u32,
	num_attributes: u32,
	text_size:      u32,
	pad1:           [16]u8,
}

xv_list_image_formats_cookie_t :: struct{
	sequence: ctypes.uint,
}

xv_list_image_formats_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
}

xv_list_image_formats_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_formats:   u32,
	pad1:          [20]u8,
}

xv_query_image_attributes_cookie_t :: struct{
	sequence: ctypes.uint,
}

xv_query_image_attributes_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
	id:           u32,
	width:        u16,
	height:       u16,
}

xv_query_image_attributes_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num_planes:    u32,
	data_size:     u32,
	width:         u16,
	height:        u16,
	pad1:          [12]u8,
}

xv_put_image_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
	drawable:     drawable_t,
	gc:           gcontext_t,
	id:           u32,
	src_x:        i16,
	src_y:        i16,
	src_w:        u16,
	src_h:        u16,
	drw_x:        i16,
	drw_y:        i16,
	drw_w:        u16,
	drw_h:        u16,
	width:        u16,
	height:       u16,
}

xv_shm_put_image_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port:         xv_port_t,
	drawable:     drawable_t,
	gc:           gcontext_t,
	shmseg:       shm_seg_t,
	id:           u32,
	offset:       u32,
	src_x:        i16,
	src_y:        i16,
	src_w:        u16,
	src_h:        u16,
	drw_x:        i16,
	drw_y:        i16,
	drw_w:        u16,
	drw_h:        u16,
	width:        u16,
	height:       u16,
	send_event:   u8,
	pad0:         [3]u8,
}

xvmc_surface_info_t :: struct{
	id:                    xvmc_surface_t,
	chroma_format:         u16,
	pad0:                  u16,
	max_width:             u16,
	max_height:            u16,
	subpicture_max_width:  u16,
	subpicture_max_height: u16,
	mc_type:               u32,
	flags:                 u32,
}

xvmc_query_version_cookie_t :: struct{
	sequence: ctypes.uint,
}

xvmc_query_version_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
}

xvmc_query_version_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	major:         u32,
	minor:         u32,
}

xvmc_list_surface_types_cookie_t :: struct{
	sequence: ctypes.uint,
}

xvmc_list_surface_types_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port_id:      xv_port_t,
}

xvmc_list_surface_types_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num:           u32,
	pad1:          [20]u8,
}

xvmc_create_context_cookie_t :: struct{
	sequence: ctypes.uint,
}

xvmc_create_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_id:   xvmc_context_t,
	port_id:      xv_port_t,
	surface_id:   xvmc_surface_t,
	width:        u16,
	height:       u16,
	flags:        u32,
}

xvmc_create_context_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	width_actual:  u16,
	height_actual: u16,
	flags_return:  u32,
	pad1:          [20]u8,
}

xvmc_destroy_context_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	context_id:   xvmc_context_t,
}

xvmc_create_surface_cookie_t :: struct{
	sequence: ctypes.uint,
}

xvmc_create_surface_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	surface_id:   xvmc_surface_t,
	context_id:   xvmc_context_t,
}

xvmc_create_surface_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	pad1:          [24]u8,
}

xvmc_destroy_surface_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	surface_id:   xvmc_surface_t,
}

xvmc_create_subpicture_cookie_t :: struct{
	sequence: ctypes.uint,
}

xvmc_create_subpicture_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	subpicture_id: xvmc_subpicture_t,
	context_:      xvmc_context_t,
	xvimage_id:    u32,
	width:         u16,
	height:        u16,
}

xvmc_create_subpicture_reply_t :: struct{
	response_type:       u8,
	pad0:                u8,
	sequence:            u16,
	length:              u32,
	width_actual:        u16,
	height_actual:       u16,
	num_palette_entries: u16,
	entry_bytes:         u16,
	component_order:     [4]u8,
	pad1:                [12]u8,
}

xvmc_destroy_subpicture_request_t :: struct{
	major_opcode:  u8,
	minor_opcode:  u8,
	length:        u16,
	subpicture_id: xvmc_subpicture_t,
}

xvmc_list_subpicture_types_cookie_t :: struct{
	sequence: ctypes.uint,
}

xvmc_list_subpicture_types_request_t :: struct{
	major_opcode: u8,
	minor_opcode: u8,
	length:       u16,
	port_id:      xv_port_t,
	surface_id:   xvmc_surface_t,
}

xvmc_list_subpicture_types_reply_t :: struct{
	response_type: u8,
	pad0:          u8,
	sequence:      u16,
	length:        u32,
	num:           u32,
	pad1:          [20]u8,
}

